#include "L2Server.h"

#include "Shared.h"


//-----------------------------------------------------------
//NPC Info Polymorf 2013-02-21
//-----------------------------------------------------------

//pUser+1010 - polymorphed

//1			writeD(_cha.getObjectId());
//2			writeD(_cha.getPoly().getPolyId()+1000000);  // npctype id
//3			writeD(_cha.getKarma() > 0 ? 1 : 0); 
//4			writeD(_x);
//5			writeD(_y);
//6			writeD(_z);
//7			writeD(_heading);
//8			writeD(0x00);
//9			writeD(_mAtkSpd);
//10			writeD(_pAtkSpd);
//11			writeD(_runSpd);
//12			writeD(_walkSpd);
//13			writeD(_swimRunSpd/*0x32*/);  // swimspeed
//14			writeD(_swimWalkSpd/*0x32*/);  // swimspeed
//15			writeD(_flRunSpd);
//16			writeD(_flWalkSpd);
//17			writeD(_flyRunSpd);
//18			writeD(_flyWalkSpd);
//19			writeF(_cha.getMovementSpeedMultiplier());
//20			writeF(_cha.getAttackSpeedMultiplier());
//21			writeF(NpcTable.getInstance().getTemplate(_cha.getPoly().getPolyId()).collisionRadius);
//22			writeF(NpcTable.getInstance().getTemplate(_cha.getPoly().getPolyId()).collisionHeight);
//23			writeD(_inv.getPaperdollItemId(Inventory.PAPERDOLL_RHAND)); // right hand weapon
//24			writeD(0);
//25			writeD(_inv.getPaperdollItemId(Inventory.PAPERDOLL_LHAND)); // left hand weapon
//1			writeC(1);	// name above char 1=true ... ??
//2			writeC(_cha.isRunning() ? 1 : 0);
//3			writeC(_cha.isInCombat() ? 1 : 0);
//4			writeC(_cha.isAlikeDead() ? 1 : 0);
//5			writeC(_cha.getInvisible()); // invisible ?? 0=false  1=true   2=summoned (only works if model has a summon animation)
//31		writeS(_cha.getName());

/*
C2 and up chronicles

			writeS(_cha.getTitle()); //c2 begin
			writeD(0); //c2
			writeD(0); //c2
			writeD(0000);  //c2 hmm karma ??

			writeD(_cha.getAbnormalEffect());  // C2
			writeD(_activeChar.getClanId()); //clan id
			writeD(_activeChar.getClanCrestId()); //crest id
			writeD(0);  // C2
			writeD(0);  // C2
			writeC(0);  // C2


			writeC(0x00);  // C3  team circle 1-blue, 2-red
			writeF(template.fCollisionRadius);
			writeF(template.fCollisionHeight);
			writeD(0x00);  // C4
			writeD(0x00);  // C6
			writeD(0x00);
			writeD(0x00);
			writeC(0x01);
			writeC(0x01);
			writeD(0x00);
*/

//new format: cddddddddddddddddddffffdddcccccSSddddddddccffddddccd


//1'st
//hook: 004FF5F7 + 0 nop


//.text:004FF5F7                 push    offset EMPTY_WCHAR_5B563C //name
//.text:004FF5FC                 push    0
//.......................
//.text:004FF6C4                 push    22h
//.text:004FF6C6                 push    offset aCddddddddddd_0 ; "cddddddddddddddddddffffdddcccccS"


//4FF5F7 + 0 nop  [21*4 to esp]
__declspec(naked) void PolymorphNPCInfo_fix1()
{

	__asm {

			push 0
			push 1
			push 1
			push 0
			push 0
			push 0 //c6
			push 0 //c4

			push 0
			push 0 //collision radius
			push 0
			push 0 //collision heigh

			push 0 //c3 team circle

			push 0 //c
			push 0
			push 0  //clan crest ID
			push 0  //clan ID
		mov		edx,[ebx][00000AB0h]
		push	edx	//abnormal effect c2
			//push 0	//abnormal effect

			push 0 //karma?
			push 0
			push 0
			push 5B563Ch //c2 title

//extend
			push 5B563Ch //emptywarchar! //name (c1 last)


mov	edx,[ebp][-34h]
			push 4FF5FCh
			retn

	}
}


//2'nd
//hook: 004FFD7F + 0 nop

//.text:004FFD7F                 push    offset EMPTY_WCHAR_5B563C //name
//.text:004FFD84                 push    1
//..............
//.text:004FFE57                 push    22h
//.text:004FFE59                 push    offset aCddddddddddd_0 ; "cddddddddddddddddddffffdddcccccS"

//4FFD7F + 0 nop  [21*4 to esp]
__declspec(naked) void PolymorphNPCInfo_fix2()
{

	__asm {

			push 0
			push 1
			push 1
			push 0
			push 0
			push 0 //c6
			push 0 //c4

			push 0
			push 0 //collision radius
			push 0
			push 0 //collision heigh

			push 0 //c3 team circle

			push 0 //c
			push 0
			push 0  //clan crest ID
			push 0  //clan ID
		mov		edx,[ebx][00000AB0h]
		push	edx	//abnormal effect c2
			//push 0	//abnormal effect

			push 0 //karma?
			push 0
			push 0
			push 5B563Ch //c2 title

//extend
			push 5B563Ch //name (c1 last)

xor edx,edx
			push 4FFD84h
			retn

	}
}



//-----------------------------------------------------------
//end of NPC Info Polymorf
//-----------------------------------------------------------



/*
BuyListSeed:


protected final void writeImpl() //chronicle3
{
writeC(0xe8); 

writeD(_money); // current money
writeD(_listId); // list id

writeH(_list.size()); // list length

for (L2ItemInstance item : _list)
{
writeH(item.getItem().getType1()); // item->type1
writeD(item.getObjectId()); // objectId
writeD(item.getItemId()); // item id
writeD(item.getCount()); // item count
writeH(item.getItem().getType2()); // item->type2
writeH(0x00); // unknown

writeD(0x03); // price
}
}

SellListProcure:



protected final void writeImpl() //chronicle 3
{
writeC(0xE9);
writeD(_money); // money
writeD(0); // lease ?
writeH(_sellList.size()); // list size

for(L2ItemInstance item : _sellList.keySet())
{
writeH(item.getItem().getType1());
writeD(item.getObjectId());
writeD(item.getItemId());
writeD(_sellList.get(item)); // count
writeH(item.getItem().getType2());
writeH(0); // unknown
writeD(0); // price, u shouldnt get any adena for crops, only raw materials
}
}
*/



//------------------------------------------
// Character selection packet

/*
		writeS(_cha.getName());
		writeD(_cha.getCharId()); // ??
		writeS(_cha.getTitle());
		writeD(_sessionId);
		writeD(_cha.getClanId());
		writeD(0x00);  //??
		writeD(_cha.getSex());
		writeD(_cha.getRace().ordinal());
		writeD(_cha.getClassId().getId());
		writeD(0x01); // active ??
		writeD(_cha.getX());	
		writeD(_cha.getY());	
		writeD(_cha.getZ());	

		writeF(_cha.getCurrentHp());  
		writeF(_cha.getCurrentMp());  
		writeD(_cha.getSp());
		writeD(_cha.getExp());
		writeD(_cha.getLevel());
		writeD(0x0);	//?
		writeD(0x0);	//?
		writeD(_cha.getINT()); 
		writeD(_cha.getSTR()); 
		writeD(_cha.getCON()); 
		writeD(_cha.getMEN()); 
		writeD(_cha.getDEX()); 
		writeD(_cha.getWIT()); 
        for (int i=0; i<30; i++)
        {
            writeD(0x00);
        }
//        writeD(0); //c3
//        writeD(0); //c3
//        writeD(0); //c3

        if (getClient().getRevision() >= 528)
        {
            writeD(0x00);       //c3  work
            writeD(0x00);       //c3  work
            
        }
        else if (getClient().getRevision() > 481)
        {
            writeD(0);  //these are needed for rev483+
            writeD(0);
            writeD(0);
            writeD(0);
        }
        // extra info
        writeD(GameTimeController.getInstance().getGameTime());	// in-game time 

        if (getClient().getRevision() >= 528)
        {
            writeD(0x00);   //  
            
            writeD(0x00);       //c3 
            
            writeD(0x00);       //c3 InspectorBin
            writeD(0x00);       //c3 
            writeD(0x00);       //c3 
            writeD(0x00);       //c3 
            
            writeD(0x00);       //c3 InspectorBin for 528 client
            writeD(0x00);       //c3 
            writeD(0x00);       //c3 
            writeD(0x00);       //c3 
        }
        if (getClient().getRevision() >= 553)
        {
            writeD(0x00);       //c3 
            writeD(0x00);       //c3 
            writeD(0x00);       //c3 
            writeD(0x00);       //c3 
            writeD(0x00);       //c3 
        }



*/



//468c41 + 1 nop
__declspec(naked) void CharacterSelection_c2fix()
{

	__asm {



	mov     edx, [ebp-4Ch]




	push 0 //c3
	push 0 //c3
	push edx //c2-485 time
	push 0 //c3 or c2 481 (//485 not crashing	 if time)
	push 0 //c3 or c2 481  (//485 not crashing	 if time)


	push edx //fix for c3 = c3TIME  //or c2 481


	push 0 //c3 or c2 481 //485 not crashing	if time


		


	cmp [eax+01624h],478
	jg done

	push edx //c3 or c2 481  c2-478 TIME 485 is crashing there if not 0
	jmp short finish

done:
	push 0 //c3 or c2 481 //night at start for 478 protocols
finish:



//original C2
		//push edx
		 push   0
		 push 468c47h
		 retn

	
	}
}




//4fB19d + 3nop
__declspec(naked) void SetupGaugeC2Fix()
{
	__asm {

		push edi //c2 time
		push edi //time
		push 2 //color
		push 085h //opcode c1 (c2 = 6d)

		push	4fb1a5h
		retn
		}
}


//----------------------
//C2 GMuserInfo
//----------------------



//4fe862+2nop
__declspec(naked) void GMUserC2FixA()
{
	__asm {

		pop		ecx //c3 hair slot
		push	edx
		mov		edx,[ebp][-00000164h]


		push	4fe869h	
		retn
		}
}


//4fe8d1 + 2nop
__declspec(naked) void GMUserC2FixB()
{
	__asm {

		pop		edx //c3 hair
		mov		edx,[ebp][-00000124h]
		push	ecx
		mov		ecx,[ebp][-00000128h]

		push	4fe8d8h
		retn
		}
}

////////////////////
// user info
///////////////////




//const int USER_LOCATION__CHEST = -0x00000170;
//const int USER_LOCATION__GLOVES = -0x00000174;
//const int USER_LOCATION__BOOTS = -0x00000168;
//const int USER_LOCATION__HOSE = -0x0000016C;

////////////////
//civil dress
////////////////
/*
__declspec(naked) void UserInfoPacketC2_Civil() //not working yet
{

	__asm
	{

			cmp [ebp][-00000198h],  9030  
			jne civil_1
			mov [ebp][-00000170h], 460 //chest
			mov [ebp][-0000016Ch], 460 //hose
			mov [ebp][-00000168h], 2444 //boots
			mov [ebp][-00000174h], 2473 //gloves
			jmp	short done
civil_1:
			cmp [ebp][-00000170h],  9031  
			jne civil_2
			mov [ebp][-00000170h], 2408 //chest
			mov [ebp][-0000016ch], 2408 //hose
			mov [ebp][-00000168h], 2440 //boots
			mov [ebp][-00000174h], 2479 //gloves
civil_2:
			cmp [ebp][-00000170h],  9032  
			jne civil_3
			mov [ebp][-00000170h], 2407 //chest
			mov [ebp][-0000016ch], 2407 //hose
			mov [ebp][-00000168h], 563 //boots
			mov [ebp][-00000174h], 2472 //gloves
civil_3:
			cmp [ebp][-00000170h],  9033  
			jne civil_4
			mov [ebp][-00000170h], 459 //chest
			mov [ebp][-0000016ch], 459 //hose
			mov [ebp][-00000168h], 2442 //boots
			mov [ebp][-00000174h], 2474 //gloves
civil_4:
			cmp [ebp][-00000170h],  9034  
			jne civil_5
			mov [ebp][-00000170h], 454 //chest
			mov [ebp][-0000016ch], 454 //hose
			mov [ebp][-00000168h], 591 //boots
			mov [ebp][-00000174h], 609 //gloves
civil_5:
			cmp [ebp][-00000170h],  9035  
			jne civil_6
			mov [ebp][-00000170h], 359 //chest
			mov [ebp][-0000016ch], 359 //hose
			mov [ebp][-00000168h], 557 //boots
			mov [ebp][-00000174h], 613 //gloves
civil_6:
			cmp [ebp][-00000170h],  9036  
			jne civil_7
			mov [ebp][-00000170h], 2409 //chest
			mov [ebp][-0000016ch], 2409 //hose
			mov [ebp][-00000168h], 583 //boots
			mov [ebp][-00000174h], 2482 //gloves
civil_7:
done:

		ret
	}

}

*/


//B grade textures fix, 2011-08
__declspec(naked) void UserInfoPacketC2_BGrade()
{

	__asm
	{

			cmp [ebp][-00000170h],  2390  //avadon leather mail
			je avadon_leather_mail_g

			cmp [ebp][-00000170h],  2406  //avadon robe
			je avadon_robe_g

			cmp [ebp][-00000170h],  2392  //doom leather mail
			je doom_leather_mail_g

			cmp [ebp][-00000170h],  2399  //doom tunic
			je doom_robe_g

			cmp [ebp][-00000170h],  2391  //bwolf leather mail
			je bwolf_leather_mail_g

			cmp [ebp][-00000170h],  2398  //bwolf tunic
			je bwolf_robe_g


			cmp [ebp][-00000170h],  2384  //zubei leather shirt
			je zubei_leather_mail_g

			cmp [ebp][-00000170h],  2397  //zubei tunic
			je zubei_robe_g


		//	call UserInfoPacketC2_Civil

			jmp short done
//////////////////
//avadon
/////////////////
avadon_leather_mail_g:
			cmp [ebp][-00000174h],  2464 //avadon gloves
			jne avadon_leather_mail_b
			mov [ebp][-00000174h],  2466 //avadon light model

			jmp short avadon_leather_mail_b

avadon_robe_g:
			cmp [ebp][-00000174h],  2464 //avadon gloves
			jne avadon_robe_b
			mov [ebp][-00000174h],  2468 //avadon robe model

			jmp short avadon_robe_b

avadon_leather_mail_b:
			cmp [ebp][-00000168h],  600 //avadon boots
			jne done
			mov [ebp][-00000168h],  578 //avadon light model

			jmp short done

avadon_robe_b:
			cmp [ebp][-00000168h],  600 //avadon boots
			jne done
			mov [ebp][-00000168h],  603 //avadon robe model

			jmp short done
///////////////
//doom
//////////////
doom_leather_mail_g:
			cmp [ebp][-00000174h],  2475 //doom gloves
			jne doom_leather_mail_b
			mov [ebp][-00000174h],  2480 //doom light model

			jmp short doom_leather_mail_b

doom_robe_g:
			cmp [ebp][-00000174h],  2475 //doom gloves
			jne doom_robe_b
			mov [ebp][-00000174h],  2481 //doom robe model

			jmp short doom_robe_b

doom_leather_mail_b:
			cmp [ebp][-00000168h],  601 //doom boots
			jne done
			mov [ebp][-00000168h],  588 //doom light model

			jmp short done

doom_robe_b:
			cmp [ebp][-00000168h],  601 //doom boots
			jne done
			mov [ebp][-00000168h],  590 //doom robe model

			jmp short done


///////////////
//blue wolf
//////////////
bwolf_leather_mail_g:
			cmp [ebp][-00000174h],  2487 //bwolf gloves
			jne bwolf_leather_mail_b
			mov [ebp][-00000174h],  2485 //bwolf light model

			jmp short bwolf_leather_mail_b

bwolf_robe_g:
			cmp [ebp][-00000174h],  2487 //bwolf gloves
			jne bwolf_robe_b
			mov [ebp][-00000174h],  2486 //bwolf robe model

			jmp short bwolf_robe_b

bwolf_leather_mail_b:
			cmp [ebp][-00000168h],  568 //2439 //bwolf boots
			jne done
			mov [ebp][-00000168h],  564 //bwolf light model

			jmp short done

bwolf_robe_b:
			cmp [ebp][-00000168h],  568 //2439 //bwolf boots
			jne done
			mov [ebp][-00000168h],  582 //bwolf robe model

			jmp short done

///////////////
//zubei 
//////////////
zubei_leather_mail_g:
			cmp [ebp][-00000174h],  2476 //612 //zubei gloves
			jne zubei_leather_mail_b
			mov [ebp][-00000174h],  2465 //zubei light model

			jmp short zubei_leather_mail_b

zubei_robe_g:
			cmp [ebp][-00000174h],  2476 //612 //zubei gloves
			jne zubei_robe_b
			mov [ebp][-00000174h],  2467 //zubei robe model

			jmp short zubei_robe_b

zubei_leather_mail_b:
			cmp [ebp][-00000168h],  554 //zubei boots
			jne done
			mov [ebp][-00000168h],  572 //zubei light model

			jmp short done

zubei_robe_b:
			cmp [ebp][-00000168h],  554 //zubei boots
			jne done
			mov [ebp][-00000168h],  595 //zubei robe model

			jmp short done



done:
			ret


	}

}





//format 4fe9c2   06036f8
//esp 4fe9d1 18ch
//----------------------------
//C2 userinfo
//-----------------------------
/*
.text:004FEB86                 mov     ecx, [ebp-160h] //lrhand
.text:004FEB8C                 push    ecx
.text:004FEB8D                 mov     edx, [ebp-164h] //back
.text:004FEB93                 push    edx
.text:004FEB94                 mov     ecx, [ebp-168h] //feet
.text:004FEB9A                 push    ecx
.text:004FEB9B                 mov     edx, [ebp-16Ch] //legs
.text:004FEBA1                 push    edx
.text:004FEBA2                 mov     ecx, [ebp-170h] //chest
.text:004FEBA8                 mov     edx, [ebp-174h] // gloves
.text:004FEBAE                 push    ecx
.text:004FEBAF                 mov     ecx, [ebp-178h] //head
.text:004FEBB5                 push    edx
.text:004FEBB6                 mov     edx, [ebp-17Ch] //lhand
.text:004FEBBC                 push    ecx
.text:004FEBBD                 mov     ecx, [ebp-180h] //rhand
.text:004FEBC3                 push    edx
.text:004FEBC4                 mov     edx, [ebp-184h] //lfinger
.text:004FEBCA                 push    ecx
.text:004FEBCB                 mov     ecx, [ebp-188h] //rfinger
.text:004FEBD1                 push    edx
.text:004FEBD2                 mov     edx, [ebp-18Ch] //neck
.text:004FEBD8                 push    ecx
.text:004FEBD9                 mov     ecx, [ebp-190h] //lear
.text:004FEBDF                 push    edx
.text:004FEBE0                 mov     edx, [ebp-194h] //rear
.text:004FEBE6                 push    ecx
.text:004FEBE7                 mov     ecx, [ebp-198h] //underwear
.text:004FEBED                 push    edx
*/

__declspec(naked) void UserInfoPacketC2FixD()
{

	__asm
	{

		//4FECB3
		push eax
		
		
//		push 1 //high five //will replace with corect value on packet sending
//		push 1 //expTableC1[eax] //high five


		mov     eax, [ebp][-50h]

//		push	0 			//C5+ Q format
		push    ecx			//exp
		

		push	4FECB8h
		retn
	}

}

__declspec(naked) void UserInfoPacketC2FixC()
{

	__asm
	{
		      //4febfb +2nop
/*
			pop		ecx //hair

			mov		edx, [edi+0F54h]
			mov		edx, [edx+0118h]
//			mov		edx,[ebp][-00000144h]
			push	edx
//			push	0 //face c6 (in C5 was at the end of packet)

			push	ecx  //hair

			mov		edx,[ebp][-00000120h]
			mov		ecx,[ebp][-00000124h]		
*/
			push	edx
			mov		edx,[ebp][-00000128h]
	
			push	4fec02h
			retn

	}

}



__declspec(naked) void UserInfoPacketC2FixB()
{

	__asm
	{
		      //4febee=nop
			mov	edx,[ebp][-00000120h]
			push	ecx

			mov	ecx,[ebp][-00000124h]


			push	4febfbh
			retn

	}

}




__declspec(naked) void UserInfoPacketC2FixA()
{

	__asm
	{

			//4feb8C + 2nop
			pop		ecx //there is hair value


		
		call UserInfoPacketC2_BGrade

//restore what owerwrote
			mov		ecx,[ebp][-00000160h]
			push	ecx
			mov		edx,[ebp][-00000164h]

			push	4feb93h
			retn

	}

}






//format 4fecec   0603690
//esp 4fecfb 1a4h


//-----------------------------------------
//charinfo 
//-----------------------------------------



//const int CHAR_LOCATION_CHEST = -0x0000012C;
//const int CHAR_LOCATION_GLOVES = -0x00000130;
//const int CHAR_LOCATION_BOOTS = -0x00000124;
//const int USER_LOCATION__HOSE = -0x00000128;
////////////////
//civil dress
////////////////
/*
__declspec(naked) void CharInfoPacketC2_Civil() //not working yet
{

	__asm
	{

			cmp [ebp][-0000012Ch],  9030  
			jne civil_1
			mov [ebp][-0000012Ch], 460 //chest
	//		mov [ebp][-00000128h], 460 //hose
			mov [ebp][-00000124h], 2444 //boots
			mov [ebp][-00000130h], 2473 //gloves
civil_1:
			cmp [ebp][-0000012Ch],  9031  
			jne civil_2
			mov [ebp][-0000012Ch], 2408 //chest
			mov [ebp][-00000128h], 2408 //hose
			mov [ebp][-00000124h], 2440 //boots
			mov [ebp][-00000130h], 2479 //gloves
civil_2:
			cmp [ebp][-0000012Ch],  9032  
			jne civil_3
			mov [ebp][-0000012Ch], 2407 //chest
			mov [ebp][-00000128h], 2407 //hose
			mov [ebp][-00000124h], 563 //boots
			mov [ebp][-00000130h], 2472 //gloves
civil_3:
			cmp [ebp][-0000012Ch],  9033  
			jne civil_4
			mov [ebp][-0000012Ch], 459 //chest
			mov [ebp][-00000128h], 459 //hose
			mov [ebp][-00000124h], 2442 //boots
			mov [ebp][-00000130h], 2474 //gloves
civil_4:
			cmp [ebp][-0000012Ch],  9034  
			jne civil_5
			mov [ebp][-0000012Ch], 454 //chest
			mov [ebp][-00000128h], 454 //hose
			mov [ebp][-00000124h], 591 //boots
			mov [ebp][-00000130h], 609 //gloves
civil_5:
			cmp [ebp][-0000012Ch],  9035  
			jne civil_6
			mov [ebp][-0000012Ch], 359 //chest
			mov [ebp][-00000128h], 359 //hose
			mov [ebp][-00000124h], 557 //boots
			mov [ebp][-00000130h], 613 //gloves
civil_6:
			cmp [ebp][-0000012Ch],  9036  
			jne civil_7
			mov [ebp][-0000012Ch], 2409 //chest
			mov [ebp][-00000128h], 2409 //hose
			mov [ebp][-00000124h], 583 //boots
			mov [ebp][-00000130h], 2482 //gloves
civil_7:

		ret
	}

}
		

////////////////
//donator armor
///////////////
__declspec(naked) void CharInfoPacketC2_Donator()
{

	__asm
	{
			cmp [ebp][-0000012Ch],  9641  //chest
			jne donator_1
			mov [ebp][-0000012Ch],  361
			jmp short donator_3
			
donator_1:
			cmp [ebp][-0000012Ch],  9645  
			jne donator_2
			mov [ebp][-0000012Ch],  405
			jmp short donator_3
			
donator_2:
			cmp [ebp][-0000012Ch],  9649  
			jne donator_3
			mov [ebp][-0000012Ch],  2400
			
donator_3:
			cmp [ebp][-00000128h],  9642  //legs
			jne donator_4
			mov [ebp][-00000128h],  386
			jmp short donator_6
			
donator_4:
			cmp [ebp][-00000128h],  9646  
			jne donator_5
			mov [ebp][-00000128h],  422
			jmp short donator_6
			
donator_5:
			cmp [ebp][-00000128h],  9650  
			jne donator_6
			mov [ebp][-00000128h],  2405
			
donator_6:
			cmp [ebp][-00000124h],  9644  //boots
			jne donator_7
			mov [ebp][-00000124h],  2441
			jmp short donator_9
			
donator_7:
			cmp [ebp][-00000124h],  9648  
			jne donator_8
			mov [ebp][-00000124h],  575
			jmp short donator_9
			
donator_8:
			cmp [ebp][-00000124h],  9652  
			jne donator_9
			mov [ebp][-00000124h],  598
			
donator_9:
			cmp [ebp][-00000130h],  9643  //gloves 
			jne donator_10
			mov [ebp][-00000130h],  2471
			jmp short donator_12
			
donator_10:
			cmp [ebp][-00000130h],  9647  
			jne donator_11
			mov [ebp][-00000130h],  2469
			jmp short donator_12
			
donator_11:
			cmp [ebp][-00000130h],  9651  
			jne donator_12
			mov [ebp][-00000130h],  2478
			
donator_12:

			ret
	}
}
*/



//B grade textures fix, 2011-08
__declspec(naked) void CharInfoPacketC2_BGrade()
{

	__asm
	{

			cmp [ebp][-0000012Ch],  2390  //avadon leather mail
			je avadon_leather_mail_g1

			cmp [ebp][-0000012Ch],  2406  //avadon robe
			je avadon_robe_g1

			cmp [ebp][-0000012Ch],  2392  //doom leather mail
			je doom_leather_mail_g1

			cmp [ebp][-0000012Ch],  2399  //doom tunic
			je doom_robe_g1

			cmp [ebp][-0000012Ch],  2391  //bwolf leather mail
			je bwolf_leather_mail_g1

			cmp [ebp][-0000012Ch],  2398  //bwolf tunic
			je bwolf_robe_g1


			cmp [ebp][-0000012Ch],  2384  //zubei leather shirt
			je zubei_leather_mail_g1

			cmp [ebp][-0000012Ch],  2397  //zubei tunic
			je zubei_robe_g1

		//	call	CharInfoPacketC2_Civil


			jmp short done




//////////////////
//avadon
/////////////////
avadon_leather_mail_g1:
			cmp [ebp][-00000130h],  2464 //avadon gloves
			jne avadon_leather_mail_b1
			mov [ebp][-00000130h],  2466 //avadon light model

			jmp short avadon_leather_mail_b1

avadon_robe_g1:
			cmp [ebp][-00000130h],  2464 //avadon gloves
			jne avadon_robe_b1
			mov [ebp][-00000130h],  2468 //avadon robe model

			jmp short avadon_robe_b1

avadon_leather_mail_b1:
			cmp [ebp][-00000124h],  600 //avadon boots
			jne done
			mov [ebp][-00000124h],  578 //avadon light model

			jmp short done

avadon_robe_b1:
			cmp [ebp][-00000124h],  600 //avadon boots
			jne done
			mov [ebp][-00000124h],  603 //avadon robe model

			jmp short done
///////////////
//doom
//////////////
doom_leather_mail_g1:
			cmp [ebp][-00000130h],  2475 //doom gloves
			jne doom_leather_mail_b1
			mov [ebp][-00000130h],  2480 //doom light model

			jmp short doom_leather_mail_b1

doom_robe_g1:
			cmp [ebp][-00000130h],  2475 //doom gloves
			jne doom_robe_b1
			mov [ebp][-00000130h],  2481 //doom robe model

			jmp short doom_robe_b1

doom_leather_mail_b1:
			cmp [ebp][-00000124h],  601 //doom boots
			jne done
			mov [ebp][-00000124h],  588 //doom light model

			jmp short done

doom_robe_b1:
			cmp [ebp][-00000124h],  601 //doom boots
			jne done
			mov [ebp][-00000124h],  590 //doom robe model

			jmp short done


///////////////
//blue wolf
//////////////
bwolf_leather_mail_g1:
			cmp [ebp][-00000130h],  2487 //bwolf gloves
			jne bwolf_leather_mail_b1
			mov [ebp][-00000130h],  2485 //bwolf light model

			jmp short bwolf_leather_mail_b1

bwolf_robe_g1:
			cmp [ebp][-00000130h],  2487 //bwolf gloves
			jne bwolf_robe_b1
			mov [ebp][-00000130h],  2486 //bwolf robe model

			jmp short bwolf_robe_b1

bwolf_leather_mail_b1:
			cmp [ebp][-00000124h],  568 //2439 //bwolf boots
			jne done
			mov [ebp][-00000124h],  564 //bwolf light model

			jmp short done

bwolf_robe_b1:
			cmp [ebp][-00000124h],  568  //2439 //bwolf boots
			jne done
			mov [ebp][-00000124h],  582 //bwolf robe model

			jmp short done

///////////////
//zubei 
//////////////
zubei_leather_mail_g1:
			cmp [ebp][-00000130h],  2476 //612 //zubei gloves
			jne zubei_leather_mail_b1
			mov [ebp][-00000130h],  2465 //zubei light model

			jmp short zubei_leather_mail_b1

zubei_robe_g1:
			cmp [ebp][-00000130h],  2476 //612 //zubei gloves
			jne zubei_robe_b1
			mov [ebp][-00000130h],  2467 //zubei robe model

			jmp short zubei_robe_b1

zubei_leather_mail_b1:
			cmp [ebp][-00000124h],  554 //zubei boots
			jne done
			mov [ebp][-00000124h],  572 //zubei light model

			jmp short done

zubei_robe_b1:
			cmp [ebp][-00000124h],  554 //zubei boots
			jne done
			mov [ebp][-00000124h],  595 //zubei robe model

			jmp short done



done:
			ret


	}

}



/*
.text:004FFA2C                 mov     eax, [ebp+var_11C] //lrhand
.text:004FFA32                 push    ecx
.text:004FFA33                 mov     ecx, [ebp+var_120] //back
.text:004FFA39                 push    edx
.text:004FFA3A                 mov     edx, [ebp+var_124] //feet
.text:004FFA40                 push    eax
.text:004FFA41                 mov     eax, [ebp+var_128] //legs
.text:004FFA47                 push    ecx
.text:004FFA48                 mov     ecx, [ebp+var_12C] //chest
.text:004FFA4E                 push    edx
.text:004FFA4F                 mov     edx, [ebp+var_130] //gloves
.text:004FFA55                 push    eax
.text:004FFA56                 mov     eax, [ebp+var_134] //lhand
.text:004FFA5C                 push    ecx
.text:004FFA5D                 mov     ecx, [ebp+var_138] //rhand
.text:004FFA63                 push    edx
.text:004FFA64                 mov     edx, [ebp+var_13C] //head
.text:004FFA6A                 push    eax
.text:004FFA6B                 mov     eax, [ebp+var_154] //underwear
*/

__declspec(naked) void CharacterInfoPacketC2Fix()
{

	__asm
	{
		
		call CharInfoPacketC2_BGrade
		//call CharInfoPacketC2_Donator

			//4ffa33 + nop
			mov	ecx,[ebp][-00000120h]
			push	edx
			mov	edx,[ebp][-00000124h]
			


			push	4ffa40h
			retn
	}

}

/*
__declspec(naked) void CharacterInfoPacketC2FixC()
{

	__asm
	{
			//4ff93f + nop
			lea	edx,[ebp][-00000258h]
			


			push	4ff945h
			retn
	}

}
*/


//format 4ffab3 06037cc
//esp 4ffac2 100h


//-----------------------------------------
//BC charinfo 
//-----------------------------------------
/*
.text:004FF48F                 mov     eax, [ebp+var_11C] //lrhand
.text:004FF495                 push    ecx
.text:004FF496                 mov     ecx, [ebp+var_120] //back
.text:004FF49C                 push    edx
.text:004FF49D                 mov     edx, [ebp+var_124] //feet
.text:004FF4A3                 push    eax
.text:004FF4A4                 mov     eax, [ebp+var_128] //legs
.text:004FF4AA                 push    ecx
.text:004FF4AB                 mov     ecx, [ebp+var_12C] //chest
.text:004FF4B1                 push    edx
.text:004FF4B2                 mov     edx, [ebp+var_130] //gloves
.text:004FF4B8                 push    eax
.text:004FF4B9                 mov     eax, [ebp+var_134] //lhand
.text:004FF4BF                 push    ecx
.text:004FF4C0                 mov     ecx, [ebp+var_138] //rhand
.text:004FF4C6                 push    edx
.text:004FF4C7                 mov     edx, [ebp+var_13C] //head
.text:004FF4CD                 push    eax
.text:004FF4CE                 mov     eax, [ebp+var_154] //underwear
*/


__declspec(naked) void BCCharacterInfoPacketC2Fix()
{

	__asm
	{
		call CharInfoPacketC2_BGrade
		//call CharInfoPacketC2_Donator


			//4ff496 + nop
			mov	ecx,[ebp][-00000120h]
			push	edx
			mov	edx,[ebp][-00000124h]
			


			push	4ff4a3h
			retn
	}

}

/*
__declspec(naked) void BCCharacterInfoPacketC2FixC()
{

	__asm
	{
			//4ff3a5 + nop
			lea	edx,[ebp][-00000258h]
			


			push	4ff3abh
			retn
	}

}
*/


//format 4ff516  06037cc
//esp  4ff522  100h




__declspec(naked) void ClanInfoC2Fix()
{

	__asm
	{
		      //4c036a

			push	esi
			mov		esi,[ebp][-14h]
			push	esi
			mov		esi,[eax][00000108h]

			push	04c0375h
			retn

	}

}


__declspec(naked) void PartyWindowAddC2()
{

	__asm
	{
		      //4b53f7

			
			mov		ecx,[ebp][-30h]
			push	edx
			push	ecx
			push	ebx

			push	04b53fdh
			retn

	}

}

__declspec(naked) void PartyWindowAllC2()
{

	__asm
	{
		      //4b5582

			
			lea		ecx,[ebp][-00002030h]
			push	ecx
			push	ebx
			push	edx

			push	04b558bh
			retn

	}

}


/*
//tried to find gametime original - unsuccess


//LoadCharacterPacket(CDBSocket *socket, const unsigned char *packet)
	WriteMemory8(0x004659AA, 0xA0); 
	WriteMemory8(0x00465EB1, 0xe8); 
	WriteMemory8(0x00465EB2, 0xda); 
	WriteMemory8(0x00465EB3, 0xf0); 
	WriteMemory8(0x00465EB4, 0xfe); 
	WriteMemory8(0x00465EB5, 0xff); 
	WriteMemory8(0x00465EF8, 0xe8); 
	WriteMemory8(0x00465EF9, 0x73); 
	WriteMemory8(0x00465EFA, 0x9d); 
	WriteMemory8(0x00465EFB, 0x07); 

//LoadSelectedCharacterPacket(CDBSocket *socket, const unsigned char *packet)
	WriteMemory8(0x004686B6, 0xf8); 
	WriteMemory8(0x00468C41, 0x8b); 
	WriteMemory8(0x00468C42, 0x55); 
	WriteMemory8(0x00468C43, 0xb4); 
	WriteMemory8(0x00468C44, 0x52); 
	WriteMemory8(0x00468C45, 0x6a); 
	WriteMemory8(0x00468C46, 0x00); 

	WriteMemory8(0x00468D3E, 0xf8); 
	WriteMemory8(0x00468D3F, 0x00); 


//userinfo
	WriteMemory8(0x004FE615, 0xe8); 
	WriteMemory8(0x004FE616, 0x36); 
	WriteMemory8(0x004FE617, 0x14); 
	WriteMemory8(0x004FE618, 0xf4); 
	WriteMemory8(0x004FE619, 0xff);

//validate location
	WriteMemory8(0x004E8A63, 0x7e); 
	WriteMemory8(0x004E8A64, 0x62); 

//on socket read
	WriteMemory8(0x0050F949, 0x0f); 
	WriteMemory8(0x0050F94A, 0xb6); 
	WriteMemory8(0x0050F94B, 0xc0); 
	WriteMemory8(0x0050F94C, 0x50); 
	WriteMemory8(0x0050F94D, 0x68); 
	WriteMemory8(0x0050F94E, 0x1c); 
	WriteMemory8(0x0050F94F, 0x8b); 
	WriteMemory8(0x0050F950, 0x60); 
	WriteMemory8(0x0050F951, 0x00); 


*/

/*
//setup gauge
	WriteMemory8(0x004FB19D, 0x57); 
	WriteMemory8(0x004FB19E, 0x6a); 
	WriteMemory8(0x004FB19F, 0x02); 
	WriteMemory8(0x004FB1A0, 0x68); 
	WriteMemory8(0x004FB1A1, 0x85); 
	WriteMemory8(0x004FB1A2, 0x00); 
	WriteMemory8(0x004FB1A3, 0x00); 
	WriteMemory8(0x004FB1A4, 0x00); 
	WriteMemory8(0x004FB1A6, 0x84); 
	WriteMemory8(0x004FB1A7, 0x64); 
	WriteMemory8(0x004FB1A8, 0x5b); 
	WriteMemory8(0x004FB1B2, 0x14); 
*/

/*
//server crash???
//show radar?
WriteMemory8(0x004A6C1C, 0x68); 
WriteMemory8(0x004A6C1D, 0xBD); 
WriteMemory8(0x004A6C1E, 0x00); 
WriteMemory8(0x004A6C1F, 0x00); 
WriteMemory8(0x004A6C20, 0x00); 

//delete radar?
WriteMemory8(0x004A6d2c, 0x68); 
WriteMemory8(0x004A6d2D, 0xBe); 
WriteMemory8(0x004A6d2E, 0x00); 
WriteMemory8(0x004A6d2F, 0x00); 
WriteMemory8(0x004A6d30, 0x00); 
*/

//set C3=1 in ini
/*
//multisell
WriteHook(JMP_HOOK,0x00492ce0, C3Multisell1, 0);
WriteHook(JMP_HOOK,0x00492d3b, C3Multisell2, 0);
WriteHook(JMP_HOOK,0x00492e11, C3Multisell3, 0);
//esp
WriteMemory8(0x00492cfe, 0x18); 
WriteMemory8(0x00492d7f, 0x2c); 
WriteMemory8(0x00492e2a, 0x1c); 
*/


/*
//
pDebug = ini_read("general", "C2_multisell", 0);
if (pDebug == NULL)	pDebug="0";
if (atoi(pDebug) == 1)
{

WriteHook(JMP_HOOK,0x00492ce0, C2Multisell1, 0);
WriteHook(JMP_HOOK,0x00492d3b, C2Multisell2, 0);
WriteHook(JMP_HOOK,0x00492e11, C2Multisell3, 0);
//esp
C3EspAddr = (BYTE *)0x00492cfe;
*C3EspAddr = (BYTE)0x18;  
C3EspAddr = (BYTE *)0x00492d7f;
*C3EspAddr = (BYTE)0x2c;
C3EspAddr = (BYTE *)0x00492e2a;
*C3EspAddr = (BYTE)0x1C;



}
*/


__declspec(naked) void PetInfo_C2()
{
	__asm {

//54e2ea
//----------------------------------------
//c2
	push  0 //(c)??

/*
// ride button   if ((npcId >= 12526 && npcId <= 12528) || (npcId == 16030)) //  16025  16030 CT1 Great Wolf
 	mov     ecx, [esi+654h] 		//npc class id
	cmp	ecx,1012526 //wind strider
	je	ride
 	mov     ecx, [esi+654h] 
	cmp	ecx,1012527 //star strider
	je	ride
 	mov     ecx, [esi+654h] 
	cmp	ecx,1012528 //dusk strider
	je	ride	
	mov     ecx, [esi+654h] 
	cmp	ecx,1012621 //wyvern
	je	ride
	mov     ecx, [esi+654h] 
	cmp	ecx,1013871 //great wolf
	je	ride

	pop ecx
	push	0 //no ride button
	jmp	noRide
ride:
	push	1 //ride button
noRide:
*/

// for nonrideable pets - TvT doesnot show, so set all rideable
	push  1 //(h) ride button to all pets
	

//	mov		dword ptr [edi+0AB0h], 0	//Null AVE
	push	[edi+0AB0h]	//Abnormal Effects abnormal visual effect... bleed=1; poison=2; poison & bleed=3; flame=4;



//---------------------------
//c1

		push eax				//writeD(_summon.getMAtkSpd());//casting speed
		call    MATH_FLOAT2DEC


	push	54e2f0h //return address
	retn
	}
}



//4A6C1C
__declspec(naked) void show_radar_c2()
{
	__asm {
		

		push 1 //radar type
		push 0 //show radar

		push 0EDh //radar controll opcode (see in c1 opcode repatch) //original 0BDh

		push	FORMAT_RADAR_CONTROL
		push	eax
		call	CSOCKET_SEND
		add		esp, 020h

		push 4A6C2Fh
		retn

	}
}

//4A6D2C
__declspec(naked) void del_radar_c2()
{
	__asm {

		push 1 //radar type
		push 1 //del radar

		push 0EDh //radar controll opcode (see in c1 opcode repatch) //original 0BEh

		push	FORMAT_RADAR_CONTROL
		push	eax
		call	CSOCKET_SEND
		add		esp, 020h

		push 04A6D3Fh
		retn


	}
}



//426b4a
__declspec(naked) void GM_show_radar_c2()
{
	__asm {
		

		push 1 //radar type
		push 0 //show radar

		push 0BDh //0EDh //radar controll opcode (see in c1 opcode repatch)

		push	FORMAT_RADAR_CONTROL
		push	eax
		call	CSOCKET_SEND
		add		esp, 024h

		push 426b5Dh
		retn

	}
}

//4A6BE9
__declspec(naked) void GM_del_radar_c2()
{
	__asm {

		push 1 //radar type
		push 1 //del radar

		push 0BEh //0EDh //radar controll opcode (see in c1 opcode repatch)

		push	FORMAT_RADAR_CONTROL
		push	eax
		call	CSOCKET_SEND
		add		esp, 024h

		push 0426BFCh
		retn


	}
}


//--------------------------------------
//1e add item

__declspec(naked) void c2_trade_1()
{
	__asm {


//4e659e
		mov	edx,[ecx][00000088h]
		push edx //consume type

	push 0
		movsx	edx,word ptr[ecx][00000090h]
		push edx //enchant
		//push 0 //slot Q addon - classic



push 4e65aah
retn

	}

}


__declspec(naked) void c2_trade_2()
{
	__asm {



//4e656c

		mov	edi,[ecx][00000088h]
		push edi //consume type

	push 0
		movsx	edi,word ptr[ecx][00000090h]
		push edi //enchant
		//push 0 //slot Q addon - classic


push 4e6578h
retn

	}

}



__declspec(naked) void c2_trade_3()
{
	__asm {


//4e64c8
		mov	edx,[ecx][00000088h]
		push edx //consume type

		movsx	edx,word ptr[ecx][00000090h]
		mov		eax,[esi][0000404Ch]

		push 0
		push edx //enchant
		//push 0 //slot Q addon - classic


push 4e64dah
retn
	}

}


__declspec(naked) void c2_trade_4()
{
	__asm {



//4e6476

		mov	ebx,[ecx][00000088h]
		push ebx //consume type


		movsx	ebx,word ptr[ecx][00000090h]


	push 0
		push ebx //enchant
		//push 0 //slot Q addon - classic


push 4e6482h
retn


	}

}



__declspec(naked) void c2_trade_5()
{
	__asm {


//4e6320
		mov	edx,[ecx][00000088h]
		push edx //consume type


		movsx	edx,word ptr[ecx][00000090h]


	push 0
		push edx //enchant
		//push 0 //slot Q addon - classic


push 4e632Ch
retn

	}

}


__declspec(naked) void c2_trade_6()
{
	__asm {


//4e62ee
		mov	edi,[ecx][00000088h]
		push edi //consume type


		movsx	edi,word ptr[ecx][00000090h]


		push 0
		push edi //enchant
		//push 0 //slot Q addon - classic

push 4e62fah
retn

	}

}



__declspec(naked) void c2_trade_7()
{
	__asm {


//4e624a
		mov	edx,[ecx][00000088h]
		push edx //consume type



		movsx	edx,word ptr[ecx][00000090h]
		mov		eax,[esi][0000404Ch]

	push 0
		push edx //enchant
		//push 0 //slot Q addon - classic



push 4e625Ch
retn


	}

}


__declspec(naked) void c2_trade_8()
{
	__asm {


//4e61f8
		mov	ebx,[ecx][00000088h]
		push ebx //consume type



		movsx	ebx,word ptr[ecx][00000090h]


	push 0
		push ebx //enchant
		//push 0 //slot Q addon - classic



push 4e6204h
retn


	}

}


/*
userinfo
		Inventory.PAPERDOLL_UNDERWEAR,  198
        Inventory.PAPERDOLL_REAR, 194
        Inventory.PAPERDOLL_LEAR,  190
        Inventory.PAPERDOLL_NECK,  18c
        Inventory.PAPERDOLL_RFINGER, 188
        Inventory.PAPERDOLL_LFINGER, 184

        Inventory.PAPERDOLL_HEAD, 180
        Inventory.PAPERDOLL_RHAND, 17C
        Inventory.PAPERDOLL_LHAND, 178
        Inventory.PAPERDOLL_GLOVES, 174
        Inventory.PAPERDOLL_CHEST, 170
        Inventory.PAPERDOLL_LEGS, 16c
        Inventory.PAPERDOLL_FEET, 168
        Inventory.PAPERDOLL_CLOAK, 164
        Inventory.PAPERDOLL_RHAND, 160


charinfo
		Inventory.PAPERDOLL_UNDERWEAR, 154  

Inventory.PAPERDOLL_REAR, 150  not send
Inventory.PAPERDOLL_LEAR,  14c not send
Inventory.PAPERDOLL_NECK,  148 not send
Inventory.PAPERDOLL_RFINGER, 144 not send
Inventory.PAPERDOLL_LFINGER, 140 not send


        Inventory.PAPERDOLL_HEAD, 13c
        Inventory.PAPERDOLL_RHAND, 138
        Inventory.PAPERDOLL_LHAND, 134
        Inventory.PAPERDOLL_GLOVES, 130
        Inventory.PAPERDOLL_CHEST, 12c
        Inventory.PAPERDOLL_LEGS, 128
        Inventory.PAPERDOLL_FEET, 124
        Inventory.PAPERDOLL_CLOAK, 120
        Inventory.PAPERDOLL_RHAND, 11c



*/