#include <windows.h>
#include <stdio.h>

#include "Globals.h"
#include "CCreature.h"
#include "CParty.h"
//#include "MemberList.h"
#include "ServerPackets.h"
//#include "UserSocket.h"
//#include "SafeObjects.h"


//CPARTY_UPDATEWINDOWPACKET CParty_UpdateWindowPacket = &CParty::UpdateWindowPacket;
//CPARTY_OPENALLWINDOWPACKET CParty_OpenAllWindowPacket = &CParty::OpenAllWindowPacket;

typedef  void (__thiscall *CPARTY_GETALLMEMBERS)(CParty_ *pParty, CMemberList *lstMember);
CPARTY_GETALLMEMBERS CParty_GetAllMembers = (CPARTY_GETALLMEMBERS)(0x0044B410);

typedef  CCreature_* (__thiscall *CPARTY_GETMASTER)(CParty_ *pParty);
CPARTY_GETMASTER CParty_GetMaster = (CPARTY_GETMASTER)(0x004B3C70);

typedef  void (__thiscall *CPARTY_DISMISS)(CParty_ *pParty);
CPARTY_DISMISS CParty_Dismiss = (CPARTY_DISMISS)(0x004B4F70);

typedef  void (__thiscall *CPARTY_WITHDRAW)(CParty_ *pParty, CCreature_ *pUser);
CPARTY_WITHDRAW CParty_Withdraw = (CPARTY_WITHDRAW)(0x004B4D60);

typedef  int (__thiscall *CPARTY_GETMEMBERCOUNT)(CParty_ *pParty);
CPARTY_GETMEMBERCOUNT CParty_GetMemberCount = (CPARTY_GETMEMBERCOUNT)0x004EAFE0;

typedef  void (__thiscall *CPARTY_SETMASTER)(CParty_ *pParty, CCreature_ *pUser);
CPARTY_SETMASTER CParty_SetMaster = (CPARTY_SETMASTER)(0x004B3380);


MEMBERLIST_FREEDATA MemberList_FreeData = (MEMBERLIST_FREEDATA)(0x004923B0);


void CParty_::SetMaster(CCreature_ *pUser)
{
	CParty_SetMaster(this, pUser);
}

int CParty_::GetMemberCount()
{
	return CParty_GetMemberCount(this);
}

void CParty_::GetAllMembers(CMemberList *lstMember)
{
	CParty_GetAllMembers(this,lstMember);
}

CCreature_ *CParty_::GetMaster()
{
	return CParty_GetMaster(this);
}

void CParty_::Dismiss()
{
	CParty_Dismiss(this);
}

void CParty_::Withdraw(CCreature_*pUser)
{
	CParty_Withdraw(this, pUser);
}

void CParty_::OpenAllWindowPacket(CCreature_ *pUser)
{
/*

	if (SO_VALID_USER(pUser)==false)
	{
		CLog_AddW(CLOG,2,L"CParty::OpenAllWindowPacket SAFEOBJECTS CHECKPOINT");
		return;
	}

	CMemberList MemberList;
	ZeroMemory(&MemberList, sizeof(CMemberList));
	GetAllMembers(&MemberList);

	if (MemberList.ppUserBegin==NULL) 
	{
		CLog_AddW(CLOG,2,L"CParty::OpenAllWindowPacket No Members Error");
		return;
	}

	UCHAR buffer[0x2000];
	UCHAR*p;
	p = buffer;
	int total=0;
	int nCount = (int)(MemberList.ppUserEnd - MemberList.ppUserBegin);

	for (int i=0; i<nCount; i++)
	{
		CCreature_ *pMember = MemberList.ppUserBegin[i];
		if (pUser!=NULL && pMember!=NULL && pUser->nObjectID != pMember->nObjectID)
		{
			int n = Assemble(p,0x2000-total,"dSdddddddddd",
				pMember->nObjectID,				//d
				pMember->Data->szName,			//S
				(int)pMember->GetCurrentCP(),	//d
				(int)pMember->GetMaxCP(),		//d
				(int)pMember->GetCurrentHP(),	//d
				(int)pMember->GetMaxHP(),		//d
				(int)pMember->GetCurrentMP(),	//d
				(int)pMember->GetMaxMP(),		//d
				pMember->GetLevel(),			//d
				pMember->GetClass(),			//d
				0,
				0);
			p += n;
			total += n;
		}
	}
	if (total>0 || total<0x2000)
	{
		pUser->pUserSocket->Send("cdddb",
			0x4E,							//c
			GetMasterID(),					//d
			GetLootDistribution() & 0xF,	//d
			nCount-1,						//d
			total,	buffer);				//b
	}
	else
	{
		CLog_AddW(CLOG,2,L"CParty::OpenAllWindowPacket Packet Assembler Error");
	}

	MemberList.Cleanup();
*/

}

void CParty_::UpdateWindowPacket(CCreature_ *pUser, INT nUpdateType)
{
	if (SO_VALID_USER(pUser)==false)
	{
		//CLog_AddW_hd(CLOG,2,L"CParty::UpdateWindowPacket SAFEOBJECTS CHECKPOINT");
		return;
	}

	int i;
	CMemberList MemberList;
	ZeroMemory(&MemberList, sizeof(CMemberList));
	GetAllMembers(&MemberList);
	if (MemberList.ppUserBegin!=NULL)
	{
		int nCount = (int)(MemberList.ppUserEnd - MemberList.ppUserBegin);
		for (i=0;i<nCount;i++)
		{
			CCreature_ *pMember = MemberList.ppUserBegin[i];
			//CLog_AddW(CLOG,0,L"pUser=%X pMember=%X",pUser,pMember);
			if (pUser!=NULL && pMember!=NULL && pUser->nObjectID != pMember->nObjectID)
			{
				CUserSocket *pMemberSocket = pMember->pUserSocket;
				if (pMemberSocket != NULL)
				{
					pMemberSocket->Send("cdSdddddddd",
						0x52,							//c
						pUser->nObjectID,				//d
						pUser->Data->wszName,			//S
						(int)pUser->GetCurrentCP(),	//d
						(int)pUser->GetMaxCP(),		//d
						(int)pUser->GetCurrentHP(),	//d
						(int)pUser->GetMaxHP(),		//d
						(int)pUser->GetCurrentMP(),	//d
						(int)pUser->GetMaxMP(),		//d
						pUser->GetLevel(),			//d
						pUser->GetClass()				//d
						);

					/*switch(nUpdateType)
					{
					case 1:
						CLog_AddW(CLOG,0,L"Send Status 1");
						pMemberSocket->Send("cdddddd",
							SP_STATUS_UPDATE,				//c
							pMember->nObjectID,				//d
							4,								//d
							STATUS_CUR_HP,					//d
							(int)pMember->GetCurrentHP(),	//d
							STATUS_MAX_HP,					//d
							(int)pMember->GetMaxHP()		//d
							);
						break;
					case 2:
						CLog_AddW(CLOG,0,L"Send Status 2");
						pMemberSocket->Send("cdddddd",
							SP_STATUS_UPDATE,				//c
							pMember->nObjectID,				//d
							2,								//d
							STATUS_CUR_MP,					//d
							(int)pMember->GetCurrentMP(),	//d
							STATUS_MAX_MP,					//d
							(int)pMember->GetMaxMP()		//d
							);
						break;
					}*/
				}
			}
		}
		MemberList.Cleanup();
	}
}

void CParty_::ChangePartyLeader(CCreature_ *pUser)
{
	if (SO_VALID_USER(pUser)==false)
	{
		//CLog_AddW_hd(CLOG,2,L"CParty::ChangePartyLeader SAFEOBJECTS CHECKPOINT");
		return;
	}
	SetMaster(pUser);
	CMemberList MemberList;
	ZeroMemory(&MemberList, sizeof(CMemberList));
	GetAllMembers(&MemberList);
	if (MemberList.ppUserBegin==NULL) 
	{
		//CLog_AddW_hd(CLOG,2,L"CParty::ChangePartyLeader No Members Error");
		return;
	}
	int nCount = (int)(MemberList.ppUserEnd - MemberList.ppUserBegin);
	//first round
	for (int i=0; i<nCount; i++)
	{
		CCreature_ *pMember = MemberList.ppUserBegin[i];
		if (pUser!=NULL && pMember!=NULL && pMember->pUserSocket !=NULL)
		{
			//delete all small windows
			pMember->pUserSocket->Send("c",0x50);
			//update small party window
			OpenAllWindowPacket(pMember);
		}
	}
	//second round, restore all abnormals and send text message
	for (int i=0; i<nCount; i++)
	{
		CCreature_ *pMember = MemberList.ppUserBegin[i];
		if (pUser!=NULL && pMember!=NULL && pMember->pUserSocket !=NULL)
		{
			//update abnormals
			pMember->SendAbnormalStatusInfo();
			//send messsage
			SP_SM_TEXT_TEXT(pMember->pUserSocket,SM_S1_BECOME_PARTY_LEADER,pUser->Data->wszName);
		}
	}
	MemberList.Cleanup();
}