static const __int64 ret0 = 0x5FD680; // retn 0
static const __int64 ret1 = 0x693830; //mov al,1  retn
static const __int64 retf0 = 0x7A2730;
static const __int64 CheckResisted = 0x4D1850; //c4 7985D0;

enum EffectList {
	_p_critical_rate_by_weapon,
	_p_critical_damage_by_weapon,
	_p_magic_speed_by_weapon,
	_i_erase,
	_i_betray,
//no arguments
	_i_summon_friend=10,
	_i_summon_party,
	_p_self_resurrect,
	_p_target_cancel,
//p_eff  1 arg
	_p_mirage=30,
	_p_counter_melee,
	_p_evade_melee,
	_p_protection_blessing,
	_p_enlarge_buffslots
};

enum OpCondList {
	_remain_mp_per,

	_can_summon_friend=10,
	_can_summon_party
};

enum AttackType {
	AT_NONE,
	AT_SWORD,
	AT_BLUNT,
	AT_DAGGER,
	AT_POLE,
	AT_FIST,
	AT_BOW,
	AT_ETC,
	AT_DUAL,
	AT_DUALFIST
};

enum DiffType {
	Per,
	Diff
};

class CSkillEffectByWeapon: public CSkillEffect {
public:
	__int64* pSkillEffect;
	__int64 Unk;
	__int64 WeapList;//+10
	__int64 Unk2;
	double dDiff;	//+20
	DiffType DiffPer;		//+28
};

class CSkillEffectNoParam: public CSkillEffect {
public:
	__int64* pSkillEffect;
};

class CSkillEffectOneIntParam: public CSkillEffect {
public:
	__int64* pSkillEffect;
	__int64 Unk;
	int nValue;
};

class CSkillEffectOneDoubleParam: public CSkillEffect {
public:
	__int64* pSkillEffect;
	__int64 Unk;
	double dValue;
};

class CSkillOperateCondSingle: public CSkillOperateCondition {
public:
	__int64* pOperateConditionFunc;
};

class CSkillOperateCondOneVar: public CSkillOperateCondition {
public:
	__int64* pOperateConditionFunc;
	int nValue;
};

//--------------------------------------------------------------------------------------------------
DWORD p_critical_rate_by_weapon_CheckPumpCondition(CSkillEffect* pSkillEffect, CCreature* pCreature);
void p_critical_rate_by_weapon_Pump(CSkillEffect* pSkillEffect, CCreature* pCreature);

DWORD p_critical_damage_by_weapon_CheckPumpCondition(CSkillEffect* pSkillEffect, CCreature* pCreature);
void p_critical_damage_by_weapon_Pump(CSkillEffect* pSkillEffect, CCreature* pCreature);

DWORD p_magic_speed_by_weapon_CheckPumpCondition(CSkillEffect* pSkillEffect, CCreature* pCreature);
void p_magic_speed_by_weapon_Pump(CSkillEffect* pSkillEffect, CCreature* pCreature);

bool p_mirage_CheckPumpCondition(CSkillEffect* pSkillEffect, CCreature* pTarget);
void p_mirage_Pump(CSkillEffect* pSkillEffect, CCreature* pTarget);

bool p_evade_melee_CheckPumpCondition(CSkillEffect* pSkillEffect, CCreature* pTarget);
void p_evade_melee_Pump(CSkillEffect* pSkillEffect, CCreature* pTarget);

bool p_counter_melee_CheckPumpCondition(CSkillEffect* pSkillEffect, CCreature* pTarget);
void p_counter_melee_Pump(CSkillEffect* pSkillEffect, CCreature* pTarget);

bool p_protection_blessing_CheckPumpCondition(CSkillEffect* pSkillEffect, CCreature* pTarget);
void p_protection_blessing_Pump(CSkillEffect* pSkillEffect, CCreature* pTarget);

bool p_enlarge_buffslots_CheckPumpCondition(CSkillEffect* pSkillEffect, CCreature* pTarget);
void p_enlarge_buffslots_Pump(CSkillEffect* pSkillEffect, CCreature* pTarget);
//--------------------------------------------------------------------------------------------------
bool remain_mp_per_CanUse(CSkillOperateCondition* pOpCond, CCreature* pSkillUser);
bool can_summon_friend_CanUse(CSkillOperateCondition* pOpCond, CCreature* pSkillUser, CCreature* pTargetObject);
bool can_summon_party_CanUse(CSkillOperateCondition* pOpCond, CCreature* pSkillUser, CCreature* pTargetObject);

const __int64 p_critical_rate_by_weapon[] = {
	ret0,
	ret0,
	ret0,
	ret0,
	retf0,
	(__int64)p_critical_rate_by_weapon_CheckPumpCondition,
	(__int64)p_critical_rate_by_weapon_Pump,
	ret1,
	CheckResisted
};

const __int64 p_critical_damage_by_weapon[] = {
	ret0,
	ret0,
	ret0,
	ret0,
	retf0,
	(__int64)p_critical_damage_by_weapon_CheckPumpCondition,
	(__int64)p_critical_damage_by_weapon_Pump,
	ret1,
	CheckResisted
};

const __int64 p_magic_speed_by_weapon[] = {
	ret0,
	ret0,
	ret0,
	ret0,
	retf0,
	(__int64)p_magic_speed_by_weapon_CheckPumpCondition,
	(__int64)p_magic_speed_by_weapon_Pump,
	ret1,
	CheckResisted
};

const __int64 p_mirage[] = {
	ret0,
	ret0,
	ret0,
	ret0,
	retf0,
	(__int64)p_mirage_CheckPumpCondition,
	(__int64)p_mirage_Pump,
	ret1,
	CheckResisted
};

const __int64 p_counter_melee[] = {
	ret0,
	ret0,
	ret0,
	ret0,
	retf0,
	(__int64)p_counter_melee_CheckPumpCondition,
	(__int64)p_counter_melee_Pump,
	ret1,
	CheckResisted
};

const __int64 p_evade_melee[] = {
	ret0,
	ret0,
	ret0,
	ret0,
	retf0,
	(__int64)p_evade_melee_CheckPumpCondition,
	(__int64)p_evade_melee_Pump,
	ret1,
	CheckResisted
};

const __int64 p_protection_blessing[] = {
	ret0,
	ret0,
	ret0,
	ret0,
	retf0,
	(__int64)p_protection_blessing_CheckPumpCondition,
	(__int64)p_protection_blessing_Pump,
	ret1,
	CheckResisted
};

const __int64 p_enlarge_bufflosts[] = {
	ret0,
	ret0,
	ret0,
	ret0,
	retf0,
	(__int64)p_enlarge_buffslots_CheckPumpCondition,
	(__int64)p_enlarge_buffslots_Pump,
	ret1,
	CheckResisted
};

/*
struct sEffectStruct {			//p_		i_			i_cub	c_		t_
__int64 _1CalcSuccess;		//ret0		ret0/func	ret0	ret0	ret0
__int64 _2Instant;			//ret0		func		ret0	ret0	ret0
__int64 _3Cubic;			//ret0		ret0		func	ret0	ret0
__int64 _4Tick;				//ret0		ret0		ret0	ret0	func
__int64 _5TickValue;		//retf0		retf0		retf0	retf0	ret_value
__int64 _6CheckPump;		//func		ret1		ret1	ret1	ret1
__int64 _7Pump;				//func		ret0		ret0	ret0	ret0
__int64 _8Consume;			//ret1		ret1		ret1	func	ret1
__int64 _9CheckResisted;	//const		const		const	const	const
};
*/
const __int64 can_summon_friend[] = {
	(__int64)can_summon_friend_CanUse,
	0,
	0
};

const __int64 can_summon_party[] = {
	(__int64)can_summon_party_CanUse,
	0,
	0
};

const __int64 remain_mp_per[] = {
	(__int64)remain_mp_per_CanUse,
	0,
	0
};
/*
struct sOpCond {
__int64 _1CanUseFunction;
__int64 _2ConstZero;
__int64 _3Unknown;
};
*/