#include "L2Server.h"

/*
438b10	CCreature::IsVehicle()
4403c0	CCreature::MoveToLocation
440490	CCreature::MoveToLocationInVehicle(CVehicle *pVehicle, int x, int y, int z)
483fa0	CGetOnVehicleIOCPMessage::OnReceive(int id=0)
4840f0	CGetOffVehicleIOCPMessage::OnReceive(int id=0)
499fd0	CMoveInVehicleAction::OnEnd(bool bFinishedWell)
49a070	CMoveInVehicleAction::GetDestination()
49ed60	CMoveInVehicleAction::SetMoving()
4ce260	CContainerDB::IsVehicle(int index)
518a20	CVehicle::StartDrive()
519270	GetObject(unsigned int sid)
5193e0	CVehicle::CVehicle()
5195e0	CVehicle::CVehicle(const CVehicle& other): CObject(other)
519710	CVehicle::GetObject(unsigned int sid)
519790	CVehicle::FindObject(unsigned int sid)
519830	CVehicle::FindObjectSP(unsigned int sid)
5198f0	CVehicleDB::FindVehicle(int id)
519b30	CVehicleController::Arrived()
519cc0	CVehicle::ProcessStopDrive()
519ed0	CVehicle::StopDrive()
519f70	CVehicleDB::StartDrive()
51a030	CVehicle::SendVehicleInfo(CUserSocket *pSocket)
51abe0	CVehicleDB::AddVehicle()
51ad00	CVehicleController::CVehicleController()
51ae50	CVehicleController::AddStation(CVehicleStationInfo *pStation)
51aed0	CVehicle::InSight(CObject *pObject)
51b2a0	CVehicle::OutOtSight(CObject *pObject)
51b670	CVehicle::TimerExpired(int id)
51bd90	CVehicle::InformVehicleStart(bool bStart)
51bf80	CVehicle::KickIllegal(int ticket_id, FVector vTarget)
51c2f0	CVehicleDB::EraseAllVehicle()
51c4d0	CVehicleDB::Load()
51c670	CVehicleController::TimerExpired(int id)
*/



//---------------------------------------------------------------------------------
/*
//ExAirShipInfo
DWORD nObjectID=0;
DWORD fuel=100;
DWORD ExAirShipInfoID =0;
//ddddddddddddddddd
//%ExAirShipInfoID:%dx:%dy:%dz:%dyaw:%ddriver:%dserverobj:%dfuel:%dmaxfuel:%
//d               ddd d   d      d     d     d        dddddddd
//ExAirShipInfoID xyz yaw driver objid fuel  maxfuel 
				CSocketOLD::Send(pSocket, "chddddddddddddddddd", aOPCODE(OP_EXTENDED), aOPCODEx(0x60), ExAirShipInfoID,
					(int) CSharedDat->x, (int) CSharedDat->y, (int) CSharedDat->z +50, CSharedDat->m_Direction,
					CSharedDat->nObjectID, nObjectID, fuel, fuel,
					0,0,0,0,0,0,0,0);

		CSocketOLD::Send(pSocket, "chdddddd", aOPCODE(OP_EXTENDED), aOPCODEx(0x60), 0,
		(int) CSharedDat->x, (int) CSharedDat->y, (int) CSharedDat->z +300, CSharedDat->m_Direction);

*/

//////////////////////////////////////////
// B R O A D C A S T S
//////////////////////////////////////////

/*
[0x6e] "0x59 0x60, VehicleInfo", //"60, ExAirShipInfo",
[0x6f] "0x5a 0x6c, VehicleDeparture",
				//"65, ExMoveToLocationAirShipPacket", //move 
				//"66, ExStopMoveAirShipPacket", //stop
[0x70] "0x5b 0x6d, VehicleCheckLocation",
[0x71] "0x5c 0x6e, GetOnVehicle", //"63, ExGetOnAirShipPacket",
[0x72] "0x5d 0x6f, GetOffVehicle", //"64, ExGetOffAirShipPacket",

[0x89] "0x71 0x7e, MoveToLocationInVehicle", 
				//"6d  ExMoveToLocationInAirShipPacket",
[0x8a] "0x72 0x7f, StopMoveInVehice", 
				//"6e  ExStopMoveInAirShipPacket",
[0x8b] "0x73 0x80, ValidateLocatioInVehicle",
				//"6f  ExValidateLocationInAirShipPacket",

[0xd3] "0xba 0xc0, VehicleStart",

==============================================
//"71  ExMoveToTargetInAirShipPacket",
//"72  ExAttackInAirShipPacket",
//"73  ExMagicSkillUseInAirShipPacket",

*/


//------------------------------------------
// Vehicle Info
//------------------------------------------

__declspec(naked) void GraciaF_VehicleInfo()
{
	__asm {


//51a095
//esp 51a0e7 40+4
		push	0 //max fuel
		push	0 //current fuel
		push	0
		push	0
		push	0
		push	0
		push	0
		push	0
		push	0

		mov		ecx,[esi][0000080h]
		push	ecx //speed 2
		mov		ecx,[esi][078h]
		push	ecx //speed 1
		push	0 //// object id of player who control ship

//ground vehicle
		push	0  //dummy value
		fld		qword ptr[edx][010h]
		mov		edi,eax
		push	ecx //direction
		call	MATH_FLOAT2DEC
		fld		qword ptr[ebx][08h]
		push	eax //z
		call	MATH_FLOAT2DEC
		fld		qword ptr[edi]
		push	eax //y
		call	MATH_FLOAT2DEC
		mov		edx, esi

//51a0b3

		push	eax //x
		mov		eax,[esi][018h]
		push	eax //object id
		push	060h
		push	FORMAT_VEHICLEG2a
		sub		esp, 018h 

		push	51a0c2h
		retn
	}

}




__declspec(naked) void GraciaF_VehicleInfo_air()
{
	__asm {


//51a095
//esp 51a0e7 40+10
//...........
//air vehicle
//...........
		push	0 //max fuel
		push	0 //current fuel
		push	0
		push	0
		push	0
		push	0
		push	0
		push	0
		push	0

		mov		ecx,[esi][0000080h]
		push	ecx //speed 2
		mov		ecx,[esi][078h]
		push	ecx //speed 1
		push	0 //// object id of player who control ship

		mov		ecx,[ebp][08h]
		fld		qword ptr[edx][010h]
		mov		edi,eax
		push	ecx //direction
		call	MATH_FLOAT2DEC
		fld		qword ptr[ebx][08h]
		push	eax //z
		call	MATH_FLOAT2DEC
		fld		qword ptr[edi]
		push	eax //y
		call	MATH_FLOAT2DEC
		mov		edx, esi

//51a0b3

		push	eax //x
		mov		eax,[esi][018h]
		push	eax //object id
		push	060h
		push	0FEh
		push	FORMAT_VEHICLEA2a
		sub		esp, 018h 

		push	51a0c2h
		retn
	}

}




//---------------------------------------
// Validate Location IN vehicle
//---------------------------------------
/*
        writeC(0x73); // writeC(0x80);
        writeD(_activeChar.getObjectId());
        writeD(1343225858); //TODO verify vehicle object id ??
        writeD(_activeChar.getX());
        writeD(_activeChar.getY());
        writeD(_activeChar.getZ());
        writeD(_activeChar.getHeading());


*/

__declspec(naked) void GraciaF_Vehicle_ValidateLoc1()
{
	__asm {


//4484b2 +3nop
//esp 44851D 44+4

//ground vehicle
pop 	esi
push 	0 	//dummy
push 	esi 	//direction
fld 	qword ptr[ebp][-048h]
call 	MATH_FLOAT2DEC
fld 	qword ptr[ebp][-050h]
push	eax	//z
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-058h]
push	eax	//y
call 	MATH_FLOAT2DEC
mov	ecx,[ebx][018h]
mov	edx,[ebp][-040h]
push	eax	//x
push	edi	// object id
push	ecx	// object id
mov	ecx,[ebp][-03ch]
push	080h
push	FORMAT_VEHICLEG1 //cddddddd

push	4484e2h
retn

}
}

__declspec(naked) void GraciaF_Vehicle_ValidateLoc2()
{
	__asm {


//4485A5 +3nop
//esp 448611 44+4

//ground vehicle
pop 	esi
push 	0 	//dummy
push 	esi 	//direction
fld 	qword ptr[ebp][-048h]
call 	MATH_FLOAT2DEC
fld 	qword ptr[ebp][-050h]
push	eax	//z
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-058h]
push	eax	//y
call 	MATH_FLOAT2DEC
mov	ecx,[ebx][018h]
mov	edx,[ebp][-040h]
push	eax	//x
push	edi	// object id
push	ecx	// object id
mov	ecx,[ebp][-03ch]
push	080h
push	FORMAT_VEHICLEG1 //cddddddd

push	4485d5h
retn

}
}

//-----------------------------------------------
// Get On/Off Vehicle
//-----------------------------------------------




/*
		writeC(0x5c/5d); //       6e/6f
		writeD(_activeChar.getObjectId());
		writeD(_boat.getObjectId());
        writeD(_x);
        writeD(_y);
        writeD(_z);
*/

__declspec(naked) void GraciaF_Vehicle_GetOn()
{
	__asm {

//484044 +3nop
//esp 4840b3 40+4

push	0 //dummy
fld	qword ptr[esi][028h]
call 	MATH_FLOAT2DEC
fld	qword ptr[esi][020h]
push	eax	//z
call 	MATH_FLOAT2DEC
fld	qword ptr[esi][018h]
push	eax	//y
call 	MATH_FLOAT2DEC
mov	edx,[esi][014h]
mov	ecx,[ebp][-034h]
push	eax	//x
mov	eax,[edi][018h]
push	edx
mov	edx,[ebp][-030h]
push	eax
push	06eh
push	FORMAT_VEHICLEG //cdddddd

push	484074h
retn

}
}


__declspec(naked) void GraciaF_Vehicle_GetOff()
{
	__asm {

//484176 +3nop
//esp 4841e1 40+4

push	0 //dummy
fld	qword ptr[esi][028h]
call 	MATH_FLOAT2DEC
fld	qword ptr[esi][020h]
push	eax	//z
call 	MATH_FLOAT2DEC
fld	qword ptr[esi][018h]
push	eax	//y
call 	MATH_FLOAT2DEC
mov	ecx,[edi][018h]
mov	edx,[esi][018h]
push	eax	//x
mov	eax,[esi][014h]
push	eax
push	ecx
push	06fh
push	FORMAT_VEHICLEG  //cdddddd

push	4841A3h
retn

}
}


//----------------------------------------------------
// Stop Move In Vehicle
//----------------------------------------------------
/*

		writeC(0x72); //7f
		writeD(_activeChar.getObjectId());
		writeD(_boatId);
		writeD(_activeChar.getInBoatPosition().getX());
		writeD(_activeChar.getInBoatPosition().getY());
		writeD(_activeChar.getInBoatPosition().getZ());
		writeD(_activeChar.getPosition().getHeading());
*/

__declspec(naked) void GraciaF_Vehicle_StopIn()
{
	__asm {
//49e1f6 +1nop
//esp 49e271 44+4

mov	eax,[esi][00000F54h]
fld	qword ptr[ebp][-030h]
add	eax,020h
mov	[eax][02],bx
mov	eax,[eax]
push	0 	//dummy
push	eax 	//direction
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-038h]
push	eax	//z
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-040h]
push	eax	//y
call 	MATH_FLOAT2DEC
mov	ecx,[ebp][-058h]
mov	edx,[ebp][-054h]
push	eax	//x
mov	eax,[esi][018h]
push	edi
push	eax
push	07fh
push	FORMAT_VEHICLEG1  //cddddddd

push	49e236h
retn

}
}

//------------------------------------------
// Move To Location In Vehicle
//-------------------------------------------
/*
		writeC(0x71); //7e
        writeD(_charObjId);
        writeD(_boatId);
		writeD(_destination.x);
		writeD(_destination.y);
		writeD(_destination.z);
		writeD(_origin.x);
		writeD(_origin.y);
		writeD(_origin.z);

*/

__declspec(naked) void GraciaF_Vehicle_MoveToLoc1()
{
	__asm {

//49ef25 +3nop
//esp 49efbc 4C+4

push	0 //dummy
fld	qword ptr[ebp][-080h] 
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-088h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-090h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebx][020h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebx][018h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebx][010h] 
push	eax
call 	MATH_FLOAT2DEC
push	eax
lea	ecx,[ebx][-08h]
mov	eax, 04e2900h
call	eax
mov	ecx,[eax][018h]
mov	edx,[esi][018h]
push	ecx
mov	ecx,[ebp][-058h]
push	edx
mov	edx,[ebp][-054h]
push	07eh	
push	FORMAT_VEHICLEG1 //_TOLOC //cddddddddd

push	49ef81h
retn
}
}


__declspec(naked) void GraciaF_Vehicle_MoveToLoc2()
{
	__asm {

//49f3af +3nop
//esp 49f447 4c+4

push	0 //dummy
fld	qword ptr[ebp][-080h] 
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-088h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-090h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebx][020h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebx][018h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebx][010h] 
push	eax
call 	MATH_FLOAT2DEC
push	eax
lea	ecx,[ebx][-08h]
mov	eax, 04e2900h
call	eax
mov	eax,[eax][018h]
mov	ecx,[esi][018h]
mov	edx,[ebp][-058h]
push	eax
push	ecx
mov	ecx,[ebp][-054h]
push	07eh	
push	FORMAT_VEHICLEG1 //_TOLOC //cddddddddd

push	49f40bh
retn
}
}

//----------------------------------------
// Vehicle Check Location 
//----------------------------------------
/*
		writeC(0x5b); //6d
		writeD(_boat.getObjectId());
		writeD(_x);
		writeD(_y);
		writeD(_z);
		writeD(_boat.getPosition().getHeading());
*/



//////////////////////////////////////////
// S I N G L E  PACKETS
//////////////////////////////////////////

//-----------------------------------------
// Vehicle Departure (Move/Stop)
//-----------------------------------------
/*
		writeC(0x5a); //6c
		writeD(_boat.getObjectId());
		writeD(_speed1);
		writeD(_speed2);
		writeD(_x);
		writeD(_y);
		writeD(_z);

*/

__declspec(naked) void GraciaF_Vehicle_Depart()
{
	__asm {

//51A1FC +1nop
//esp 51a227 24+4

push	0	//dummy
push	eax 	//z
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-038h] 
push	eax	//y
call 	MATH_FLOAT2DEC
mov	ecx,[ebp][08h]
push	eax	//x
mov	eax,[esi][018h]
push	ebx	//speed 2
push	edi	//speed 1
push	eax	//object ID
push	06ch
push	FORMAT_VEHICLEG1 //cddddddd

push	51a21ch
retn
}
}


//-----------------------------------------------
// Get On/Off Vehicle SINGLE
//-----------------------------------------------

/*
		writeC(0x5c/5d); //       6e/6f
		writeD(_activeChar.getObjectId());
		writeD(_boat.getObjectId());
        writeD(_x);
        writeD(_y);
        writeD(_z);
*/

__declspec(naked) void GraciaF_Vehicle_GetOnS()
{
	__asm {

//484001 +0nop
//esp  484030 20+4

push	0 //dummy
//fld	qword ptr[esi][028h]
call 	MATH_FLOAT2DEC
fld	qword ptr[esi][020h]
push	eax	//z
call 	MATH_FLOAT2DEC
fld	qword ptr[esi][018h]
push	eax	//y
call 	MATH_FLOAT2DEC
mov	ecx,[edi][018h]
push	eax	//x
mov	eax,[esi][014h]
push	eax
push	ecx
push	071h
push	FORMAT_VEHICLEG //cdddddd

push	484028h
retn

}
}


__declspec(naked) void GraciaF_Vehicle_GetOffS()
{
	__asm {

//484138 +0nop
//esp 484167 20+4

push	0 //dummy
//fld	qword ptr[esi][028h]
call 	MATH_FLOAT2DEC
fld	qword ptr[esi][020h]
push	eax	//z
call 	MATH_FLOAT2DEC
fld	qword ptr[esi][018h]
push	eax	//y
call 	MATH_FLOAT2DEC
mov	ecx,[edi][018h]
push	eax	//x
mov	eax,[esi][014h]
push	eax
push	ecx
push	072h
push	FORMAT_VEHICLEG  //cdddddd

push	48415fh
retn

}
}


//------------------------------------------
// Move To Location In Vehicle Single
//-------------------------------------------


__declspec(naked) void GraciaF_Vehicle_MoveToLocS()
{
	__asm {

//49eeC9 +0nop
//esp 49ef1f 2C+10

push	0 //dummy
//fld	qword ptr[ebp][-080h] 
call 	MATH_FLOAT2DEC
fld		qword ptr[ebp][-088h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-090h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebx][020h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebx][018h] 
push	eax
call 	MATH_FLOAT2DEC
fld	qword ptr[ebx][010h] 
push	eax
call 	MATH_FLOAT2DEC
mov	ecx,[ebp][-014h]
mov	edx,[ecx][018h]
push	eax
mov	eax,[esi][018h]
push	edx
push	eax
push	089h	
push	FORMAT_VEHICLEG1 //_TOLOC //cddddddddd

push	49ef17h
retn
}
}


//----------------------------------------------------
// Stop Move In Vehicle Single
//----------------------------------------------------

__declspec(naked) void GraciaF_Vehicle_StopInS()
{
	__asm {
//49e1b1 +1nop 
//esp 49e201  20+4


push	0 	//dummy
push	ebx 	//direction
call 	MATH_FLOAT2DEC
fld		qword ptr[ebp][-038h]
push	eax	//z
call 	MATH_FLOAT2DEC
fld		qword ptr[ebp][-040h]
push	eax	//y
call 	MATH_FLOAT2DEC
mov	ecx,[ebp][-018h]
mov	edx,[esi][018h]
push	eax	//x
push	ecx
push	edx
push	08ah
push	FORMAT_VEHICLEG1  //cddddddd

push	49e1DCh
retn

}
}

//---------------------------------------
// Validate Location IN vehicle Single
//---------------------------------------

__declspec(naked) void GraciaF_Vehicle_ValidateLocS()
{
	__asm {


//4e8445 + 0nop
//esp 4e8479 24+4

//pop	eax	//direction???
push	0 //dummy
//push	eax
push	43c230h  //what is it? direction????????????????????
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-028h] 
push	eax	//z
call 	MATH_FLOAT2DEC
fld	qword ptr[ebp][-030h] 
push	eax	//y
call 	MATH_FLOAT2DEC
mov	edx,[esi][018h]
push	eax	//x
push	edi
push	edx
push	08Bh
push	FORMAT_VEHICLEG1 //cddddddd

push	4e8471h
retn

}
}


//------------------------------------------------
// Vehicle Start
//------------------------------------------------
/*
		writeC(0xba); //c0
		writeD(_boat.getObjectId());
		writeD(_state);

*/

__declspec(naked) void GraciaF_Vehicle_Start()
{
	__asm {
//51BF0A


retn
}
}



__declspec(naked) void GraciaF_VehicleInfoS()
{
	__asm {


//51a198
//esp 51a1ce 20+4
		push	0 //max fuel
		push	0 //current fuel
		push	0
		push	0
		push	0
		push	0
		push	0
		push	0
		push	0

		mov		ecx,[esi][0000080h]
		push	ecx //speed 2
//		push	0
		mov		ecx,[esi][078h]
		push	ecx //speed 1
//		push	0
		push	0 // object id of player who control ship

		push	0 //dummy

//ground vehicle
		mov		ecx,[ebp][-14h]
		fld		qword ptr[edx][010h]
		mov		edi,eax
		push	ecx //direction
		call	MATH_FLOAT2DEC
		fld		qword ptr[ebx][08h]
		push	eax //z
		call	MATH_FLOAT2DEC
		fld		qword ptr[edi]
		push	eax //y
		call	MATH_FLOAT2DEC
		mov		ecx, [ebp][08h]
		push	eax //x
		mov		eax,[esi][018h]
		push	eax //object id
		push	06Eh
		push	FORMAT_VEHICLEG2a

		push	51a1c3h
		retn



	}

}



__declspec(naked) void GraciaF_VehicleInfoS_air()
{
	__asm {


//51a198
//esp 51a1ce 20+10
//...........
//air vehicle
//...........

		push	0 //max fuel
		push	0 //current fuel
		push	0
		push	0
		push	0
		push	0
		push	0
		push	0
		push	0

		mov		ecx,[esi][0000080h]
		push	ecx //speed 2
//		push	0
		mov		ecx,[esi][078h]
		push	ecx //speed 1
//		push	0
		push	0 //// object id of player who control ship

		mov		ecx,[ebp][-14h]
		fld		qword ptr[edx][010h]
		mov		edi,eax
		push	ecx //direction
		call	MATH_FLOAT2DEC
		fld		qword ptr[ebx][08h]
		push	eax //z
		call	MATH_FLOAT2DEC
		fld		qword ptr[edi]
		push	eax //y
		call	MATH_FLOAT2DEC
		mov		ecx, [ebp][08h]
		push	eax //x
		mov		eax,[esi][018h]
		push	eax //object id
		push	060h
		push	0FEh
		push	FORMAT_VEHICLEA

		push	51a1c3h
		retn



	}

}






//////////////////////////////////////////////////////////////////////////


/*
__declspec(naked) void GraciaF_VehicleBC()
{
	__asm {


		//51a095

		fld		qword ptr[edx][010h]
		mov		edi,eax
		push	ecx //direction
		call	MATH_FLOAT2DEC
		fld		qword ptr[ebx][08h]
//		cmp		eax, -2000  //cmp z
//		jg		flyingShip

//ground vehicle
		pop		ecx
//		push	0  //dummy value
		push	ecx //direction
		push	eax //z
		call	MATH_FLOAT2DEC
		fld		qword ptr[edi]
		push	eax //y
		call	MATH_FLOAT2DEC
		mov		edx, esi

//51a0b3

		push	eax //x
		mov		eax,[esi][018h]
		push	eax //object id
		push	060h
		push	0FEh
		push	FORMAT_VEHICLE_AIR
		sub		esp, 018h 

		push	51a0c2h
		retn

	}

}


__declspec(naked) void GraciaF_Vehicle()
{
	__asm {

//51a198
//esp 51a1ce 20+4

		fld		qword ptr[edx][010h]
		mov		edi,eax
		push	ecx //direction
		call	MATH_FLOAT2DEC
		fld		qword ptr[ebx][08h]

//ground vehicle
		pop		ecx
//		push	0  //dummy value
		push	ecx //direction
		push	eax //z
		call	MATH_FLOAT2DEC
		fld		qword ptr[edi]
		push	eax //y
		call	MATH_FLOAT2DEC
		mov		ecx, [ebp][08h]
		push	eax //x
		mov		eax,[esi][018h]
		push	eax //object id
		push	060h
		push	06Eh
		push	FORMAT_VEHICLE_AIR

		push	51a1c3h
		retn



	}

}


*/