#include "L2Server.h"
#include "PacketReader.h"


PTrade GetActiveTrade(DWORD * pUser) 
{
	PTrade pTrade = NULL;
	_asm
	{
		mov		eax, pUser
		mov		eax, [eax+19BCh]
		mov		pTrade, eax
	}

	return pTrade;


}


bool checkTradeValid(PTrade pTrade) {

	PTrade pTrade2 = NULL;
	DWORD UserObj = 0;

	DWORD *pUser2 = NULL;
	UserObj = pTrade->user2_OID; //GetParameter(pTrade,0x24);
	if (UserObj != 0) {
		pUser2 = CCreature::GetCreature(UserObj);
		if (pUser2 != NULL) {
			pTrade2 = GetActiveTrade(pUser2);
			if (pTrade != pTrade2)
				return false;
		}
	}
	if (pUser2 == NULL)
		return false;


	pUser2 = NULL;
	UserObj = pTrade->user1_OID; //GetParameter(pTrade,0x20);
	if (UserObj != 0) {
		pUser2 = CCreature::GetCreature(UserObj);
		if (pUser2 != NULL) {
			pTrade2 = GetActiveTrade(pUser2);
			if (pTrade != pTrade2)
				return false;
		}
	}
	if (pUser2 == NULL)
		return false;



	return true;

}

int checkTradeItems(PTrade pTrade) //not used function
{

	

	PacketReader pCSIBuffer1((u8 *)pTrade->user1TradeItemsDataBuffer);
	PacketReader pCSIBuffer2((u8 *)pTrade->user2TradeItemsDataBuffer);
	int itemssize1=pTrade->user1ItemBufferSize;
	int itemssize2=pTrade->user2ItemBufferSize;
	int itemid1=0;
	int itemid2=0;
	int item1size=0;
	int item2size=0;
	//int items1[50];
	//int items2[50];




	for(int i=0; (i< 50) || (item1size !=itemssize1); i++)
	{
		
		pCSIBuffer1.ReadH(); //item type1
		pCSIBuffer1.ReadD(); //item object id
		itemid1 = pCSIBuffer1.ReadD();
		//items1[i] = itemid1;
		//LOG->Add(CONSOLE_LOG,"CHECK USER1 Same item trading item[%d]", itemid1 );
		if (itemid1 == 0)
					break; //all ok
		pCSIBuffer1.ReadD(); //item ammount
		pCSIBuffer1.ReadH(); //item type2
		pCSIBuffer1.ReadH(); //is Blessed
		pCSIBuffer1.ReadD(); //Body part
		pCSIBuffer1.ReadH(); //enchant
		pCSIBuffer1.ReadH(); //0 - reserved
		pCSIBuffer1.ReadH(); //0 - reserved
		item1size=item1size+28;
	}


	for(int j=0; (j< 50) || (item2size !=itemssize2) ; j++)
	{
			pCSIBuffer2.ReadH(); //item count?
			pCSIBuffer2.ReadH(); //item type1  this is D, and first is H
			pCSIBuffer2.ReadD(); //item object id
			itemid2=pCSIBuffer2.ReadD();
			//items2[j] = itemid2;
			//LOG->Add(CONSOLE_LOG,"CHECK USER2 Same item trading item[%d]", itemid2 );
			if (itemid2 == 0)
						break; 
			pCSIBuffer2.ReadD(); //item ammount
			pCSIBuffer2.ReadH(); //item type2
			pCSIBuffer2.ReadH(); //is Blessed
			pCSIBuffer2.ReadD(); //Body part
			pCSIBuffer2.ReadH(); //enchant
			pCSIBuffer2.ReadH(); //0 - reserved
			pCSIBuffer2.ReadH(); //0 - reserved
			item2size=item2size+30;

	}





	return 0;


}

//void decrementItemCount(DWORD *pUser, PTrade pTrade)
//{
//}


int TradeAddItem(DWORD *pUser, PTrade pTrade, DWORD addItemObjID, DWORD addItemID) 
{
	
	if (GetParameter(pUser,24) == pTrade->user1_OID) {

		//we will ad to first user
		if (pTrade->smeliCustomTradeItems1Count >60) return 1;


		pTrade->smeliCustomTradeItems1Count++;
		pTrade->smeliCustomTradeItems1DataBuffer[pTrade->smeliCustomTradeItems1Count].class_id=addItemID;
		pTrade->smeliCustomTradeItems1DataBuffer[pTrade->smeliCustomTradeItems1Count].object_id=addItemObjID;
		
		if (checkTradeItems4Confirm(pTrade) > 0)
		{
			pTrade->smeliCustomTradeItems1Count--;
			return 2;
		}

		for(int i=1; (i<= pTrade->smeliCustomTradeItems1Count) ; i++)
		{

			for(int j=i+1; (j<= pTrade->smeliCustomTradeItems1Count)  ; j++)
			{
				if ((pTrade->smeliCustomTradeItems1DataBuffer[i].object_id == pTrade->smeliCustomTradeItems1DataBuffer[j].object_id) )
				{
					pTrade->smeliCustomTradeItems1Count--;
					return 3;

				}
			}
		}


	} else {

		//we will ad to second user
		if (pTrade->smeliCustomTradeItems2Count >60) return 1;
		pTrade->smeliCustomTradeItems2Count++;
		pTrade->smeliCustomTradeItems2DataBuffer[pTrade->smeliCustomTradeItems2Count].class_id=addItemID;
		pTrade->smeliCustomTradeItems2DataBuffer[pTrade->smeliCustomTradeItems2Count].object_id=addItemObjID;
		
		if (checkTradeItems4Confirm(pTrade) > 0)
		{
			pTrade->smeliCustomTradeItems2Count--;
			return 2;
		}

		for(int i=1; (i<= pTrade->smeliCustomTradeItems2Count) ; i++)
		{

			for(int j=i+1; (j<= pTrade->smeliCustomTradeItems2Count)  ; j++)
			{
				if ((pTrade->smeliCustomTradeItems2DataBuffer[i].object_id == pTrade->smeliCustomTradeItems2DataBuffer[j].object_id) )
				{
					pTrade->smeliCustomTradeItems2Count--;
					return 3;

				}
			}
		}

	}





	return 0;
}

int checkTradeItems4Confirm(PTrade pTrade)
{
//not allow users to exchange the same items


	for(int i=1; (i<= pTrade->smeliCustomTradeItems1Count) ; i++)
	{

		for(int j=1; (j<= pTrade->smeliCustomTradeItems2Count)  ; j++)
		{
			if ((pTrade->smeliCustomTradeItems1DataBuffer[i].class_id == pTrade->smeliCustomTradeItems2DataBuffer[j].class_id) ||
				(pTrade->smeliCustomTradeItems1DataBuffer[i].object_id == pTrade->smeliCustomTradeItems2DataBuffer[j].object_id) )
			{
				return 1;

			}
		}
	}

return 0;
}


//[PTRADE+0h]  //80 33 4E 00 "A3N";; off_5B9C38  trade memory address?

//[PTRADE+4h] //trade ID
//[PTRADE+8h] //InterlockedIncrement ?
//[PTRADE+Ch] //unknown?
//[PTRADE+10h] trade id?
//[PTRADE+14h] trade id?
//[PTRADE+18h] trade id?

//[PTRADE+1Ch] = trade request timer

//[PTRADE+20h] = trade request user1 OID
//[PTRADE+24h] = trade request user2 OID
//[PTRADE+28h] unknown? trade ID??????????????????

//[PTRADE+2Ch] = trade inventory1 user1???
//[PTRADE+30h] = trade inventory2 user1???

//[PTRADE+3Ch] = trade inventory1 user2???
//[PTRADE+40h] = trade inventory2 user2???

//[PTRADE+48h] = trade is MY confirmed status
//[PTRADE+49h] = trade is OTHER confirmed status
//[PTRADE+4Ah] = trade list was sent status
//[PTRADE+4Bh] = trade active status = 1???

//[PTRADE+4Ch] = trade MY buffer? {max buffer 2000h}
//[PTRADE+204Ch] = trade MY buffer?  {max buffer 2000h}
//[PTRADE+404Ch] = trade MY buffer size?
//[PTRADE+4050h] = trade OTHER buffer size?
//[PTRADE+4054h] = trade critical section?

/*
trade buffer structure: hdddhhdhhh
		writeH(type); // item type1
		writeD(temp.getObjectId());
		writeD(temp.getItemId());
		writeD(_amount);
		writeH(temp.getItem().getType2());	// item type2
		writeH(0x00);	//isBlessed

		writeD(temp.getItem().getBodyPart());	// rev 415  slot    0006-lr.ear  0008-neck  0030-lr.finger  0040-head  0080-??  0100-l.hand  0200-gloves  0400-chest  0800-pants  1000-feet  2000-??  4000-r.hand  8000-r.hand
		writeH(temp.getEnchantLevel());	// enchant level
		writeH(0x00);	// reserved, not used in server
		writeH(0x00);   // reserved not used in server


*/
