/*
 * Lineage II Extension Project - Affectionately known as the L2EP 'Elhaym' Project/DLL
 * Property of Michael Sadlon a.k.a. mcrabben7 [mcrabben7@gmail.com]
 * Team Effort along with RipperX, Annatar, Nevyn, and with some help from others.
 * 
 * The goals of this project are to expand the aging Lineage II Chronicle 1 server
 * to support the functionality in C3 and C4, and is made to work with the C4 client.
 * 
 * This project is open-source.  It is released from time to time by our discretion.
 * Anyone who has this code, or this DLL, and chooses to use it or learn from it frees
 * us from ALL liabilities.  USE AT YOUR OWN RISK.
 * 
 * I have chosen to release this (you can read the license in License.txt) with the caveat
 * that you may NOT sell our work, any derivative of our work, or make a profit in any way
 * related to our work or a derivative of our work WITHOUT OUR EXPRESS PERMISSION.
 * 
 * Please see License.txt for the full details.  Make sure you READ it!
 */

//disable the pesky typecast warning for this file
#pragma warning(disable: 4312)
//disable double o dword conversion warning for this file
#pragma warning(disable: 4244)
#pragma warning(disable: 4018) //signed/unsigned

#include "CombatPoints.h"
#include "memoryFuncs.h"
//#include "UserCommand.h"


//#include <ctime>
#include <math.h>

#ifndef M_PI
    #define M_PI 3.14159265358979323846
#endif
//extern void RefreshAutoSS(DWORD * pSocket, WORD itemID);
//extern BYTE L2_CHRONICLE;


//antipk protection levels
int pr_level = 50;
int pr_level_diff = 20;
int box_train_limit=3; //10 = no limits
int max_dagger_damage = 2000;
double extraDMGpercent_energy=0.2; //10% add for energy attacks for every extra energy saved 
//effect for gladiators and tyrants (set it to 0 for original c1)



int status_awake1=0; //show hp regeneration?
int status_awake2=1; //show mp regeneration?

//--------------------------------------------------------------------------------------------
//// Function Hooks
//--------------------------------------------------------------------------------------------

//1. 448925
//2. 448946
//3. 4489a8
//4. 44f5d6 hp only

//a. check player or NPC.
//b. for NPC if current HP is at certain amount, send HP status 0
//bots will stop attack and go away to second mob
//but mob is still alive and will continue.....

/*
int GetWeaponID(DWORD * pUser, PTCharBaseData CSharedDat)
{
			
				if (CSharedDat->nObjIdRHand == 0) return -1;

				DWORD * pUserInventory = GetUserInventory(pUser);
				if (pUserInventory != NULL) {

					//FindByServerID //object id
					DWORD *pItem = CInventory::FindByIndex(pUserInventory, CSharedDat->nObjIdRHand); 
					if (pItem != NULL) {
							PItemData itmdata = (PItemData)GetSharedData2(pItem);
							return itmdata->m_nClassId;
					} else return -3;
				} else return -2;
				return 0;

}
*/

int critical_power_dmg(DWORD* pAttacker,int multiplier)
{
								int dmg = 0;
								int bufflevel  =user_get_skill_level(pAttacker,193,6); 
								
								if (bufflevel > 0) {	
									 switch(bufflevel)
									 {
										case 1:
											dmg = (20*multiplier);
											break;
										case 2:
											dmg = (26*multiplier);
											break;
										case 3:
											dmg = (33*multiplier);
											break;
										case 4:
											dmg = (39*multiplier);
											break;
										case 5:
											dmg = (45*multiplier);
											break;
										case 6:
											dmg = (51*multiplier);
											break;
									 }
									
}
	return dmg;

}

int vicious_stance_dmg(DWORD* pAttacker,int multiplier1)
{

	int multiplier=multiplier1;
PTCharBaseData CSharedDatA = (PTCharBaseData)GetSharedData(pAttacker);	
if ( (FindBuffINSharedData(pAttacker,CSharedDatA, 112) == 10) && (multiplier>1) ) multiplier++;

								int dmg = 0;
								int bufflevel = user_get_skill_levelToggleON(pAttacker,312);
								if ( bufflevel== 1) //vicious stance is on
								{
									bufflevel  =user_get_skill_level(pAttacker,312,20); //vicious stance level
								
										
									 switch(bufflevel)
									 {
										case 1:
											dmg = (35*multiplier);
											break;
										case 2:
											dmg = (48*multiplier);
											break;
										case 3:
											dmg = (64*multiplier);
											break;
										case 4:
											dmg = (84*multiplier);
											break;
										case 5:
											dmg = (109*multiplier);
											break;
										case 6:
											dmg = (139*multiplier);
											break;
										case 7:
											dmg = (166*multiplier);
											break;
										case 8:
											dmg = (196*multiplier);
											break;
										case 9:
											dmg = (229*multiplier);
											break;
										case 10:
											dmg = (266*multiplier);
											break;
										case 11:
											dmg = (306*multiplier);
											break;
										case 12:
											dmg = (349*multiplier);
											break;
										case 13:
											dmg = (379*multiplier);
											break;
										case 14:
											dmg = (410*multiplier);
											break;
										case 15:
											dmg = (443*multiplier);
											break;
										case 16:
											dmg = (475*multiplier);
											break;
										case 17:
											dmg = (509*multiplier);
											break;
										case 18:
											dmg = (542*multiplier);
											break;
										case 19:
											dmg = (576*multiplier);
											break;
										case 20:
											dmg = (609*multiplier);
											break;



									 }
									
								}

	return dmg/2; //  divide by 2 cause reduced twice in skilldata
}


int critical_damage_dmg(DWORD* pAttacker,int multiplier)
{
						int dmg = 0;
						int bufflevel=user_get_skill_levelToggleON(pAttacker,343);	//3043 dagger critical damage toggle SA
						if (bufflevel ==1 ) {
							bufflevel  =CCreature::GetItemSkillParameter(pAttacker,343,0x10); //3043 dagger critical damage toggle SA

								switch(bufflevel)
								{
										case 1:
											dmg = (107*multiplier);
											break;
										case 2:
											dmg = (118*multiplier);
											break;
										case 3:
											dmg = (130*multiplier);
											break;
										case 4:
											dmg = (141*multiplier);
											break;
										case 5:
											dmg = (151*multiplier);
											break;
										case 6:
											dmg = (160*multiplier);
											break;
										case 7:
											dmg = (201*multiplier);
											break;
										case 8:
											dmg = (265*multiplier);
											break;
										default:
											dmg = (200*multiplier);
											break;

								}
						}
	return dmg;

}


//I would recommend using -D_USE_MATH_DEFINES or /D_USE_MATH_DEFINES depending on your compiler.
int j_getHeadingTo(int _heading, int _x, int _y, int heading2, int x2, int y2, bool toChar)
	{

		long double dx = x2 - _x;
		long double dy = y2 - _y;
		int heading = (int) (atan2(-dy, -dx) * 32768.0 / M_PI + 32768);

		heading = toChar ? heading2 - heading : _heading - heading;

		if(heading < 0)
			heading += 65536;
		return heading;
	}

bool j_isBehindTarget(int _heading, int _x, int _y, int heading2, int x2, int y2)
	{
			int head = j_getHeadingTo(_heading, _x, _y, heading2, x2,y2,true);
			return head != -1 && (head <= 10430 || head >= 55105);
	}

bool j_isInFront(int _heading, int _x, int _y, int heading2, int x2, int y2, int degrees)
	{
			int head = j_getHeadingTo(_heading, _x, _y, heading2, x2,y2,false);
			return head <= 32768 * degrees / 180 || head >= 65536 - 32768 * degrees / 180;
	}

/*
bool IsBackPosition(int pos1a, int pos2a)
{

//positions are -32768 to 32768
	//so juzt add it
int pos1 = pos1a+32768;
int pos2 = pos2a+32768;

	if (pos1>49152 && pos2<16384) 
	{
		if (abs((65536-pos2)-(pos1-16384)) > 16000) return false;

	} else if  (pos2>49152 && pos1<16384) 
	{
		if (abs((65536-pos1)-(pos2-16384)) > 16000) return false;

	} else 
	{
		if (abs(pos1-pos2) > 16000) return false;
	}
	

	return true;

}
*/

bool IsPet(int nclassid)
{
	if (
			(nclassid == 1012077) 
		|| (nclassid == 1012311) || (nclassid == 1012312) || (nclassid == 1012313)
		|| (nclassid == 1012526) || (nclassid == 1012527) || (nclassid == 1012528)
	) return true;
	return false;
}

bool IsSummon(int nclassid)
{
	if (
				//c1 summons
				(nclassid == 1012006 || nclassid == 1012007 || nclassid == 1012008) ||
				(nclassid > 1012060 && nclassid < 1012076) ||
				(nclassid > 1012174 && nclassid < 1012184) ||
				(nclassid > 1012174 && nclassid < 1012184) ||
				(nclassid > 1012343 && nclassid < 1012371) ||
				(nclassid > 1012410 && nclassid < 1012465) ||
				//c4 summons
				(nclassid > 1014110 && nclassid < 1014663) ||
				//c6 summons
				(nclassid > 1014835 && nclassid < 1014839) ||
				//c2 summons
				(nclassid > 1012476 && nclassid < 1012516) 



		) return true;
	return false;
}


static const wchar_t *fnCombatPonts001=L"Elhaym::int CheckHP(DWORD *pCreature, DWORD statustype, DWORD statusammount, DWORD isBroadcast)";
int CheckHP(DWORD *pCreature, DWORD statustype, DWORD statusammount, DWORD isBroadcast)
{

try { _set_se_translator( trans_func );

	if (pCreature == NULL) return 0;

	PTCharBaseData CSharedDat= (PTCharBaseData)GetSharedData(pCreature);
	if (CSharedDat == NULL) return 0;

	if (CSharedDat->nIsPC == 1) {
		//do not return, party users get update via SmallWindowUpdate packet          if ((isBroadcast > 0) && (CSharedDat->m_pParty > 0)) return 1;
		//return 1;
	}

 return 0; 


} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts001,0);
   throw;       // Pass exception to some other handler
}

}



///////////////////////////////////////
// Status update AWAKENING
///////////////////////////////////////

//static const char * FORMAT_STATUS_AWAKENING1 = "cdddddd";

//single send
__declspec(naked) void Awakening_StatusUpdate1()
{
	__asm
	{
		//448920
/*
		cmp ebx,9 //current HP
		jl done
		cmp ebx,0Ch //max MP
		jg done

		//now in ESI we have pUser
		pushad
			push 0
			push edi //status ammount
			push ebx //status type
			push esi //pUser
			call CheckHP
			add esp,16
			cmp	eax,0
			je all_ok

		popad
		mov	edi,0 //0 as status value
		jmp short done

all_ok:
		popad
done:
*/

		cmp ebx,0x1b //status karma
		jl done_gd
		neg edi //negative karma
done_gd:


		push	edi 		//value of status update
		push	ebx 		//status update parameter: 09h - curr HP; 0ah - max HP;  0bh - cur MP; 0ch - max MP; 01h - level;
		push    001			//how many parameters

		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening
		    
		push    ecx //objectID



			push	448925h
			retn
	}
}

__declspec(naked) void Awakening_StatusUpdate2()
{
	__asm
	{
//44893e

		cmp ebx,9 //current HP
		jl done
		cmp ebx,0Ch //max MP
		jg done


		//now in ESI we have pUser
		pushad

		push 1
		push edi //status ammount
		push ebx //status type
		push esi //pUser
		call CheckHP
		add esp,16
		cmp	eax,0
		je all_ok

		popad
		mov	edi,0 //0 as status value
		jmp short done

all_ok:
		popad
done:
		

		cmp ebx,0x1b //status karma
		jl done_gd
		neg edi //negative karma
done_gd:


		mov	esi,[esi+18h]	//const DWORD OBJECT_ID = 24;	//0x18
		push	edi 		//value of status update
		push	ebx 		//status update parameter: 09h - curr HP; 0ah - max HP;  0bh - cur MP; 0ch - max MP; 01h - level;

		push	001		//parameters count

		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening

		push	esi //object ID

		push	448946h
		retn
	}
}

__declspec(naked) void Awakening_StatusUpdate3()
{
	__asm
	{
//44899f

		cmp ebx,9 //current HP
		jl done
		cmp ebx,0Ch //max MP
		jg done

		//now in ESI we have pUser
		pushad
			push 2
			push edi //status ammount
			push ebx //status type
			push esi //pUser
			call CheckHP
			add esp,16
			cmp	eax,0
			je all_ok

		popad
		mov	edi,0 //0 as status value
		jmp short done

all_ok:
		popad
done:

		cmp ebx,0x1b //status karma
		jl done_gd
		neg edi //negative karma
done_gd:

		mov	edx,[esp+014h]
		push	edi 		//value of status update
		push	ebx 		//status update parameter: 09h - curr HP; 0ah - max HP;  0bh - cur MP; 0ch - max MP; 01h - level;

		push	001		//parameters count

		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening

		push	eax //objectID

		push	4489a8h
		retn

	}
}

__declspec(naked) void Awakening_StatusUpdate4() //status current hp
{
	__asm
	{
//44f5d0
		//now in EBX we have pUser

		pushad
			push 3
			push eax //status ammount
			push 9 //status type HP
			push ebx //pUser
			call CheckHP
			add esp,16
			cmp	eax,0
			je all_ok

		popad
		mov	eax,0 //0 as status value
		jmp short done

all_ok:
		popad
done:




		push	eax
		push	009h 		//status parameter Current HP
		push	001h		// how many parameters will be processed


		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening

		push	esi //object id

		push	44f5d6h
		retn
	}
}


//4b5282 MP status + 1 nop
//format2: 4B5294
//esp 4b52A0 24->2C
__declspec(naked) void Awakening_StatusUpdate5() 
{
	__asm
	{
		push	ecx //max MP
		push	00Ch
		push	edx //curr MP
		push	00Bh
		mov		edi,[edi][000019B8h]
		push	002

		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening

		push	ebx //object id
		push	01Ah
		push	FORMAT_STATUSU_Awake2
		push	edi
		call	CSOCKET_SEND
		add		esp,2Ch

		push	4B52A1h
		retn


	}
}

//4E83D6 + 1 nop
//format2: 4e83e5
//esp 4E83F1 24->2C
__declspec(naked) void Awakening_StatusUpdate6()
{
	__asm
	{
			push	eax //curr HP
			mov		eax,[ebp][0Ch]
			push	009h
			push	eax //max HP
			push	00Ah
			push	002

		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening

			push	edx //object id
		push	01Ah
		push	FORMAT_STATUSU_Awake2
		push	ecx
		call	CSOCKET_SEND
		add		esp,2Ch


			push	4E83F2h
			retn



	}

}

//4EC359 + 1 nop
//format2: 4EC365
//esp 4EC371 24->2C
__declspec(naked) void Awakening_StatusUpdate7()
{
	__asm
	{
		push	ecx //max hp
		push	00Ah
		push	eax //curr hp
		push	009h
		push	002

		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening

		push	edx //object id
		push	01Ah
		push	FORMAT_STATUSU_Awake2
		push	ebx
		call	CSOCKET_SEND
		add		esp,2Ch

		push	4EC372h
		retn


	}

}

//4EC422 + 2 nop
//format2: 4EC459
//esp 4EC443 24->2C
__declspec(naked) void Awakening_StatusUpdate8()
{
	__asm
	{
		push	ebx //max MP
		push	00Ch
		push	eax //curr MP
		mov		eax,[esi][18h]
		push	00Bh
		push	002

		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening

		push	eax //object id
		mov		eax,[esi][000019B8h]
		push	01Ah
		push	FORMAT_STATUSU_Awake2
		push	eax
		call	CSOCKET_SEND
		add		esp,2Ch

		push	4EC444h
		retn


	}

}


//4b5282 MP status + 1 nop
//format2: 4B5294
//esp 4b52A0 24->2C
__declspec(naked) void Lind558_StatusUpdate5() 
{
	__asm
	{
		push	ecx //max MP
		push	00Ch
		push	edx //curr MP
		push	00Bh
		mov		edi,[edi][000019B8h]
		push	002

		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening

		push	ebx //object id
		push	01Ah
		push	FORMAT_STATUSU_Lind558_2
		push	edi
		call	CSOCKET_SEND
		add		esp,2Ch

		push	4B52A1h
		retn


	}
}

//4E83D6 + 1 nop
//format2: 4e83e5
//esp 4E83F1 24->2C
__declspec(naked) void Lind558_StatusUpdate6()
{
	__asm
	{
			push	eax //curr HP
			mov		eax,[ebp][0Ch]
			push	009h
			push	eax //max HP
			push	00Ah
			push	002

		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening

			push	edx //object id
		push	01Ah
		push	FORMAT_STATUSU_Lind558_2
		push	ecx
		call	CSOCKET_SEND
		add		esp,2Ch


			push	4E83F2h
			retn



	}

}

//4EC359 + 1 nop
//format2: 4EC365
//esp 4EC371 24->2C
__declspec(naked) void Lind558_StatusUpdate7()
{
	__asm
	{
		push	ecx //max hp
		push	00Ah
		push	eax //curr hp
		push	009h
		push	002

		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening

		push	edx //object id
		push	01Ah
		push	FORMAT_STATUSU_Lind558_2
		push	ebx
		call	CSOCKET_SEND
		add		esp,2Ch

		push	4EC372h
		retn


	}

}

//4EC422 + 2 nop
//format2: 4EC459
//esp 4EC443 24->2C
__declspec(naked) void Lind558_StatusUpdate8()
{
	__asm
	{
		push	ebx //max MP
		push	00Ch
		push	eax //curr MP
		mov		eax,[esi][18h]
		push	00Bh
		push	002

		push	status_awake2  //d, Awakening
		push	status_awake1  //d, Awakening

		push	eax //object id
		mov		eax,[esi][000019B8h]
		push	01Ah
		push	FORMAT_STATUSU_Lind558_2
		push	eax
		call	CSOCKET_SEND
		add		esp,2Ch

		push	4EC444h
		retn


	}

}


//////////////////////////////////
// Status update preaw broadcasts
//////////////////////////////////

__declspec(naked) void StatusUpdate2()
{
	__asm
	{
//44893e

		cmp ebx,9 //current HP
		jl done
		cmp ebx,0Ch //max MP
		jg done


		//now in ESI we have pUser
		pushad

		push 1
		push edi //status ammount
		push ebx //status type
		push esi //pUser
		call CheckHP
		add esp,16
		cmp	eax,0
		je all_ok

		popad
		mov	edi,0 //0 as status value
		jmp short done

all_ok:
		popad
done:



		mov	esi,[esi+18h]	//const DWORD OBJECT_ID = 24;	//0x18
		push	edi 		//value of status update
		push	ebx 		//status update parameter: 09h - curr HP; 0ah - max HP;  0bh - cur MP; 0ch - max MP; 01h - level;

		push	001		//parameters count

		//push	status_awake2  //d, Awakening
		//push	status_awake1  //d, Awakening

		push	esi //object ID

		push	448946h
		retn
	}
}

__declspec(naked) void StatusUpdate3()
{
	__asm
	{
//44899f

		cmp ebx,9 //current HP
		jl done
		cmp ebx,0Ch //max MP
		jg done

		//now in ESI we have pUser
		pushad
			push 2
			push edi //status ammount
			push ebx //status type
			push esi //pUser
			call CheckHP
			add esp,16
			cmp	eax,0
			je all_ok

		popad
		mov	edi,0 //0 as status value
		jmp short done

all_ok:
		popad
done:

		mov	edx,[esp+014h]
		push	edi 		//value of status update
		push	ebx 		//status update parameter: 09h - curr HP; 0ah - max HP;  0bh - cur MP; 0ch - max MP; 01h - level;

		push	001		//parameters count

		//push	status_awake2  //d, Awakening
		//push	status_awake1  //d, Awakening

		push	eax //objectID

		push	4489a8h
		retn

	}
}

__declspec(naked) void StatusUpdate4()
{
	__asm
	{
//44f5d0
		//now in EBX we have pUser

		pushad
			push 3
			push eax //status ammount
			push 9 //status type HP
			push ebx //pUser
			call CheckHP
			add esp,16
			cmp	eax,0
			je all_ok

		popad
		mov	eax,0 //0 as status value
		jmp short done

all_ok:
		popad
done:


		push	eax
		push	009h 		//status parameter Current HP
		push	001h		// how many parameters will be processed


//		push	status_awake2  //d, Awakening
//		push	status_awake1  //d, Awakening

		push	esi //object id

		push	44f5d6h
		retn
	}
}


//4d6b90	CSkillEffect_i_energy_attack::Instant(CCreature *pSkillUser, CObject *pTarget, CSkillInfo *pSki..)
__declspec(naked) void CSkillEffect_i_energy_attack()
{

	//4d6d16 +1 nop

	__asm
	{

		pushad
		mov		ecx,[ebp][-24h]
		push	001 //what4
		push	ecx //what3
		lea		edx,[ebp][-28h] //pdamage
		push	edx
		push	edi	//caster-attacker

		mov		ecx,[ebp][08h]
		push	ecx //pREALtarget
		call CombatPointsDamageSkillEnergy
		add		esp,20

		popad


//restore
		mov		eax,[ebp][-24h]
		mov		ecx,[ebp][08h]

		push	04d6d1ch
		retn




	}

}


//4d70b0	CSkillEffect_i_death_link::Instant()
__declspec(naked) void CSkillEffect_i_death_link()
{

	//4d749c +1 nop

	__asm
	{

		pushad
		mov		ecx,[ebp][-24h]
		push	001 //what4
		push	ecx //what3
		lea		edx,[ebp][-28h] //pdamage
		push	edx
		push	esi	//caster-attacker
		push	ebx //pREALtarget
		call CombatPointsDamageMagic
		add		esp,20

		popad


//restore
		mov	ecx,[ebp][-24h]
		mov	edx,[ebp][-28h]

		push	04d74a2h
		retn




	}

}


//4db600	CSkillEffect_i_p_attack::Instant
__declspec(naked) void CSkillEffect_i_p_attack()
{

//4DB795 + 1 NOP

	__asm
	{

		pushad
		mov		ecx,[ebp][-20h]
		push	001 //what4
		push	ecx //what3
		mov		ecx,[ebp][08h] //caster
		lea		edx,[ebp][-24h] //pdamage
		push	edx
		push	ecx	//caster-attacker
		push	ebx //pREALtarget
		call CombatPointsDamageSkillPhysical
		add		esp,20

		popad


//restore
		mov	ecx,[ebp][-20h]
		mov	edx,[ebp][-24h]

		push	04db79bh
		retn


	}

}


//4dbc50	CSkillEffect_i_fatal_blow::Instant()
__declspec(naked) void CSkillEffect_i_fatal_blow()
{

	//4dbdc1 +1 nop

	__asm
	{

		pushad
		mov		ecx,[ebp][-34h]
		push	001 //what4
		push	ecx //what3
		lea		edx,[ebp][-38h] //pdamage
		push	edx
		push	esi	//caster-attacker
		push	edi //pREALtarget
		call CombatPointsDamagePhysicalFatal
		add		esp,20

		popad


//restore
		mov	ecx,[ebp][-34h]
		mov	edx,[ebp][-38h]

		push	04dbdc7h
		retn




	}

}


//4dbe30	CSkillEffect_i_hp_drain
__declspec(naked) void CSkillEffect_i_hp_drain()
{

	//4dc12d +1 nop

	__asm
	{

		pushad
		mov		ecx,[ebp][-1ch]
		push	001 //what4
		push	ecx //what3
		lea		edx,[ebp][-20h] //pdamage
		push	edx
		push	edi	//caster-attacker
		push	ebx //pREALtarget
		call CombatPointsDamageMagicAttack
		add		esp,20

		popad


//restore
		mov	eax,[ebp][-1ch]
		mov	ecx,[ebp][-20h]

		push	04dc133h
		retn




	}
}

//4dc1a0	CSkillEffect_i_m_attack::Instant()
__declspec(naked) void CSkillEffect_i_m_attack()
{

	//4dc54c +1 nop

	__asm
	{

		pushad
		mov		ecx,[ebp][-24h]
		push	001 //what4
		push	ecx //what3
		lea		edx,[ebp][-28h] //pdamage
		push	edx
		push	esi	//caster-attacker
		push	ebx //pREALtarget
		call CombatPointsDamageMagicAttack
		add		esp,20

		popad


//restore
		mov	ecx,[ebp][-24h]
		mov	edx,[ebp][-28h]

		push	04dc552h
		retn




	}

}



//4dcfe0	CSkillEffect_i_backstab::Instant()
__declspec(naked) void CSkillEffect_i_backstab()
{

	//4dd1cb +1 nop

	__asm
	{

		pushad
		mov		ecx,[ebp][-38h]
		push	001 //what4
		push	ecx //what3
		lea		edx,[ebp][-3Ch] //pdamage
		push	edx
		push	esi	//caster-attacker
		push	ebx //pREALtarget
		call CombatPointsDamageMagicBackstab
		add		esp,20

		popad


//restore
		mov	ecx,[ebp][-38h]
		mov	edx,[ebp][-3Ch]

		push	04dd1d1h
		retn




	}

}

//4db820	CSkillEffect_i_p_attack_over_hit::instant_1
//	ebp+8 = caster
//  ebp+c = target
//53dcb0 - CriticalSection Lock
//53dd10 - CriticalSection UnLock

__declspec(naked) void CSkillEffect_i_p_attack_over_hit()
{

//4DB9AD + 1 NOP

	__asm
	{

		pushad
		mov		ecx,[ebp][-20h]
		push	007 //what4
		push	ecx //what3
		mov		ecx,[ebp][08h] //caster
				//mov	edx,[ebp][-24h]
				//push	edx //damage
		lea		edx,[ebp][-24h] //pdamage
		push	edx
		push	ecx	//caster-attacker
				//mov		ecx,ebx
		//mov		ecx,[ebp][0Ch] //ptarget
		//push	ecx
		push	ebx //pREALtarget
		call CombatPointsDamageSkillPhysical
		add		esp,20

		popad


//restore
		mov	ecx,[ebp][-20h]
		mov	edx,[ebp][-24h]
		mov	eax,[ebx]

		push	04db9b3h
		retn


	}

}



//4d7940	CSkillEffect_i_cub_m_attack::Instant()
__declspec(naked) void CSkillEffect_i_cub_m_attack()
{

//4D7a36 + 1 NOP

	__asm
	{

		pushad
		mov		ecx,[ebp][-20h]
		push	001 //what4
		push	ecx //what3
		mov		ecx,[ebp][08h] //caster
		lea		edx,[ebp][-24h] //pdamage
		push	edx
		push	ecx	//caster-attacker
		push	ebx //pREALtarget
		call CombatPointsDamageMagic
		add		esp,20

		popad


//restore
		mov	eax,[ebp][-20h]
		mov	ecx,[ebp][-24h]

		push	04d7a3Ch
		retn


	}

}



//4d7ac0	CSkillEffect_i_cub_hp_drain::Instant()
__declspec(naked) void CSkillEffect_i_cub_hp_drain()
{

	//4d7b60 +1 nop

	__asm
	{
		pop eax

		pushad
		mov		ecx,[ebp][-1ch]
		push	001 //what4
		push	ecx //what3
		lea		edx,[ebp][-20h] //pdamage
		push	edx
		push	edi	//caster-attacker
		push	esi //pREALtarget
		call CombatPointsDamageMagic
		add		esp,20

		popad


//restore
		mov	eax,[ebp][-1ch]
		mov	ecx,[ebp][-20h]
		push 001

		push	04d7b66h
		retn




	}

}


__declspec(naked) void CSkillEffect_t_hp__Tick()
{

//.text:004DA9E5 call    sub_44A770 //damage contribution
// 4DA96e + 0 nop
	__asm {

		pushad



			mov	edi, [ebp][08h] //edi is our pUser (who got damage)
			test edi, edi
			jz short done

			lea		edx,[ebp][0Ch] //pdamage
			push	edx
			push	0 //pAttacker (null)
			push	edi //pUser
			
			call	CombatPointsDamagePoison
			add		esp,12


done:			 
		popad




		mov	edi, [ebp][08h] 
		test edi, edi

		push 04da973h
		retn

	}

}


__declspec(naked) void CSkillEffect_t_cub_hp__Tick()
{


// 4DAA4D + 0 nop
	__asm {

		pushad



			mov	edi, [ebp][08h] //edi is our pUser (who gaving damage)
			test edi, edi
			jz short done

			lea		edx,[ebp][0Ch] //pdamage
			push	edx
			push	0 //pAttacker (null)
			push	edi //pUser
			
			call	CombatPointsDamagePoison
			add		esp,12


done:			 
		popad




		mov	esi, [ebp][08h] 
		test esi, esi

		push 04DAA52h
		retn

	}

}
////////////////////////////////////////////////////////////////////////////////
//reflect damage
////////////////////////////////////////////////////////////////////////////////
static const wchar_t *fn_damage_shield_bug_fix1=L"Elhaym::damage_shield_bug_fix1 summon/pet:[%s] hp<300, master:[%s]";
int damage_shield_bug_fix(DWORD *pAttacker, PTCharBaseData CSharedDatA, PTCharBaseData CSharedDat)
{

	if ((CSharedDat == NULL) )
	{
		return 0;
	}

	if ((CSharedDatA == NULL))
	{
		return 0;
	}

	if (CSharedDatA->m_nClassId < 1012002)
	{
		return 1;
	}

	if ((CSharedDatA->m_nPvPflag1 != 0) || (CSharedDatA->nKarma != 0))
	{
		return 1;
	}

	if ((CSharedDat->nIsPC == 1) || IsSummon(CSharedDat->m_nClassId) || IsPet(CSharedDat->m_nClassId)  )
	{


		if (IsSummon(CSharedDatA->m_nClassId) || IsPet(CSharedDatA->m_nClassId))
		{
			//situation:
			// offender casts reflect damage on victim PC or summon
			//then offender sends his summon with low HP to attack victim
			//reflect damage works before PVP flag is triggered
			//and if offender summon is killed, victim becomes PK+karma
			if (CSharedDatA->fHP < 300) {
				CSharedDatA->m_nPvPflag1 = 1;
				PTCharBaseData CSharedDatAM = CSharedDatA;
				DWORD *master= CCreature::GetMaster(pAttacker);
				if (master != NULL) {
					CSharedDatAM = (PTCharBaseData)GetSharedData(master);
				}

				__asm {
		mov		ebx, CSharedDatAM
		add		ebx,0A0h //name of creature or master
		push	ebx
		mov		ebx, CSharedDatA
		add		ebx,0A0h //name of creature
		push	ebx
		push	fn_damage_shield_bug_fix1
		push	0 //black collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 14h
				}


				return 0;
			}
		}
	}


 return 1; //all ok
}

//43D070 + 3 nop
//static const wchar_t *fnCreatureAttackedBy_DamageShield1=L"Elhaym::CreatureAttackedBy_DamageShield [%s]";
__declspec(naked) void CreatureAttackedBy_DamageShield()
{
	__asm {
		//edi - attacker
		//esi - target
		mov edx, [edi][0F54h]	
		mov	eax, [edx][06Ch] //ispc
		cmp		eax,1
		je		done

				mov		eax,[edx][0364h] //STR atribute, bosses have it 41+
				cmp		eax,41
				jl reflect_check1
				mov	eax,43D08Eh //no damage reflect on epics and raids
				jmp eax

reflect_check1:

pushad
	
	push [esi][0F54h] //target shared data
	push [edi][0F54h] //attacker shared data
	push edi //attacker
	call damage_shield_bug_fix
	add	esp,12
popad

done:

		mov     edx, [edi]
		fmul    qword ptr [esi+198h] //reflect damage skill value

		push	43D078h
		retn


	}
}


//4d99bf + 2nop
//static const wchar_t *fnCSkillEffect_p_damage_shield_Check1=L"Elhaym::CSkillEffect_p_damage_shield_Check [%s]";
//static const wchar_t *fnCSkillEffect_p_damage_shield_Pump1=L"Elhaym::CSkillEffect_p_damage_shield_Pump [%s]";

__declspec(naked) void CSkillEffect_p_damage_shield_Check()
{
	__asm {

				mov ecx, [esi][0F54h] //creature with reflect damage buff shareddata
				mov	eax,ecx
//
               mov     eax, [esi]
               mov     ecx, esi
               call    dword ptr [eax+54h]

				push	4D99C6h
				retn


	}

}

//4D9A34 + 2 nop
__declspec(naked) void CSkillEffect_p_damage_shield_Pump()
{
	__asm {

			mov     byte ptr [eax+196h], 1

/*
pushad
		mov ecx, [eax][0F54h]

		mov		ebx, ecx
		add		ebx,0A0h //name of creature
		push	ebx
		push	fnCSkillEffect_p_damage_shield_Pump1
		push	0 //black collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 10h
popad
*/
			push	4D9A3Bh
			retn


	}

}



/*
__declspec(naked) void HookSystemMessageGaveDamage()
{
	__asm
	{
		pushad
		lea		eax, [ebp+0Ch]
		push	eax			//pDamage
		push	[ebp+8]		//pAttacker
		push	ebx			//pUser
		call	CombatPointsDamageHandler
		add		esp, 12
		popad
		//Restore the commands we overwrote
		mov     al, byte ptr [ebp+11]
		mov     edx, [ebx]
		push	450B04h
		retn
	}
}
*/


/*
__declspec(naked) void HookCombatPointsRegenerationC2()
{
	__asm
	{
		pushad
		//push	ecx
		push	ecx		//pUser
		call	CombatPointsRegenerationC2
		add		esp, 4
		//pop		ecx
		popad
		//Restore the commands we overwrote
		push	ebp
		mov		ebp, esp
		push	0FFFFFFFFh
		push	4E6E85h
		retn
	}
}
*/

__declspec(naked) void HookCombatPointsRegeneration()
{
	__asm
	{
		pushad
		//push	ecx
		push	ecx		//pUser
		call	CombatPointsRegeneration
		add		esp, 4
		//pop		ecx
		popad
		//Restore the commands we overwrote
		push	ebp
		mov		ebp, esp
		push	0FFFFFFFFh
		push	4E6E85h
		retn
	}
}


__declspec(naked) void HookCombatPointsDamage()
{
	__asm
	{
		pushad
		lea		eax, [ebp+0Ch]
		push	eax			//pDamage
		push	[ebp+8]		//pAttacker
		push	ecx			//pUser
		call	CombatPointsDamagePhysical
		add		esp, 12
		popad
		//Restore the commands we overwrote
		push	esi
		mov		esi, ecx
		test	esi, esi
		push	43CFA1h
		retn
	}

}

//GM command healthy
__declspec(naked) void BuilderCommandHealthyFix()
{
	__asm
	{
		push	esi
		call	BuilderCommandHealthyCP
		add		esp, 4
		//Restore the commands we overwrote
		mov		eax, [esi+0F54h]
		push	421508h
		retn
	}
}

__declspec(naked) void HookCCreatureUseItem()
{
	__asm
	{
		mov		eax, 52E030h			//CDB::RequestUseItem(CItem *, User *)
		call	eax
		push	eax
		mov		eax, [ebx+28h]
		mov		eax, [eax+78h]
		cmp		eax, CP_POTION
		je		short useCP
		cmp		eax, CP_GREATER_POTION
		je		short useCP
		cmp		eax, CP_GREATER_POTION2
		je		short useCP
		jmp		short WrongItem
	useCP:
		pushad
		push	eax
		push	esi
		call	StartCombatPointPotion
		add		esp, 8
		popad
	WrongItem:
		pop		eax
		push	443753h
		retn
	}
	//.text:0044374E                 call    CDB__RequestUseItem
	//.text:00443753                 jmp     short loc_443762

}

__declspec(naked) void HookCCreatureChangeClass()
{
	__asm
	{
		pushad
		push	0
		push	esi
		call	CombatPointsLevelChange
		add		esp, 8
		popad
		//Restore the commands we overwrote
		mov		eax, 451DD0h
		call	eax
		push	452856h
		retn
	}
	//.text:00452851                 call    sub_451DD0
	//.text:00452856                 mov     ecx, esi
}

__declspec(naked) void HookCCreatureDie()
{
	__asm
	{
		pushad
			
		//	mov		eax,[ecx+019B8h] //pSocket
		//	mov     dword ptr [eax+13CCh], 1 //login mode normal

			push	ecx
			call	CombatPointsDie
			add		esp, 4
		popad
		//Restore the commands we overwrote
		push    ebp
		mov     ebp, esp
		push    0FFFFFFFFh
		push	44F845h
		retn
	}
	//.text:0044F840                 push    ebp
	//.text:0044F841                 mov     ebp, esp
	//.text:0044F843                 push    0FFFFFFFFh
	//.text:0044F845                 push    offset loc_5A480B

}

__declspec(naked) void HookCCreatureDieC5()
{
	__asm
	{
		pushad
		push	ecx
		call	CombatPointsDie //Cursed
		add		esp, 4
		popad
		//Restore the commands we overwrote
		push    ebp
		mov     ebp, esp
		push    0FFFFFFFFh
		push	44F845h
		retn
	}
	//.text:0044F840                 push    ebp
	//.text:0044F841                 mov     ebp, esp
	//.text:0044F843                 push    0FFFFFFFFh
	//.text:0044F845                 push    offset loc_5A480B

}


__declspec(naked) void HookCCreatureLevelUp()
{
	_asm
	{
		pushad
		push	1
		push	esi
		call	CombatPointsLevelChange
		add		esp, 8
		popad
		//Restore the commands we overwrote
		call    dword ptr [edx+18h]
		test    al, al
		push	4517BEh
		retn
	}
	//.text:004517B9                 call    dword ptr [edx+18h]
	//.text:004517BC                 test    al, al
	//.text:004517BE                 jz      short loc_451826

}


__declspec(naked) void HookCCreatureLevelUpGF()
{
	_asm
	{
		pushad
		push	1
		push	esi
		call	CombatPointsLevelChangeGF
		add		esp, 8
		popad
		//Restore the commands we overwrote
		call    dword ptr [edx+18h]
		test    al, al
		push	4517BEh
		retn
	}
	//.text:004517B9                 call    dword ptr [edx+18h]
	//.text:004517BC                 test    al, al
	//.text:004517BE                 jz      short loc_451826

}

__declspec(naked) void HookCCreatureLevelDown()
{
	_asm
	{
		pushad
		push	0
		push	esi
		call	CombatPointsLevelChange
		add		esp, 8
		popad
		//Restore the commands we overwrote
		mov     edx, [esi+0F54h]
		push	45157Bh
		retn
	}
	//.text:00451575                 mov     edx, [esi+0F54h]
	//.text:0045157B                 mov     eax, [edx+378h]
}



//--------------------------------------------------------------------------------------------
//// Function Definitions
//--------------------------------------------------------------------------------------------
/*
void CombatPointsRegenerationC2(DWORD * pUser)
{
	if(pUser != NULL)
	{
		DWORD * pUserData = GetSharedData(pUser);
		if(pUserData != NULL && GetParameter(pUserData, AI_IS_PLAYER) )
		{
			ExUser * tempExUser = GetExUser(pUser);
				if(tempExUser != NULL)
				{
					tempExUser->CurrentCP = 0;
					CombatPointsRegeneration(pUser);
				}
		}
	}
}
*/


static const wchar_t *fnCombatPonts003=L"Elhaym::void CombatPointsRegeneration(DWORD * pUser)";
void CombatPointsRegeneration(DWORD * pUser)
{

	try { _set_se_translator( trans_func );

	if(pUser != NULL)
	{
		DWORD * pUserData = GetSharedData(pUser);
		PTCharBaseData CSharedDat = (PTCharBaseData)pUserData;

		if(pUserData != NULL && GetParameter(pUserData, AI_IS_PLAYER) )
		{




			//Fix HP Stacking Bugs AND check our HP status
			double * pCurrentHP = (double *)GetAddress(pUserData, AI_HP);
			double * pMaxHP = (double *)GetAddress(pUserData, AI_MAX_HP);

			double * pCurrentMP = (double *)GetAddress(pUserData, AI_MP);


			//#ifdef __DEBUG_VERBOSE__
			//	file << ">>>> CP Regen: HP: " << *pCurrentHP << " Max HP: " << *pMaxHP << ".\n";
			//	file.flush();
			//#endif

			//Will determine whether or not we send CurrentHP in the StatusUpdate packet
			bool bUpdateHP = false;

			//If HP is stacked, reset it
			if( *pCurrentHP > *pMaxHP)
			{
				*pCurrentHP = *pMaxHP;
				bUpdateHP = true;
			}

			//no God mode 
			if (*pCurrentHP == 0 && (CSharedDat->nIsAlive == 1))
			{
				*pCurrentHP = 1;
				bUpdateHP = true;

			}

			//#ifdef __DEBUG_VERBOSE__
			//	file << ">>>> CP Regen: HP: " << *pCurrentHP << " Max HP: " << *pMaxHP << ".\n";
			//	file.flush();
			//#endif

			//Check if we can regenerate CP or not
			//if( currentHP >= maxHP )
			//{
ExUser * tempExUser = GetExUser(pUser);
if(tempExUser != NULL)
{


	if (tempExUser->ROTATIONEX > 0) {

			short OP_ExRotation =0xC1;
			if(get_L2_CHRONICLE() > 14) OP_ExRotation=0xC2;

			tempExUser->ROTATIONEX =0;
			if (CSharedDat->nTargetObjId >0) {
				int direction=CSharedDat->m_Direction;
				if (direction > 32768)
				{
					direction = direction - 32768;
				} else {
					direction = direction + 32768;
				}
				CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET),"chdd", 
					aOPCODE(OP_EXTENDED),aOPCODEx(0xc2), //OP_ExRotation), 
				CSharedDat->nTargetObjId, direction);
			}
	}
//#################################
//lindvior 530+ protocol fix (tauti fix too)
	if (tempExUser->ExTeleportToLocationActivate > 0)
	{


		CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET),"chddddddd", 
			aOPCODE(OP_EXTENDED),aOPCODEx(get_OP_TELEPORT_TO_LOCATION_EXT()), 
			CSharedDat->nObjectID,
			(int)CSharedDat->x,(int)CSharedDat->y,(int)CSharedDat->z,
			0, //Instance id
		CSharedDat->m_Direction,
		0);



		if (tempExUser->ExTeleportToLocationActivate > 1) {
			tempExUser->ExTeleportToLocationActivate=0;
		} else {
			tempExUser->ExTeleportToLocationActivate=0;
			//tempExUser->ExTeleportToLocationActivate = tempExUser->ExTeleportToLocationActivate+1;
		}
	
	}




//this added due to wrong character packet, remove when fixed
	/*
	if(get_L2_CHRONICLE() > 15) {
if (CSharedDat->nKarma > 0) {
							FVector locVec;
							locVec.x=CSharedDat->x;
							locVec.y=CSharedDat->y;
							locVec.z=CSharedDat->z;
							L2Server::BroadcastToNeighborDist(G_BROADCAST_OBJECT,CSharedDat->nObjectID, 0x0A000, locVec,1500, 
								FORMAT_STATUSU_Awake1, aOPCODE(OP_STATUS_UPDATE), GetParameter(pUser, OBJECT_ID), 
								0, 1,1,0x1b, -CSharedDat->nKarma);
}
	}
*/

//#################################
// overbuff fix
	//bool isInJail= (CSharedDat->x < -100000) && (CSharedDat->y < -165000);
	int ovrbuff = 0;
	if (tempExUser->overbuff_checker == 0) 
	{
		tempExUser->overbuff_checker = 1;
		ovrbuff = FindOverbuff(pUser, CSharedDat);

	if ( ovrbuff > 0) {
		LOG->Add(FILE_LOG,"[%S] overbuffed with [%d], disconecting... ", CSharedDat->wszName, ovrbuff);	
		CSocketOLD::Close((DWORD *)GetParameter(pUser, USER_SOCKET));
		//if (CSharedDat->nBuilder != 1 ) {
			//user_teleport( pSocket, -115016, -179224, -6752); //teleport to jail
		//	isInJail = true;
		//}
	}
	}
//#################################


//#################################
//pk check
	if ((tempExUser->pk_checker == 1) && (CSharedDat->nKarma == 0))
	{
		LOG->Add(FULL_LOG,"[%S] possible PK without karma exploit... ", CSharedDat->wszName);	
	}
	tempExUser->pk_checker = 0;

	if (CSharedDat->fHP >0 && CSharedDat->m_nMakerParam1 == DEADLOG_PARAMETER)
													CSharedDat->m_nMakerParam1 = 0;


//chat ban GM check
if (tempExUser->CHAT_BAN_GM >0)
			CSharedDat->nBuilder = 10;


////////////////////////////////////
//C2 elemental power expire check
///////////////////////////////////
					if(tempExUser->SEED_TIMER >0)
					{
						if ((GetTickCount() - tempExUser->SEED_TIMER) > 10000) {
								tempExUser->SEED_OF_FIRE =0;
								tempExUser->SEED_OF_WATER =0;
								tempExUser->SEED_OF_WIND =0;
								tempExUser->SEED_TIMER = 0;
						}

					}


//#####################################################
// premium time handling
//#####################################################
					//count combat time in nonPVP mode for premium status update 
					if ((GetParameter8(pUser,bIsCombatMode) == 1) && (CSharedDat->m_nPvPflag1 == 0) && (CSharedDat->nIsAlive ==1) && (CSharedDat->m_bIsOnline ==1)) 
					{
							//we are in combat mode, no need to stop timer

					} else {
						if (tempExUser->premium_stop_tick == 0)
							tempExUser->premium_stop_tick = GetTickCount();
					}

//#####################################################
					


					if (tempExUser->PlayerJustDied == 1) //pc just died
					{
						tempExUser->PlayerJustDied = 2;
						tempExUser->GoingToDie = 2;
					
						//check dwarf for MP
						if (CSharedDat->m_nClass > 55)
											*pCurrentMP = 0;
						else
											*pCurrentMP = *pCurrentMP/2;

						//check clan war for MP
						DWORD *pPledge =User::GetPledge(pUser);
						if (pPledge != NULL) {
									PPLEDGESHAREDDATA pledgeSharedDat;// = (PPLEDGESHAREDDATA)GetSharedData2(pPledge);
									_asm
									{
										mov		eax, pPledge
										mov		eax, [eax+028h]
										mov		pledgeSharedDat, eax
									}
									if (pledgeSharedDat != NULL) {


										DWORD *pUser3 = CCreature::GetCreature(CSharedDat->nLastAttackerObjID); //get target's last attacker
										if (pUser3 != NULL)	
										{
											PTCharBaseData CSharedDat3 = (PTCharBaseData)GetSharedData(pUser3);
											if (CSharedDat3 != NULL)
											if (CSharedDat3->nIsPC == 1) {
												for (int i = 0; i<10; i++) {
													if (pledgeSharedDat->clanwar[i].member_id == CSharedDat3->nPledgeId ) 
															*pCurrentMP = 0; //clan wars drop all MP on death
												}
											}

										}

									}
						}


					//	DWORD * WeightPointDied = (DWORD *)GetAddress(pUserData, AI_WEIGHT_POINT);
					//	*WeightPointDied = 0;
						int * pAbnormals = (int *)GetAddress(pUser, ABNORMALS);
						*pAbnormals=0;
					}

					if( tempExUser->MaxCP <= tempExUser->CurrentCP) {
						return; //no need regeneration check
					}


//disable CP
//if ((L2_CHRONICLE>2) && (DISABLE_CP==0)) 
{
					double nRegenAmount = GetParameter(pUserData, AI_LEVEL);
					nRegenAmount = nRegenAmount * LevelMultiplier[(DWORD)nRegenAmount-1];

					//nRegenAmount = (Level % 10) + 1
					nRegenAmount = (nRegenAmount / 10) + 1;

					DWORD nMoveType = GetParameter(pUserData, AI_MOVE_TYPE);
					DWORD nStandType = GetParameter(pUserData, AI_STAND_TYPE);

					//if( Sitting OR PrivateStore )
					if( nStandType == 0 || nStandType == 2 )
					{
						nRegenAmount = nRegenAmount * CP_SIT_REGEN_RATE;
					}
					//if( Walking AND Standing )
					else if( nMoveType == 0 && nStandType == 1 )
					{
						nRegenAmount = nRegenAmount * CP_WALK_REGEN_RATE;
					}
					//if( Running AND Standing )
					else if( nMoveType == 1 && nStandType == 1 )
					{
						nRegenAmount = nRegenAmount * CP_RUN_REGEN_RATE;
					}

					if( (tempExUser->MaxCP > tempExUser->CurrentCP) && ( (tempExUser->MaxCP - tempExUser->CurrentCP) >= nRegenAmount) )
					{
						tempExUser->CurrentCP += nRegenAmount;
//LOG->Add(FULL_LOG,"[%d] Combat points regeneration... ", get_L2_CHRONICLE());	
/*
do not send CP update packets, we do not need this traffic in chronicle1
	if (get_L2_CHRONICLE() > 2) 
	{
if (get_L2_CHRONICLE() > 16) {
	CSocketOLD::Send( (DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_STATUSU_Lind558_2, aOPCODE(OP_STATUS_UPDATE), GetParameter(pUser, OBJECT_ID),GetParameter(pUser, OBJECT_ID),1, 2, STATUS_MAX_CP, tempExUser->MaxCP, STATUS_CUR_CP, tempExUser->CurrentCP);
} else {
	CSocketOLD::Send( (DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_STATUSU_Awake1, aOPCODE(OP_STATUS_UPDATE), GetParameter(pUser, OBJECT_ID), 2, STATUS_MAX_CP, tempExUser->MaxCP, STATUS_CUR_CP, tempExUser->CurrentCP);
}
	}
*/

					} else {
						tempExUser->CurrentCP = tempExUser->MaxCP;
					}



} //if ((L2_CHRONICLE>2) && (DISABLE_CP==0))


} //if(tempExUser != NULL)

		} //if(pUserData != NULL && GetParameter(pUserData, AI_IS_PLAYER) )
	} //if puser != null

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts003,0);
   throw;       // Pass exception to some other handler
}


}




//////////////////////////////////////////
// Fatal Blow
/////////////////////////////////////////
static const wchar_t *fnCombatPonts004=L"Elhaym::void CombatPointsDamagePhysicalFatal(DWORD * pTarget, DWORD * pAttacker, double *pDamage,";
void CombatPointsDamagePhysicalFatal(DWORD * pTarget, DWORD * pAttacker, double *p1Damage, DWORD *What3, DWORD What4)
{
	//this bug triggered when critical damage counts in percents
	//for example buffs: dance of fire (c1), song of hunter (c2), etc
	if (*p1Damage<0) {
		*p1Damage= 0;
		return;
	}

	double pDamage =*p1Damage;
	


	try { _set_se_translator( trans_func );


			if (L2_SKILLS_VERSION > 1) {
					if(SO_VALID_USER(pAttacker))
					{
							PTCharBaseData CSharedDatA = (PTCharBaseData)GetSharedData(pAttacker);
if (CSharedDatA != NULL)
if ((CSharedDatA->nMountType == 2) && (CSharedDatA->nIsPC == 1))
{
	 //no mortal blow on wyverns
	*p1Damage =0;
	return;
}


							if (CSharedDatA != NULL) {
								int bufflevel = 0;
								double dmg_mod=0;

								//dance of fire npc buff
								bufflevel  =FindBuffINSharedData(pAttacker,CSharedDatA, 10008); //NPC buff dance of fire
								if (bufflevel > 0) dmg_mod = 0.35;
								//dance of fire
								bufflevel  =FindBuffINSharedData(pAttacker,CSharedDatA, 274); //dance of fire
								if (bufflevel > 0) dmg_mod = 0.5 ;

								//crt_dam 
								bufflevel=critical_damage_dmg(pAttacker,6);
								if (bufflevel > 0 && (pDamage > bufflevel)) pDamage = (pDamage)-bufflevel-(bufflevel*dmg_mod);
								//vicious stance
								bufflevel=vicious_stance_dmg(pAttacker,5);
								if (bufflevel > 0 && (pDamage > bufflevel)) pDamage = (pDamage)-bufflevel-(bufflevel*dmg_mod);

								// Death Whisper buff 
								bufflevel  =FindBuffINSharedData(pAttacker,CSharedDatA, 1242);
								if (bufflevel>0) pDamage = (pDamage)*(1+ (bufflevel+0.1)/20); //damage increase percent

							}

					} else {
						return;
					}
					if(SO_VALID_USER(pTarget))
					{
							PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pTarget);
							if (CSharedDat != NULL) {
								if (CSharedDat->nIsPC) {
									int bufflev  =FindBuffINSharedData(pTarget,CSharedDat, 3509); // undergarment skill
									if (bufflev>0) pDamage = (pDamage)/(1+ (bufflev+0.1)/10); //damage reduce percent
									bufflev  =FindBuffINSharedData(pTarget,CSharedDat, 110); // ultimate defence skill
									if (bufflev>0) pDamage = (pDamage)/(6*bufflev); //damage reduce 
								}
							}
							if (pDamage > max_dagger_damage) pDamage=max_dagger_damage;

					}
			}

	if (pDamage > 0) *p1Damage=pDamage;
	CombatPointsDamageSkillPhysical(pTarget, pAttacker, p1Damage,What3,What4);

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts004,0);
   throw;       // Pass exception to some other handler
}


}

static const wchar_t *fnCombatPonts004a=L"Elhaym::void CombatPointsDamageSkillPhysical(DWORD * pTarget, DWORD * pAttacker, double *pDamage,";
void CombatPointsDamageSkillPhysical(DWORD * pTarget, DWORD * pAttacker, double *pDamage, DWORD *What3, DWORD What4)
{

	try { _set_se_translator( trans_func );

//		fileEs << ">>>> CP MDamage: " << *pDamage << " fn: " <<  *What3 << " .\n";
//		fileEs.flush();
if(SO_VALID_USER(pAttacker))
{
	PTCharBaseData CSharedDatA = (PTCharBaseData)GetSharedData(pAttacker);
	if (CSharedDatA != NULL) 
	{
		if (CSharedDatA->nIsPC) {

				if (User::CheckTrade(pAttacker)) {
					CombatPointsDamagePhysical(pTarget, pAttacker, pDamage);
					return;
				}
				if(CSharedDatA->m_bIsStanding > 1 || CSharedDatA->m_bIsOnline ==0 || CSharedDatA->nIsAlive ==0 || CSharedDatA->fHP <= 0) {
					CombatPointsDamagePhysical(pTarget, pAttacker, pDamage);
					return;
				}

			DWORD * pPetInventory = GetUserInventory(pAttacker);
				if(pPetInventory == NULL) {
					CombatPointsDamagePhysical(pTarget, pAttacker, pDamage);
					return;
				}
				DWORD * pItem = CInventory::FindFirstItemByClassID(pPetInventory, 6535); //physical skill shots = blessed soulshot
				if (pItem != NULL) {
					PItemData itmdata = (PItemData)GetSharedData2(pItem);
					if (itmdata == NULL) {
						CombatPointsDamagePhysical(pTarget, pAttacker, pDamage);
						return; 
					}
					int shots=itmdata->m_nCount;
					short count=1;
					if (CSharedDatA->nLevel >39) count++; 
					if (CSharedDatA->nLevel >51) count++;

					CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), FORMAT_FE00, 0xFE,0,3,6535,count,shots); //blessed soulshot
					*pDamage = (*pDamage)*2;

				}
		}
	}
}

		CombatPointsDamagePhysical(pTarget, pAttacker, pDamage);

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts004a,0);
   throw;       // Pass exception to some other handler
}


}

static const wchar_t *fnCombatPonts004b=L"Elhaym::void CombatPointsDamageSkillEnergy(DWORD * pTarget, DWORD * pAttacker, double *pDamage,";
void CombatPointsDamageSkillEnergy(DWORD * pTarget, DWORD * pAttacker, double *pDamage, DWORD *What3, DWORD What4)
{

	try { _set_se_translator( trans_func );

//		fileEs << ">>>> CP MDamage: " << *pDamage << " fn: " <<  *What3 << " .\n";
//		fileEs.flush();

			PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pTarget);
			PTCharBaseData CSharedDatA = (PTCharBaseData)GetSharedData(pAttacker);

if (CSharedDatA != NULL)
if ((CSharedDatA->nMountType == 2) && (CSharedDatA->nIsPC == 1))
{
	*pDamage = 0; //no energy attacks on wyverns
	return;
}

			if(CSharedDat != NULL && CSharedDatA != NULL) {
		
				if(CSharedDatA->nIsPC == 1)  //PC Attacker 
				{
					//check energy charge
					ExUser *tempExUser = GetExUser(pAttacker);
					if ( tempExUser != NULL) {
						if (tempExUser->ENERGY_SAVED > 0) {
							*pDamage = *pDamage * (1.0+(tempExUser->ENERGY_SAVED*extraDMGpercent_energy)); //add % to damage for every extra energy saved
							tempExUser->ENERGY_SAVED = 0;
						}

					}

					// spec feature
					if ( 
						(CSharedDatA->m_nClass == 5) || //paladin
						(CSharedDatA->m_nClass == 6) || //dark avenger
						(CSharedDatA->m_nClass == 4) || //knight
						(CSharedDatA->m_nClass == 19) || //elven knight
						(CSharedDatA->m_nClass == 20) || //temple knight
						(CSharedDatA->m_nClass == 32) || //palus knight
						(CSharedDatA->m_nClass == 33) //shilien knight
						) {
							*pDamage = 0.0; //tanks do not deal energy damage
							if (CSharedDat->nIsPC == 1) //PC Attacked PC
							if (
								User::IsInPVPZone(pAttacker) || 
								(CSharedDat->nKarma > 0) ||
								((CSharedDatA->nLevel > (CSharedDat->nLevel-10) ) && (CSharedDatA->nLevel < (CSharedDat->nLevel+10) ) && (CSharedDatA->fHP > (CSharedDatA->fMaxHP/2) ))   ) 
							{

									tempExUser = GetExUser(pTarget);
									if ( tempExUser != NULL) {

										tempExUser->hate_object_id = GetParameter(pAttacker,0x18);
										tempExUser->hate_attack = GetTickCount();
										

									}

							}



					}

				}

			}


		CombatPointsDamagePhysical(pTarget, pAttacker, pDamage);

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts004b,0);
   throw;       // Pass exception to some other handler
}


}

void CombatPointsDamageMagicAttack(DWORD * pTarget, DWORD * pAttacker, double *pDamage, DWORD *What3, DWORD What4)
{
	//beast shots implementation

	if (pAttacker == NULL) {
		return;
	}
	PTCharBaseData CSharedDatPet = (PTCharBaseData)GetSharedData(pAttacker);
	if (CSharedDatPet == NULL) {
		return;
	}
		
		if (IsPet(CSharedDatPet->m_nClassId))
		{
				
				DWORD *master= CCreature::GetMaster(pAttacker);
				DWORD * pUser=master;
				if (master == NULL) {
					CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
					return;
				}
				if (User::CheckTrade(master)) {
					CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
					return;
				}
				CSharedDatPet= (PTCharBaseData)GetSharedData(master);
				if(CSharedDatPet == NULL) {
					CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
					return;
				}
				if(CSharedDatPet->m_bIsStanding > 1 || CSharedDatPet->m_bIsOnline ==0 || CSharedDatPet->nIsAlive ==0 || CSharedDatPet->fHP <= 0) {
					CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
					return;
				}
				DWORD * pPetInventory = GetUserInventory(master);
				if(pPetInventory == NULL) {
					CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
					return;
				}
				DWORD * pItem = CInventory::FindFirstItemByClassID(pPetInventory, 6647); //blessed spiritshot_beast
				if (pItem == NULL) {
					pItem = CInventory::FindFirstItemByClassID(pPetInventory, 6646); //spiritshot_beast
					if (pItem == NULL) {
						CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
						return; 
					}
					PItemData itmdata = (PItemData)GetSharedData2(pItem);
					if (itmdata == NULL) {
						CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
						return; 
					}
					int shots=itmdata->m_nCount;

					//DelItemFromInventory(master, 6646, 1);
					CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_FE00, 0xFE,0,4,6646,1,shots);
					*pDamage = (*pDamage)*1.5;
				} else {
					PItemData itmdata = (PItemData)GetSharedData2(pItem);
					if (itmdata == NULL) {
						CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
						return; 
					}
					int shots=itmdata->m_nCount;

					//DelItemFromInventory(master, 6647, 1);
					CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_FE00, 0xFE,0,4,6647,1,shots); //blessed spiritshot_beast
					*pDamage = (*pDamage)*2;

				}

		} else if ( CSharedDatPet->m_nClassId > 1012005 && CSharedDatPet->nIsPC == 0 ) 
		{

			if ( IsSummon(CSharedDatPet->m_nClassId)) 
			{
//beast shot feature
				DWORD summon_level=CSharedDatPet->nLevel;


				//CSharedDatPet= (PTCharBaseData)GetSharedData(pUser); //check wictim
				//if(CSharedDatPet == NULL) return;
				//if (CSharedDatPet->nIsPC == 1) return; //only against NPCs beast shots can be used
				DWORD *master= CCreature::GetMaster(pAttacker);
				DWORD * pUser=master;
				if (master == NULL) {
					CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
					return;
				}
				if (User::CheckTrade(master)) {
					CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
					return;
				}
				CSharedDatPet= (PTCharBaseData)GetSharedData(master);
				if(CSharedDatPet == NULL) {
					CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
					return;
				}
				if(CSharedDatPet->m_bIsStanding > 1 || CSharedDatPet->m_bIsOnline ==0 || CSharedDatPet->nIsAlive ==0 || CSharedDatPet->fHP <= 0) {
					CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
					return;
				}
				DWORD * pPetInventory = GetUserInventory(master);
				if(pPetInventory == NULL) {
					CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
					return;
				}
				DWORD * pItem = CInventory::FindFirstItemByClassID(pPetInventory, 6647); //blessed spiritshot_beast
				if (pItem == NULL) {
					pItem = CInventory::FindFirstItemByClassID(pPetInventory, 6646); //spiritshot_beast
					if (pItem == NULL) {
						CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
						return; 
					}

					PItemData itmdata = (PItemData)GetSharedData2(pItem);
					if (itmdata == NULL) {
						CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
						return; 
					}
					int shots=itmdata->m_nCount;
					short count=1;
					if (summon_level >39) count++; 
					if (summon_level >51) count++;
					//DelItemFromInventory(master, 6646, 1);
					CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_FE00, 0xFE,0,4,6646,count,shots);

					

					*pDamage = (*pDamage)*1.5;
				} else {
					//DelItemFromInventory(master, 6647, 1);
					PItemData itmdata = (PItemData)GetSharedData2(pItem);
					if (itmdata == NULL) {
						CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
						return; 
					}
					int shots=itmdata->m_nCount;
					short count=1;
					if (summon_level >39) count++; 
					if (summon_level >51) count++;
					CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_FE00, 0xFE,0,4,6647,count,shots);


					*pDamage = (*pDamage)*2;
				}
			}

		}


	CombatPointsDamageMagic(pTarget, pAttacker, pDamage, What3, What4);
}


static const wchar_t *fnCombatPonts005=L"Elhaym::void CombatPointsDamageMagic(DWORD * pTarget, DWORD * pAttacker, double *pDamage,";
void CombatPointsDamageMagic(DWORD * pTarget, DWORD * pAttacker, double *pDamage, DWORD *What3, DWORD What4)
{

	try { _set_se_translator( trans_func );

//		fileEs << ">>>> CP MDamage: " << *pDamage << " fn: " <<  *What3 << " .\n";
//		fileEs.flush();

		
		if (L2_SKILLS_VERSION > 1) {
	//c2 magical critical fix, probability is 1 of 1000
	//c3 magical critical increase by "wild magic" buff			
			if(SO_VALID_USER(pAttacker))
			{

//ExUser * tempExUser = GetExUser( pAttacker );
//if( tempExUser != NULL ) {
//	CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, 
//L"Refreshing auto spiritshots.");
//	RefreshAutoSS((DWORD *)GetParameter(pAttacker, USER_SOCKET), tempExUser->AutoSpiritShot);
//}


				PTCharBaseData CSharedDatA = (PTCharBaseData)GetSharedData(pAttacker);
				PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pTarget);
				if (CSharedDatA != NULL)
if ((CSharedDatA->nMountType == 2) && (CSharedDatA->nIsPC == 1))
{
	*pDamage = 0; //no magic attack on wyverns
	return;
}
				
					if (CSharedDatA != NULL)
						if (CSharedDatA->nIsPC) {
	

				if (MyRandom(100)<10) {	
					
					if (CSharedDat != NULL) {
						if (CSharedDat->nIsPC) {

						int shield_fortress = user_get_skill_levelToggleON(pTarget,322); //shield fortress on	
						if (shield_fortress ==1) shield_fortress  =user_get_skill_level(pTarget,322,6); //shield fortress level

						if (shield_fortress > 0) {
							CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), "cdd", aOPCODE(OP_SYS_MSG), 158,0); //Attack Failed!
									double sh_dam1 = *pDamage;
									double sh_dam2 = sh_dam1/2.0;
									int sh_fort = 432 + (shield_fortress * 23);
										if (sh_fort < sh_dam2)
											*pDamage = sh_dam1 - sh_fort;
										else
											*pDamage = sh_dam2;

						} else {
							//CSocketOLD::Send((DWORD *)GetParameter(pTarget, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							//614, 1 , 0, L"shield fortress not found!");
						}



						} 
					}

				}
						


	int mcritb = FindBuffINSharedData(pAttacker,CSharedDatA, 1303);
	if (FindBuffINSharedData(pAttacker,CSharedDatA, 10034) > mcritb) // BUFF wild magic
			mcritb = 2;
	if (FindBuffINSharedData(pAttacker,CSharedDatA, 10015) > mcritb) // BUFF dance of siren
			mcritb = 1;
	if (FindBuffINSharedData(pAttacker,CSharedDatA, 10036) > mcritb) // BUFF prophecy of water
			mcritb = 1;



	if (CSharedDat != NULL)
		if (CSharedDat->nIsPC) {
			//no magical critical in pvp

		} else {

	if ((MyRandom(1600)-1) < ((mcritb+1.0)*CSharedDatA->fBaseCritical)) {
		if (FindBuffINSharedData(pAttacker,CSharedDatA, 1059) > 0) {
			//empower buff
				*pDamage = (*pDamage)* 10.0; 
		} else {
				*pDamage = (*pDamage)*4.0; 
		}

		CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), "cdd", aOPCODE(OP_SYS_MSG), 1280,0); //Magic Critical Hit!
	}
		}

						}
			}
		}
			


	CombatPointsDamageHandler(pTarget, pAttacker, pDamage);


} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts005,0);
   throw;       // Pass exception to some other handler
}


}

////////////////////
//backstab
///////////////////
static const wchar_t *fnCombatPonts006=L"Elhaym::void CombatPointsDamageMagicBackstab(DWORD * pTarget, DWORD * pAttacker, double *pDamage,";
void CombatPointsDamageMagicBackstab(DWORD * pTarget, DWORD * pAttacker, double *p1Damage, DWORD *What3, DWORD What4)
{

	//this bug triggered when critical damage counts in percents
	//for example buffs: dance of fire (c1), song of hunter (c2), etc
		if (*p1Damage<0) {
		*p1Damage= 0;
		return;
	}

	double  pDamage =*p1Damage;
	

	try { _set_se_translator( trans_func );

//		fileEs << ">>>> CP MDamage: " << *pDamage << " fn: " <<  *What3 << " .\n";
//		fileEs.flush();
	
PTCharBaseData CSharedDatA = (PTCharBaseData)GetSharedData(pAttacker);
if (CSharedDatA != NULL)
if ((CSharedDatA->nMountType == 2) && (CSharedDatA->nIsPC == 1))
{
	*p1Damage = 0; //no backstab on wyverns
	return;
}


if(SO_VALID_USER(pAttacker))
{
	
	if (CSharedDatA != NULL) {
								int bufflevel = 0;
								double dmg_mod=0;

								//dance of fire npc buff
								bufflevel  =FindBuffINSharedData(pAttacker,CSharedDatA, 10008); //NPC buff dance of fire
								if (bufflevel > 0) dmg_mod = 0.35;
								//dance of fire
								bufflevel  =FindBuffINSharedData(pAttacker,CSharedDatA, 274); //dance of fire
								if (bufflevel > 0) dmg_mod = 0.5 ;

								//crt_dam 
								bufflevel=critical_damage_dmg(pAttacker,6);
								if (bufflevel > 0 && (pDamage > bufflevel)) pDamage = (pDamage)-bufflevel-(bufflevel*dmg_mod);
								//vicious stance
								bufflevel=vicious_stance_dmg(pAttacker,5);
								if (bufflevel > 0 && (pDamage > bufflevel)) pDamage = (pDamage)-bufflevel-(bufflevel*dmg_mod);
								// Death Whisper buff 
								bufflevel  =FindBuffINSharedData(pAttacker,CSharedDatA, 1242);
								if (bufflevel>0) pDamage = (pDamage)*(1+ (bufflevel+0.1)/20); //damage increase percent
	}
}

		if(SO_VALID_USER(pTarget))
		{
			PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pTarget);
			if (CSharedDat != NULL)
				if (CSharedDat->nIsPC)
				{
									int bufflev  =FindBuffINSharedData(pTarget,CSharedDat, 3509); // undergarment skill
									if (bufflev>0) pDamage = (pDamage)/(1+ (bufflev+0.1)/10); //damage reduce percent
									bufflev  =FindBuffINSharedData(pTarget,CSharedDat, 110); // ultimate defence skill
									if (bufflev>0) pDamage = (pDamage)/(6*bufflev); //damage reduce 

					ExUser * tempExUser = GetExUser(pTarget);
					if(tempExUser != NULL)
					{
						//tempExUser->Attacked = 1;

						if ((tempExUser->JUST_TELEPORTED_TICK + AFTER_TELEPORT_TICKMAX) > GetTickCount()) {
							CSocketOLD::Send((DWORD *)GetParameter(pTarget, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"You were attacked too soon after teleportation!");
							*p1Damage=0;
							return;
						}



						
					}



					
					ExUser * tempExUserA = GetExUser(pAttacker);
					if(tempExUserA != NULL && CSharedDatA != NULL)
					{

//#############################
//ha ha ha, in c1 there is bug - backStab to face and no repors in several years.... yeah yeah
//now we fix it

//CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), "cdddddd", aOPCODE(OP_SYS_MSG), 0x5f, 2,1,CSharedDatA->m_Direction,1,CSharedDat->m_Direction);
if (j_isBehindTarget(CSharedDatA->m_Direction, (int)CSharedDatA->x, (int)CSharedDatA->y, CSharedDat->m_Direction, (int)CSharedDat->x, (int)CSharedDat->y))
//if (IsBackPosition(CSharedDatA->m_Direction,CSharedDat->m_Direction))
{
	//all ok 
	

} else {
	CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Backstab failed!");
	*p1Damage=0;
	return;
}

if (pDamage > max_dagger_damage) pDamage=max_dagger_damage;


//-------------------------------------------------
// check for buff (5182) and karma x levels more
//-------------------------------------------------

if ( (CSharedDatA->nKarma>0) && (CSharedDat->nKarma == 0) && (CSharedDat->nLevel<pr_level))
{
	if ((CSharedDatA->nLevel-CSharedDat->nLevel) >= pr_level_diff) {
		if ((CSharedDat->x <65544) || (CSharedDat->y < -163848)) //newbie location limit
		{
			if (tempExUser->PK_PROTECTION > 0)
			{
							CSocketOLD::Send((DWORD *)GetParameter(pTarget, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"You were attacked by high level PK!");
							CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"This person is protected by Lord's magic. Find the victim of your level!");
							*p1Damage=0;
							return;

			}
		}

	}

				
}

						if ( (CSharedDatA->nKarma==0) && (CSharedDat->nKarma > 0))
						{
							if ((CSharedDat->nLevel-CSharedDatA->nLevel) >= pr_level_diff) {
								tempExUserA->PK_PROTECTION = 0; //protection removed
							}
						}
					}


					if(tempExUser != NULL)
					{
						if 	(CSharedDat->fHP <= pDamage)
								tempExUser->GoingToDie = 1;
								tempExUser->DeathTimer = GetTickCount();
					}

				}
		}

		if (pDamage > 0) *p1Damage=pDamage;

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts006,0);
   throw;       // Pass exception to some other handler
}



}

static const wchar_t *fnCombatPonts007=L"Elhaym::int CombatPointsNewbieZone(DWORD * pUser)";
int CombatPointsNewbieZone(DWORD * pUser)
{

try { _set_se_translator( trans_func );

	PTCharBaseData CSharedDat2 = (PTCharBaseData)GetSharedData(pUser);
	

	int tileX = NULL, tileY = NULL, nRegion = NULL, nLocation = NULL;

	int x =(int)CSharedDat2->x;
	int y =(int)CSharedDat2->y;
	int z =(int)CSharedDat2->z;

	int tile=map_tile(x, y);
	tileX=(int)(tile/100)-16; 
	tileY=tile-((int)(tile/100))*100;
	tileY=tileY-9;

		nLocation = 0; //neutral


	//if we're in an unknown region
	if (tile<1610 || tile > 2526)
		nLocation = 0; //neutral

	//else we're in a known region
	else {
	//find the town id for that tile
		nRegion = _regionsNEWBIE[tileY][tileX];
		
		nLocation = nRegion; // if it > 0 then newbie zone
	}


return nLocation;

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts007,0);
   throw;       // Pass exception to some other handler
}


}

/*
int CombatPointsGetBuff(DWORD * pUser, int buffid)
{
	PTUserData PartyUser =(PTUserData)pUser; //?? GetSharedData(pUser)
	PTBuff Pt_Buff;
	int size;
	int pInt=0;

      size =  int(PartyUser->LastBuff - PartyUser->FirstBuff); // /  16;
	  if (size >24)
		  size = 24;

if (size >0)
{
      Pt_Buff =  PartyUser->FirstBuff;
	  if (Pt_Buff == NULL) {
						return 0;
	  }
	  int strj = 4;
      for(int j =  0; j <=size -1 ; j ++)
       { 
			pInt=Pt_Buff->BuffData->Buff_id;
			if (pInt == buffid) return 1;
			//pInt=Pt_Buff->BuffData->Buff_level;
			//pInt=Pt_Buff->BuffData->Buff_duration;


        Pt_Buff++;
       } 
}
return 0;
}
*/


static const wchar_t *fnCombatPonts008=L"Elhaym::void CombatPointsDamagePhysical(DWORD * pUser, DWORD * pAttacker, double * pDamage)";
void CombatPointsDamagePhysical(DWORD * pUser, DWORD * pAttacker, double * pDamage)
{
	try { _set_se_translator( trans_func );


			//Defender buff check and proceed
				if (L2_SKILLS_DEFENDER >0)
					if(SO_VALID_USER(pUser))
					{
							PTCharBaseData CSharedDatT = (PTCharBaseData)GetSharedData(pUser);
							if (CSharedDatT != NULL )
							if (CSharedDatT->nIsPC == 1) {
								BYTE DefenderBuff = FindBuffINSharedData(pAttacker,CSharedDatT, 528);
								if (DefenderBuff>0) // Defender buff
								{
									//get ex user info where defender tank is defined
									ExUser *tempExUser=GetExUser(pUser);
									PTCharBaseData CSharedDatDEF = NULL;
									if (tempExUser != NULL) {
										//now find defender tank
										ExUser *tempExUserDEF = NULL;
										if ((tempExUser->pDefender != NULL) && (tempExUser->pDefender != pAttacker)) {
											CSharedDatDEF = (PTCharBaseData)GetSharedData(tempExUser->pDefender);
											if (CSharedDatDEF != NULL) {
												if ((CSharedDatDEF->nIsAlive == 1) && (CSharedDatDEF->nIsPC == 1)) {
													if ( CombatPointsDistance(tempExUser->pDefender,CSharedDatT->x, CSharedDatT->y, CSharedDatT->z, 200) > 0) {
														tempExUserDEF=GetExUser(tempExUser->pDefender);
													} else {
														CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"Defender out of RANGE of 200!");
													}
												} else {
														CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"Defender is DEAD!");
												}
											} else {
												CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"Defender DATA is NULL!");
											}

										} else {
												CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"Defender is NULL!");
										}


										if (tempExUserDEF != NULL) {
											//defender tank found
											if (tempExUserDEF->pMerchant == pUser) {
												//defender defends the target OK
												if (CSharedDatDEF->fHP > (*pDamage)*(0.65 + (DefenderBuff*0.5))) {
													//transfer damage to defender
													//trying to block damage with shield. check shield availability and chance of block 
													if ((CSharedDatDEF->nObjIdRHand != CSharedDatDEF->nObjIdLHand) && (CSharedDatDEF->nObjIdLHand != 0) 
														&& (MyRandom(100) < (10 + FindBuffINSharedData(pAttacker,CSharedDatDEF, 1243))))
													{
														//shield block successfull, remove 50% damage
														if (MyRandom(100)>5) {
															CSharedDatDEF->fHP = CSharedDatDEF->fHP - 0.5*(*pDamage)*(0.65 + (DefenderBuff*0.5));
															CSocketOLD::Send((DWORD *)GetParameter(tempExUser->pDefender, USER_SOCKET), "cd", aOPCODE(OP_SYS_MSG), 111); //shield block successful
															CSocketOLD::Send((DWORD *)GetParameter(tempExUser->pDefender, USER_SOCKET), "cdddd", aOPCODE(OP_SYS_MSG), 812, 1,1,
																(int)(0.5*(*pDamage)*(0.65 + (DefenderBuff*0.5)))  );
														} else {
															//remove all damage - excelent shield block
															CSocketOLD::Send((DWORD *)GetParameter(tempExUser->pDefender, USER_SOCKET), "cdd", aOPCODE(OP_SYS_MSG), 1281,0); //excelent shield block successful
														}

													} else {
														CSharedDatDEF->fHP = CSharedDatDEF->fHP - (*pDamage)*(0.65 + (DefenderBuff*0.5));
														CSocketOLD::Send((DWORD *)GetParameter(tempExUser->pDefender, USER_SOCKET), "cdddd", aOPCODE(OP_SYS_MSG), 812, 1,1,
															(int)(*pDamage)*(0.65 + (DefenderBuff*0.5)));
													}
													//decrease damage to target
													*pDamage = (*pDamage)*(0.35 - (DefenderBuff*0.5)); //damage decrease 70-85%
												} else {
												CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"Defender is too WEAK to defend you from this blow!");
												}


											} //pTarget == PMerchant
											else {
												CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"Defender defending others NOW!");
											}
										} //tempExUserDEF != NULL
									} //temExUser != NULL

								} //defender buff >0
							} //target shareddata NULL

					} //target valid





	if (L2_SKILLS_VERSION > 1) {


////////////////////////////////////
// shield features check
////////////////////////////////////
		if(SO_VALID_USER(pUser))
		{
			PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pUser);
			if (CSharedDat != NULL )
				if (CSharedDat->nIsPC == 1) {
					ExUser *tempExUser = GetExUser(pUser);
					if (tempExUser->shield_success >0)  
					{

						tempExUser->shield_success = 0; //set our shield success back to 0

//shield block critical chance 
	if ((MyRandom(1000)-1) < CSharedDat->fBaseCritical) {
		*pDamage = 1; 
		CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), "cdd", aOPCODE(OP_SYS_MSG), 1281,0); //shield block Critical success! excelent
		return;
	}						
						int sh_fort = 423;
						int shield_fortress = user_get_skill_levelToggleON(pUser,322); //shield fortress on	
						if (shield_fortress ==1) shield_fortress  =user_get_skill_level(pUser,322,3); //shield fortress level

						if (shield_fortress ==0) {
							shield_fortress = FindBuffINSharedData(pUser,CSharedDat, 1304); //advanced block buff 
							sh_fort = 390;
								//need to get shield defence power?
								//well, we will make some formula magic here
								//nongrade:
								// leather sield = 47
								// buckler = 67
								//bone shield = 90
								//d-grade
								// bronze shield = 101
								// square shield = 154
								//c - grade
								// eldarake = 166
								// knight shield = 178
								//b -grade shields
								// avadon= 216
								// doom = 230
								//a grade shields
								//dark crystal = 243
								// nightmare 256
						}
						if (shield_fortress > 0) {

										

									double sh_dam1 = *pDamage;
									if (sh_dam1 > 150)
									{
										sh_dam1 = sh_dam1 + 230;
										double sh_dam2 = sh_dam1/2.0;
										sh_fort = sh_fort + (shield_fortress * 23);
										if (sh_fort < sh_dam2)
											*pDamage = sh_dam1 - sh_fort;
										else
											*pDamage = sh_dam2;

									}



							} 

						
					}


				}

		}

////////////////////////////////////
// vampiric rage features check
////////////////////////////////////
//CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
//							614, 1 , 0, L"VRAGE check1!");

		if(SO_VALID_USER(pAttacker)) // && SO_VALID_USER(pUser)) //npc is not user
		{

//CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
//							614, 1 , 0, L"VRAGE check2!");


			PTCharBaseData CSharedDat2 = (PTCharBaseData)GetSharedData(pAttacker);
			PTCharBaseData CSharedDat1 = (PTCharBaseData)GetSharedData(pUser);
			if (CSharedDat2 != NULL && CSharedDat1 != NULL)

					if (j_isBehindTarget(CSharedDat2->m_Direction, (int)CSharedDat2->x, (int)CSharedDat2->y, CSharedDat1->m_Direction, (int)CSharedDat1->x, (int)CSharedDat1->y))
					{

/*
skill_begin	skill_name = [s_back_critical_sword_1]		skill_id = 3018	level = 1	operate_type = P	magic_level = 46	effect = {{p_critical_rate_position_bonus;back;71;per}}	skill_end
skill_begin	skill_name = [s_back_critical_sword_2]		skill_id = 3018	level = 2	operate_type = P	magic_level = 49	effect = {{p_critical_rate_position_bonus;back;67;per}}	skill_end
skill_begin	skill_name = [s_back_critical_sword_3]		skill_id = 3018	level = 3	operate_type = P	magic_level = 52	effect = {{p_critical_rate_position_bonus;back;63;per}}	skill_end
skill_begin	skill_name = [s_back_critical_sword_4]		skill_id = 3018	level = 4	operate_type = P	magic_level = 55	effect = {{p_critical_rate_position_bonus;back;60;per}}	skill_end
skill_begin	skill_name = [s_back_critical_sword_5]		skill_id = 3018	level = 5	operate_type = P	magic_level = 58	effect = {{p_critical_rate_position_bonus;back;56;per}}	skill_end
skill_begin	skill_name = [s_back_critical_sword_6]		skill_id = 3018	level = 6	operate_type = P	magic_level = 61	effect = {{p_critical_rate_position_bonus;back;53;per}}	skill_end

skill_begin	skill_name = [s_back_critical_dagger_1]		skill_id = 3019	level = 1	operate_type = P	magic_level = 46	effect = {{p_critical_rate_position_bonus;back;50;per}}	skill_end
skill_begin	skill_name = [s_back_critical_dagger_2]		skill_id = 3019	level = 2	operate_type = P	magic_level = 49	effect = {{p_critical_rate_position_bonus;back;47;per}}	skill_end
skill_begin	skill_name = [s_back_critical_dagger_3]		skill_id = 3019	level = 3	operate_type = P	magic_level = 52	effect = {{p_critical_rate_position_bonus;back;45;per}}	skill_end
skill_begin	skill_name = [s_back_critical_dagger_4]		skill_id = 3019	level = 4	operate_type = P	magic_level = 55	effect = {{p_critical_rate_position_bonus;back;42;per}}	skill_end
skill_begin	skill_name = [s_back_critical_dagger_5]		skill_id = 3019	level = 5	operate_type = P	magic_level = 58	effect = {{p_critical_rate_position_bonus;back;40;per}}	skill_end
skill_begin	skill_name = [s_back_critical_dagger_6]		skill_id = 3019	level = 6	operate_type = P	magic_level = 61	effect = {{p_critical_rate_position_bonus;back;37;per}}	skill_end
*/
	
	
						//check for SA weapon backblow
						int bufflevel=user_get_skill_levelToggleON(pAttacker,3018);  //backblow sword
						if (bufflevel==0) bufflevel=user_get_skill_levelToggleON(pAttacker,3019); //backblow dagger
	
						if (bufflevel >0)
						{
							if (MyRandom(100)< 10) 
							{
								*pDamage = *pDamage * 2;
								CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), "cdd", aOPCODE(OP_SYS_MSG), 44,0); //Critical Hit
								bufflevel=vicious_stance_dmg(pAttacker,1);
								*pDamage = *pDamage + bufflevel;
								critical_power_dmg(pAttacker,1);
								*pDamage = *pDamage + bufflevel;
			
							} //random
						} //buff level


					} //isbehind
				//if (CSharedDat2->wWeaponRange<81) 
				if ( (CSharedDat2->nIsPC == 1) && (CSharedDat2->wWeaponRange<81) ) 
				{
				
					if ((CSharedDat1->nIsPC == 1) || 
						((CSharedDat1->m_nClassId > 0) && (CSharedDat1->m_nClassId < 1000687)) ||
						((CSharedDat1->m_nClassId > 1000722) && (CSharedDat1->m_nClassId < 1000863)) ||
						((CSharedDat1->m_nClassId > 1000918) && (CSharedDat1->m_nClassId < 1006000))
						)
					{

//CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
//							614, 1 , 0, L"VRAGE check3!");


//vampiric rage buff
				if (CSharedDat2->fHP < CSharedDat2->fMaxHP )
				{

					double vampdamage=0;
// check for vampiric rage for newbie
					if (CSharedDat2->nLevel<40)
						if (FindBuffINSharedData(pAttacker,CSharedDat2, 4325) >0) 
							vampdamage = (*pDamage)*0.05; //5% of damage
// check for vampiric rage
					int vragelevel = FindBuffINSharedData(pAttacker,CSharedDat2, 1268);
					if ( vragelevel > 0) {
						vampdamage = (*pDamage)*0.01*(vragelevel+5); //6-9% of damage
//CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
//							614, 1 , 0, L"VRAGE check4!");

					}
// check for dance of vampire
					if ( FindBuffINSharedData(pAttacker,CSharedDat2, 310) >0) 
						vampdamage = (*pDamage)*0.08; //8% of damage


// check for BUFF of prophecy of wind
					if ( FindBuffINSharedData(pAttacker,CSharedDat2, 10038) >0) 
						vampdamage = (*pDamage)*0.05; //5% of damage
// check for BUFF of dance of vampire
					if ( FindBuffINSharedData(pAttacker,CSharedDat2, 10012) >0) 
						vampdamage = (*pDamage)*0.08; //8% of damage
// check for BUFF of vampiric rage
					if ( FindBuffINSharedData(pAttacker,CSharedDat2, 10033) >0) 
						vampdamage = (*pDamage)*0.08; //8% of damage


// check for vampiric rage HERB
					if (FindBuffINSharedData(pAttacker,CSharedDat2, 2512) >0) 
						vampdamage = (*pDamage)*0.09; //9% of damage

					if (vampdamage >= 1) {
							double * MyHP = (double *)GetAddress((DWORD *)CSharedDat2, AI_HP);
							*MyHP = *MyHP + vampdamage;
							//CSharedDat2->fHP = CSharedDat2->fHP + vampdamage;
							CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), "cdddd", aOPCODE(OP_SYS_MSG), 1066, 1,1,(int)vampdamage);

					} 
					
				
				} //is HP lower than MaxHP
					} //is allowed target
				} //is in vampiric range
		
		} //is valid attacker
} //skill version

	

////////////////////////////////////////
// pet weapon soulshot features check
///////////////////////////////////////
//petauto autoshot pet auto shot

	if (pAttacker == NULL) return;
	PTCharBaseData CSharedDatPet = (PTCharBaseData)GetSharedData(pAttacker);
	if (CSharedDatPet == NULL) return;
		if (IsPet(CSharedDatPet->m_nClassId))
		{
				if (CSharedDatPet->nWeaponClassId == 0) return; 
				DWORD *master= CCreature::GetMaster(pAttacker);
				DWORD *pUser=master;
				if (master == NULL) return;
				if (User::CheckTrade(master)) return;
				CSharedDatPet= (PTCharBaseData)GetSharedData(master);
				if(CSharedDatPet == NULL) return;
				if(CSharedDatPet->m_bIsStanding > 1 || CSharedDatPet->m_bIsOnline ==0 || CSharedDatPet->nIsAlive ==0 || CSharedDatPet->fHP <= 0) return;
				DWORD * pPetInventory = GetUserInventory(master);
				if(pPetInventory == NULL) return;
				DWORD * pItem = CInventory::FindFirstItemByClassID(pPetInventory, 1835); //soulshot_none
				if (pItem == NULL) return; 
				PItemData itmdata = (PItemData)GetSharedData2(pItem);
				if (itmdata == NULL) return; 
				int shots=itmdata->m_nCount;

				//DelItemFromInventory(master, 1835, 1);
				CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_FE00, 0xFE,0,3,1835,1,shots);
				*pDamage = (*pDamage)*2;
				return;
		} else if ( CSharedDatPet->m_nClassId > 1012005 && CSharedDatPet->nIsPC == 0 ) 
		{

			if ( IsSummon(CSharedDatPet->m_nClassId)) 
			{
//beast shot feature
				DWORD summon_level=CSharedDatPet->nLevel;
				//CSharedDatPet= (PTCharBaseData)GetSharedData(pUser); //check wictim
				//if(CSharedDatPet == NULL) return;
				//if (CSharedDatPet->nIsPC == 1) return; //only against NPCs beast shots can be used
				DWORD *master= CCreature::GetMaster(pAttacker);
				DWORD *pUser=master;
				if (master == NULL) return;
				if (User::CheckTrade(master)) return;
				CSharedDatPet= (PTCharBaseData)GetSharedData(master);
				if(CSharedDatPet == NULL) return;
				if(CSharedDatPet->m_bIsStanding > 1 || CSharedDatPet->m_bIsOnline ==0 || CSharedDatPet->nIsAlive ==0 || CSharedDatPet->fHP <= 0) return;
				DWORD * pPetInventory = GetUserInventory(master);
				if(pPetInventory == NULL) return;
				DWORD * pItem = CInventory::FindFirstItemByClassID(pPetInventory, 6645); //soulshot_beast
				if (pItem == NULL) return; 
				PItemData itmdata = (PItemData)GetSharedData2(pItem);
				if (itmdata == NULL) return; 
				int shots=itmdata->m_nCount;
					short count=1;
					if (summon_level >39) count++; 
					if (summon_level >51) count++;

				//DelItemFromInventory(master, 6645, 1);
				CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_FE00, 0xFE,0,3,6645,count,shots);

				*pDamage = (*pDamage)*2;
				return;
			}

		}

/*
		CSharedDatPet = (PTCharBaseData)GetSharedData(pUser);
		if (CSharedDatPet != NULL)
		if (CSharedDatPet->nIsPC)
		{

		} else {
			//npc attacked		

		}
*/
		




	CombatPointsDamageHandler(pUser, pAttacker, pDamage);


} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts008,0);
   throw;       // Pass exception to some other handler
}


}

static const wchar_t *fnCombatPonts009=L"Elhaym::bool isOnBounty(DWORD *pUser)";
bool isOnBounty(DWORD *pUser)
{

try { _set_se_translator( trans_func );


		int BOUNTY_VICTIM=1740; //
		DWORD * pUserInventory = GetUserInventory(pUser);
		DWORD * pItem = CInventory::FindFirstItemByClassID(pUserInventory, BOUNTY_VICTIM);
		if (pItem != NULL)
			return true; //on bounty
		else
			return false;


} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts009,0);
   throw;       // Pass exception to some other handler
}


}

static const wchar_t *fnCombatPonts010=L"Elhaym::void CombatPointsDamagePoison(DWORD * pUser, DWORD * pAttacker, double * pDamage)";
void CombatPointsDamagePoison(DWORD * pUser, DWORD * pAttacker, double * pDamage)
{

try { _set_se_translator( trans_func );

	if(pUser == NULL)
		return;

	PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pUser);

	if(CSharedDat == NULL)
		return;

	if (CSharedDat->nIsPC ==0)
		return;

				DWORD * pUserData = GetSharedData(pUser);
				ExUser * tempExUser = GetExUser(pUser);
	

				if(tempExUser != NULL)
				{
					
				
					/*
					if ((tempExUser->JUST_TELEPORTED_TICK + AFTER_TELEPORT_TICKMAX) > GetTickCount()) {
							CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
																614, 1 , 0, L"You were attacked too soon after teleportation!");
							*pDamage=0;
							return;

					}
					*/					



				}




} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts010,0);
   throw;       // Pass exception to some other handler
}


}


double divideMe(double x, double y)
{
	if (y == 0)
		return 0;

	double quotient = x/y;
	return quotient;
}

//########################################################################################################
//########################################################################################################
//########################################################################################################
//########################################################################################################
//43cf80	CCreature::AttackedBy(CCreature* pAttacker, double dDamage, DWORD weaponId, DWORD weaponType)
static const wchar_t *fnCombatPonts011=L"Elhaym::void CombatPointsDamageHandler(DWORD * pUser, DWORD * pAttacker, double * pDamage)";
//########################################################################################################
//########################################################################################################
//########################################################################################################

void CombatPointsDamageHandler(DWORD * pUser, DWORD * pAttacker, double * pDamage)
{

try { _set_se_translator( trans_func );

	//#ifdef __DEBUG_VERBOSE__
	//	file << ">>>> CP Damage: Damage: " << *pDamage << " pUser: " << pUser << " pAttacker: " << pAttacker << ".\n";
	//	file.flush();
	//#endif

	if(pUser == NULL || pAttacker == NULL)
		return;
		//#ifdef __DEBUG_VERBOSE__
		//	file << "[DEBUG][CombatPointsDamageHandler] User is PC? " << GetParameter( GetSharedData(pUser), AI_IS_PLAYER)
		//		<< " Attacker is PC? " << GetParameter( GetSharedData(pAttacker), AI_IS_PLAYER) << ".\n";
		//	file.flush();
		//#endif

		DWORD * pUserData = GetSharedData(pUser);
		DWORD * pAttackerData = GetSharedData(pAttacker);
PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pUser);
PTCharBaseData CSharedDatA = (PTCharBaseData)GetSharedData(pAttacker);

		if(pUserData == NULL || pAttackerData == NULL)
			return;

		//no bow attacks on wyvern
	if (CSharedDatA->wWeaponRange>80) {
				if (GetParameter( pAttackerData, AI_MOUNT)==2) {
													*pDamage = 0;  //no bow attacks on wyvern
													return;
				}
	}


		//########################################################################################################
			if( CSharedDat->nIsPC == 0 &&  CSharedDatA->nIsPC == 1)  //PC Attacked NPC
			{
				if (GetParameter( pAttackerData, AI_MOUNT)==2) {
													*pDamage = 0;  //attacker on vywern can't do damage to NPC's
													return;
				}




					TQUESTS myQuest;
							for (int i=0; i <15; i++) {
								myQuest = CSharedDatA->quests[i];
								//check for beast hunt quest
								if (myQuest.quest_id == 341) {
									//how many kills
									if ((myQuest.quest_journal == CSharedDat->m_nNPC_clan_id) || (myQuest.quest_journal == CSharedDat->m_nClassId)) {

										if (myQuest.quest_state >100 && myQuest.quest_state<100000)
											*pDamage = (*pDamage)*(1.01+divideMe(myQuest.quest_state,100000.1));
										if (myQuest.quest_state >100000)
											*pDamage = (*pDamage)*(2.00+divideMe(myQuest.quest_state,10000000.1));
										

									}
									i = 15; //exit for cycle
								}
							}
		if (!IsSummon(CSharedDat->m_nClassId)) {
/*
				//==================================================================
				// START anti box train, 
				// if box_train_limit+ members in party - reduce damage to mob
				//==================================================================
				//check party for same IP address
				DWORD *pParty = GetParty(pAttacker);
				if (pParty != NULL)
				{
				DWORD *pUser1 = NULL;
				DWORD *pUser2 = NULL;
				DWORD ipcount=1;
				DWORD ipcount1=1;
				DWORD ip=0;
				PPARTYSHAREDDATA PartySD = (PPARTYSHAREDDATA) GetSharedData2(pParty);
				if (PartySD != NULL) {


					for( int i =  0; i <=PartySD->m_nOnlineMemberCount-1 ; i ++)
					{ 
					   pUser1 = CCreature::GetCreature(PartySD->pmembers[i].member_id);

					   if (pUser1 != NULL) {
						   ipcount1=1;
						   ip = GetParameter((DWORD *)GetParameter(pUser1, USER_SOCKET), 0x132C); //ip
							for( int k =  i+1; k <=PartySD->m_nOnlineMemberCount-1 ; k ++)
							{ 
							 pUser2 = CCreature::GetCreature(PartySD->pmembers[k].member_id);
							 if (pUser2 != NULL) {
								if (ip == GetParameter((DWORD *)GetParameter(pUser2, USER_SOCKET), 0x132C)) ipcount1++;

							 }

							} //for k
							if (ipcount1 > ipcount) ipcount = ipcount1;
					   } //puser1 not null


					} //for i

						if ((ipcount > box_train_limit) && (ipcount> 1)) {
							if ( User::IsInPVPZone(pAttacker) == false)	*pDamage = (*pDamage)/(ipcount);
						}

				} //partySD not null



				} //party not null


			
				//==================================================================
				// END anti train
				//==================================================================
*/
		}

				return;

			}

			//########################################################################################################
			if( CSharedDat->nIsPC == 1 &&  CSharedDatA->nIsPC == 0)  //NPC Attacked PC
			{
				


				ExUser * tempExUser1 = GetExUser(pUser);
				if(tempExUser1 != NULL)
				{
					//tempExUser1->Attacked = 1;
					if ((CSharedDat->m_nMakerParam1 == OFFLINE_PARAMETER) && (CSharedDat->m_nMakerParam2 == OFFLINE_PARAMETER))
					{ //do not attack offline shops
							*pDamage=0;
							return; 
					}


					if ((tempExUser1->JUST_TELEPORTED_TICK + AFTER_TELEPORT_TICKMAX) > GetTickCount()) {
							CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"You were attacked too soon after teleportation!");
							*pDamage=0;
							return;

					}

					tempExUser1->MOB_HIT_TIME =GetTickCount();
					tempExUser1->MOB_HIT_ID =CSharedDatA->m_nClassId;
					tempExUser1->MOB_HIT_OID =CSharedDatA->nObjectID;
					tempExUser1->MOB_HIT_LEVEL =(BYTE)CSharedDatA->nLevel;

			//	CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), "cdddddd", aOPCODE(OP_SYS_MSG), 
			//		0x5f, 2,1,CSharedDat2->m_nClassId,1,CSharedDat2->nLevel);
					if (CSharedDatA->m_nClassId < 1007000)
					if (tempExUser1->SoulShotEvil > 0)
					{
							*pDamage=(*pDamage) * tempExUser1->SoulShotEvil; //effect1:damage increase 
							//CSharedDatA->_fHpRegen = CSharedDatA->_fHpRegen * tempExUser1->SoulShotEvil; //effect2: HP regeneration increase
							//CSharedDatA->_fMpRegen = CSharedDatA->_fMpRegen * tempExUser1->SoulShotEvil; //effect3: MP regeneration increase
							tempExUser1->SoulShotEvil = 0;
							/*
							Event: Souls rebellion
							 now soulshots sometimes give power not only to player
							 but no his NPC enemy too

							*/
					} else {
						if ((CSharedDatA->nLevel - CSharedDat->nLevel) > 9)
						{
							*pDamage = (*pDamage) * 1.2;
						}
						if ((CSharedDatA->nLevel - CSharedDat->nLevel) > 4)
						{
							*pDamage = (*pDamage) * 1.1;
						}
						if ((CSharedDatA->nLevel - CSharedDat->nLevel) > 0)
						{
							*pDamage = (*pDamage) * 1.05;
						}
					}


					if 	(CSharedDat->fHP <= *pDamage) {
								tempExUser1->GoingToDie = 1;
								tempExUser1->DeathTimer = GetTickCount();
					}




				}
				return;

			}




			if( CSharedDat->nIsPC !=1 ||  CSharedDatA->nIsPC !=1)  
															return;


			//########################################################################################################
			/////////////////
			//PC ATTACKED PC
			/////////////////


				if (User::IsInPeaceZone(pAttacker))
				{
							*pDamage=0;
							return;		

				}

	ExUser * tempExUser = GetExUser(pUser);
	ExUser * tempExUserA = GetExUser(pAttacker);


				if(tempExUser != NULL)
				{
					//tempExUser->Attacked = 1;

	

					if ((tempExUser->JUST_TELEPORTED_TICK + AFTER_TELEPORT_TICKMAX) > GetTickCount()) {
							CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"You were attacked too soon after teleportation!");
							*pDamage=0;
							return;

					}
				



//#############################
//-------------------------------------------------
// check for buff (5182) and karma x levels more
//-------------------------------------------------
if ( (CSharedDatA->nKarma>0) && (CSharedDat->nKarma == 0) && (CSharedDat->nLevel<pr_level) )
{
	if ((CSharedDatA->nLevel-CSharedDat->nLevel) >= pr_level_diff) {
		if ((CSharedDat->x <65544) || (CSharedDat->y < -163848)) //newbie location limit
		{
		if (tempExUser->PK_PROTECTION > 0)
		{
							CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"You were attacked by high level PK!");
							CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
							614, 1 , 0, L"This person is protected by Lord's magic. Find the victim of your level!");
							*pDamage=0;
							return;

		}
		}

	}

				
}

if 	(CSharedDat->fHP <= *pDamage) {
				tempExUser->GoingToDie = 1;
				tempExUser->DeathTimer = GetTickCount();
}


//###############################################
//protection removed because karma vas attacked
if ( (CSharedDatA->nKarma==0) && (CSharedDat->nKarma > 0))
{
	if ((CSharedDat->nLevel-CSharedDatA->nLevel) >= pr_level_diff) {
		tempExUserA->PK_PROTECTION = 0; //protection removed

	}
}

	
//#############################
//if victim is PK
if (CSharedDat->nKarma > 0) {
						
			return;
}

//#############################
//if karma killed newbie
if (CSharedDatA->nKarma > 0) {
	if ((CSharedDat->fHP <= *pDamage) && (CSharedDat->nKarma == 0) && (CSharedDat->m_nPvPflag1 == 0) && (CSharedDat->nLevel < 40)) {
			NPCContainer2::Instance()->PKHunt(pAttacker);
	}
	return; //further karma can do anything, we exiting function
}


//####################################
//damage is high, we need chek for PK
if ((CSharedDat->fHP <= *pDamage) && (CSharedDatA->nKarma == 0) && (CSharedDat->m_nPvPflag1 == 0)) 
{
	tempExUserA->pk_checker = 1;

}


//#############################
//if victim HP is 0 already
if (CSharedDat->fHP <= 0)
				return;


//#############################
//if attacker is flagged already
if (CSharedDat->m_nPvPflag1 > 0)
				return;

//#############################
if (((CSharedDat->fHP/CSharedDat->fMaxHP)<0.1) ) 
				return;

//#############################
//--if MOB is attacking PC-victim and there another PCs starts to attack PC-victim, and HP is still high, combat points will be in use
//--if hp falls below 10% let PCs finish PC-victim and maybe get karma
//also mob must be form standart array of mobs: no summons, no guards
if (((GetTickCount() - tempExUser->MOB_HIT_TIME) > 2000) || (tempExUser->MOB_HIT_ID > 1003000) || (tempExUser->MOB_HIT_LEVEL < (CSharedDat->nLevel - 9)))
										return;

					




					
					//Check if we even HAVE CP
					if(tempExUser->CurrentCP != 0)
					{

						if(*pDamage > tempExUser->CurrentCP)
						{
							//CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), "cdddd", aOPCODE(OP_SYS_MSG), 35, 1,1,*pDamage-tempExUser->CurrentCP);

							*pDamage -= tempExUser->CurrentCP;
							tempExUser->CurrentCP = 0;
						}
						else if(*pDamage < tempExUser->CurrentCP)
						{

							//CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), "cdddd", aOPCODE(OP_SYS_MSG), 35, 1,1,*pDamage);
							CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), "cd", aOPCODE(OP_SYS_MSG), 43); //missed target

							tempExUser->CurrentCP -= *pDamage;
							*pDamage = 0;
						}
						else //damage == currentCP
						{
							//CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), "cdddd", aOPCODE(OP_SYS_MSG), 35, 1,1,*pDamage);
							CSocketOLD::Send((DWORD *)GetParameter(pAttacker, USER_SOCKET), "cd", aOPCODE(OP_SYS_MSG), 43); //missed target
							tempExUser->CurrentCP = 0;
							*pDamage = 0;
						}

						//Send a StatusUpdate packet
						if ((tempExUser->CurrentCP < tempExUser->MaxCP)   && (get_L2_CHRONICLE() > 2)) {
							if (get_L2_CHRONICLE() > 16) {
							CSocketOLD::Send( (DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_STATUSU_Lind558_2, aOPCODE(OP_STATUS_UPDATE), GetParameter(pUser, OBJECT_ID),GetParameter(pUser, OBJECT_ID),1, 2, STATUS_MAX_CP, tempExUser->MaxCP, STATUS_CUR_CP, tempExUser->CurrentCP);
							} else {
							CSocketOLD::Send( (DWORD *)GetParameter(pUser, USER_SOCKET), FORMAT_STATUSU_Awake1, aOPCODE(OP_STATUS_UPDATE), GetParameter(pUser, OBJECT_ID), 2, STATUS_MAX_CP, tempExUser->MaxCP, STATUS_CUR_CP, tempExUser->CurrentCP);
							}
						}

						//####################################
						//damage is high, we need chek for PK
						if ((CSharedDat->fHP <= *pDamage) && (CSharedDatA->nKarma == 0) && (CSharedDat->m_nPvPflag1 == 0)) 
						{
							tempExUserA->pk_checker = 1;
						} else {
							tempExUserA->pk_checker = 0;
						}


						if 	(CSharedDat->fHP <= *pDamage) {
								tempExUser->GoingToDie = 1;
								tempExUser->DeathTimer = GetTickCount();
						} 

					
					}
					



				} //tempExUser != NULL


} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts011,0);
   throw;       // Pass exception to some other handler
}


}

static const wchar_t *fnCombatPonts012=L"Elhaym::void CombatPointsLevelChange(DWORD * pUser, bool bLevelUp)";

void CombatPointsLevelChange(DWORD * pUser, bool bLevelUp)
{

	try { _set_se_translator( trans_func );

	if(pUser != NULL)
	{
		DWORD * pUserData = GetSharedData(pUser);
		if( pUserData != NULL )
		{
			if( GetParameter( pUserData, AI_IS_PLAYER) )
			{
				//Get ExUser
				ExUser * tempExUser = GetExUser(pUser);

				//Get level, classID, and the stat CON
				BYTE level = (BYTE)GetParameter(pUserData, AI_LEVEL);
				BYTE classID = (BYTE)GetParameter(pUserData, AI_CLASS_ID);
				BYTE statCON = (BYTE)GetParameter(pUserData, AI_CON);



				//Set Max CP
				tempExUser->trueMaxCP = (DWORD)(double)GetMaxCP(level, classID, statCON);
				tempExUser->MaxCP=tempExUser->trueMaxCP + tempExUser->RPK + (int)(tempExUser->occupiedcells*tempExUser->trueMaxCP/10);

				 
				if(bLevelUp) 
				{
						
				}
			}
		}
	}

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts012,0);
   throw;       // Pass exception to some other handler
}


}

void CombatPointsLevelChangeGF(DWORD * pUser, bool bLevelUp)
{
	try { _set_se_translator( trans_func );

	if(pUser != NULL)
	{
		DWORD * pUserData = GetSharedData(pUser);
		if( pUserData != NULL )
		{
			if( GetParameter( pUserData, AI_IS_PLAYER) )
			{
				//Get ExUser
				ExUser * tempExUser = GetExUser(pUser);

				//Get level, classID, and the stat CON
				BYTE level = (BYTE)GetParameter(pUserData, AI_LEVEL);
				BYTE classID = (BYTE)GetParameter(pUserData, AI_CLASS_ID);
				BYTE statCON = (BYTE)GetParameter(pUserData, AI_CON);



				//Set Max CP
				tempExUser->trueMaxCP = (DWORD)(double)GetMaxCP(level, classID, statCON);
				tempExUser->MaxCP=tempExUser->trueMaxCP + tempExUser->RPK + (int)(tempExUser->occupiedcells*tempExUser->trueMaxCP/10);

				 
				if(bLevelUp) 
				{
						
//level up social action for Gracia Final and up:
						CSocketOLD::Send( (DWORD *)GetParameter(pUser, USER_SOCKET), "cdd", 
											0x27, GetParameter(pUser, OBJECT_ID), 2122 ); 
					
				}
			}
		}
	}

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts012,0);
   throw;       // Pass exception to some other handler
}
}


static const wchar_t *fnCombatPonts013=L"Elhaym::void CombatPointsDie(DWORD * pUser)";
void CombatPointsDie(DWORD * pUser)
{

	try { _set_se_translator( trans_func );

	if(pUser != NULL)
	{
		PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pUser);
		if (CSharedDat->nIsPC == 1)
		//if( GetParameter( GetSharedData(pUser), AI_IS_PLAYER) )
		{
			//Get ExUser
			ExUser * tempExUser = GetExUser(pUser);

			//Set our CP to 0 since we died
			tempExUser->CurrentCP = 0;
			tempExUser->maraudertime = GetTickCount(); //mauraudering will be enabled after little bit time
			tempExUser->PlayerJustDied = 1; //pc die indicator
			tempExUser->MaxCP=tempExUser->trueMaxCP + tempExUser->RPK + (int)(tempExUser->occupiedcells*tempExUser->trueMaxCP/10);

			if (CSharedDat->m_nMakerParam1 == 2) CSharedDat->m_nMakerParam1 = CSharedDat->nLevel;

		} else {

//####################################################################################
//for premium feature
//####################################################################################
			DWORD * pAttacker= CCreature::GetCreature(CSharedDat->nLastAttackerIndex);
			bool smon=false;
			if (pAttacker == NULL) {
				//LOG->Add(FULL_LOG,"attacker not found" );
				return;			
			}
			PTCharBaseData CSharedDat2 = (PTCharBaseData)GetSharedData(pAttacker);
			if (CSharedDat2 == NULL) {
				//LOG->Add(FULL_LOG,"attacker SD null" );
				return;
			}
			//LOG->Add(FULL_LOG,"[%S] attacked by [%S] master=[%d]", CSharedDat->wszName, CSharedDat2->wszName, CSharedDat2->master);

			if (CSharedDat2->nIsPC == 0)
			{
				
				pAttacker=CCreature::GetMaster(pAttacker);
				if (pAttacker == NULL) {
					//LOG->Add(FULL_LOG,"master null" );
					//pAttacker=CCreature::Summon_GetMaster(pAttacker); //pAttacker+1064h			
					return;
				} //else LOG->Add(FULL_LOG,"master found" );
				/*
				if (pAttacker == NULL) {
					//LOG->Add(FULL_LOG,"summon master null" );
					CSharedDat2 = (PTCharBaseData)CSharedDat2->master;
					if (CSharedDat2 == NULL) {
						//LOG->Add(FULL_LOG,"...master's SD null" );
						return;
					} //else LOG->Add(FULL_LOG,"SD master found" );
					if (CSharedDat2->m_Meal > 0) {
							CSharedDat->m_Meal = 1;
							//LOG->Add(FULL_LOG,"...master found!" );

					} //else LOG->Add(FULL_LOG,"master not premium" );  
					return;
				} //else LOG->Add(FULL_LOG,"summon master found" );
				*/
				CSharedDat2 = (PTCharBaseData)GetSharedData(pAttacker);
				if (CSharedDat2 == NULL) {
					//LOG->Add(FULL_LOG,"master's SD null" );
					return;
				} //else LOG->Add(FULL_LOG,"master's SD ok" );
				smon=true;
				//LOG->Add(FULL_LOG,"[%S] attacked by [%S]", CSharedDat->wszName, CSharedDat2->wszName);	
				
			}
			
			if (CSharedDat2->nIsPC == 1)
			{
			//SSQ
/*
				int tile=map_tile((int)CSharedDat->x, (int)CSharedDat->x);
				if ((tile == 1810 || tile == 1910 || tile == 2010)) {
					DWORD kills = 10;
					ExUser * tempExUserA = GetExUser(pAttacker);
					if (tempExUserA != NULL) {
						kills = (DWORD)tempExUserA->SSQ_KILLS*1.5 + kills;
					}
					if (MyRandom(100)< kills) CSharedDat->m_Meal = 1; //rates increase to 2x
										//for adena and reources in SSQ zone
					if (MyRandom(1000)< kills) CSharedDat->m_Meal = 2; //rates increase to 3x 

				
				}
*/



				if (FindBuffINSharedData(pAttacker,CSharedDat2, 2580)>0) // Herb of Vitality
					CSharedDat->m_Meal = 1;


				if (CSharedDat2->m_Meal > 0)
				{
					if (smon) {
						CSharedDat->m_Meal = 1;
						//LOG->Add(FULL_LOG,"summon master premium" );
					} else {
						CSharedDat->m_Meal = 1; //only 2x premium //CSharedDat2->m_Meal;
						//LOG->Add(FULL_LOG,"premium" );
					}
					if (SERVER_RATES_MULTIPLY_ADENA > 1)
						CSharedDat->m_Meal=(int) (((CSharedDat->m_Meal + 1) * SERVER_RATES_MULTIPLY_ADENA) - 1);
				} else {
					//LOG->Add(FULL_LOG,"not premium" );
					if (SERVER_RATES_MULTIPLY_ADENA > 1)
						CSharedDat->m_Meal=SERVER_RATES_MULTIPLY_ADENA-1;

				}

				

			}
//####################################################################################


//npc died
//handled before item drop distribution
			if (CSharedDat->m_nClassId == CRAZY_FARMER) {
				NPCContainer::Instance()->DeleteNPC((BYTE *)pUser);
				//CNPC::MakeGuilty(pUser,pAttacker,true);
			}




		}
	}

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts013,0);
   throw;       // Pass exception to some other handler
}



}

/*
void CombatPointsDieCursed(DWORD * pUser)
{
	if(pUser != NULL)
	{
		PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pUser);
		if (CSharedDat->nIsPC == 1)
		//if( GetParameter( GetSharedData(pUser), AI_IS_PLAYER) )
		{
			//Get ExUser
			ExUser * tempExUser = GetExUser(pUser);

			//Set our CP to 0 since we died
			tempExUser->CurrentCP = 0;
			if ((CSharedDat->nWeaponClassId == cZariche) || (CSharedDat->nWeaponClassId == cAkamanah) )	
				if (tempExUser->Zariche == 0 || CSharedDat->nKarma == 0) { 
						tempExUser->cKarma = cNumber;
						tempExUser->Zariche= cLifetime;
						if (!CursedContainer::Instance()->UserExists((BYTE *)pUser)) 
							CursedContainer::Instance()->AddUser((BYTE *)pUser);
				}

			if (tempExUser->Zariche > 10 && MyRandom(100) < 50)
									tempExUser->Zariche = cLifetime; //50% to lose cursed weapon on death

			tempExUser->PlayerJustDied = 1; //pc die indicator
			//red sky
			//if (L2_CHRONICLE > 4)
			//		RedSky((DWORD *)GetParameter(pUser, USER_SOCKET), 4);


		} else {
//-----------------------------------------------------
//zariche and akamanah giving time
//-----------------------------------------------------
if (MyRandom(100)<cChances) {
		DWORD * pAttacker= CCreature::GetCreature(CSharedDat->nLastAttackerIndex);
		if (pAttacker == NULL) return;
		CSharedDat = (PTCharBaseData)GetSharedData(pAttacker);
		if ((CSharedDat->nIsPC == 1) &&  (CSharedDat->nIsAlive == 1) && (CSharedDat->nLevel > 4))
		{
//at level 4 and lover player have not death penaldy, so karma do not removed after death
					ExUser * tempExUser = GetExUser(pAttacker);
					if (tempExUser != NULL)
						tempExUser->Fishing = true; //give zariche
		}
}
//-----------------------------------------------------
		}
	}
}
*/

void RedSky(DWORD *pSocket, int skyTime) {
			//red sky
			CSocketOLD::Send(pSocket, "chd", aOPCODE(OP_EXTENDED), aOPCODEx(0x40), skyTime);
}

static const wchar_t *fnCombatPonts014=L"Elhaym::void StartCombatPointPotion(DWORD * pUser, WORD itemID)";
void StartCombatPointPotion(DWORD * pUser, WORD itemID)
{
	try { _set_se_translator( trans_func );

	if(pUser != NULL)
	{
		if( GetParameter( GetSharedData(pUser), AI_IS_PLAYER) )
		{

			ExUser * tempExUser = GetExUser(pUser);
			BYTE percentCP =1;
/*
			DWORD currTick = GetTickCount();
			float percentCP = 1;
			if (currTick - tempExUser->PotionTimer < CP_POTION_TIME) {
				percentCP = (currTick - tempExUser->PotionTimer) / CP_POTION_TIME;
			} else {
				tempExUser->PotionTimer = currTick;
			}
*/

			if( itemID == CP_POTION )
				tempExUser->CurrentCP += (DWORD)(CP_POTION_HEAL*percentCP);
			else if( itemID == CP_GREATER_POTION || itemID == CP_GREATER_POTION2 )
				tempExUser->CurrentCP += (DWORD)(CP_GREATER_POTION_HEAL*percentCP);

			if( tempExUser->CurrentCP > tempExUser->MaxCP)
					tempExUser->CurrentCP = tempExUser->MaxCP;
		}
	}

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts014,0);
   throw;       // Pass exception to some other handler
}


}

static const wchar_t *fnCombatPonts015=L"Elhaym::void BuilderCommandHealthyCP(DWORD * pUser)";
void BuilderCommandHealthyCP(DWORD * pUser)
{
try { _set_se_translator( trans_func );

	if(pUser != NULL)
	{
		PTCharBaseData CSharedDatPet = (PTCharBaseData)GetSharedData(pUser);
		if (CSharedDatPet == NULL) return;
		if( CSharedDatPet->nIsPC == 1 )
		{
			//Get ExUser
			ExUser * tempExUser = GetExUser(pUser);

			//Restore our CP values to max
			//if ((L2_CHRONICLE>2) && (DISABLE_CP==0)) 
				tempExUser->CurrentCP = tempExUser->MaxCP;

		} else {

//server not allows use on NPC
	//		if ((CSharedDatPet->m_nClassId == 1012077) 
	//		|| (CSharedDatPet->m_nClassId == 1012311) || (CSharedDatPet->m_nClassId == 1012312) || (CSharedDatPet->m_nClassId == 1012313)
	//		|| (CSharedDatPet->m_nClassId == 1012526) || (CSharedDatPet->m_nClassId == 1012527) || (CSharedDatPet->m_nClassId == 1012528)
	//		|| (CSharedDatPet->m_nClassId == 1006040) || (CSharedDatPet->m_nClassId == 1012564) || (CSharedDatPet->m_nClassId == 1012621)
	//		) {
	//			CSharedDatPet->m_Meal = CSharedDatPet->m_MaxMeal;
//
//			}
		}
	}

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts015,0);
   throw;       // Pass exception to some other handler
}


}

static const wchar_t *fnCombatPonts016=L"Elhaym::DWORD GetMaxCP(BYTE level, BYTE classID, BYTE statCON)";
DWORD GetMaxCP(BYTE level, BYTE classID, BYTE statCON)
{
	try { _set_se_translator( trans_func );

	#ifdef __DEBUG_VERBOSE__
		fileEx << "[DEBUG][GetMaxCP] Level: " << (DWORD)level << " ClassID: " << (DWORD)classID << " CON: " << (DWORD)statCON << "\n";
		fileEx.flush();
	#endif

	//Grab our base CON multiplier for all classes
	double multiplier = ConMultiplier[statCON-1];

	//If the classID is for base classes, 1st classes, or 2nd classes
	if( classID <= 57 )
	{
		
		double maxCP = CPByClassID[classID][level-1];
		maxCP = (maxCP * multiplier);

		//freya CT2.5 change
		if (classID == 16) 
			maxCP = (maxCP * 1.29);
		else if (classID == 30 || classID == 43) 
			maxCP = (maxCP * 1.8);
		else if (classID == 51)
			maxCP = (maxCP * 1.13);
		else if (classID == 12 || classID == 40 || classID == 27) 
			maxCP = (maxCP * 1.2);

		return maxCP;
	}

/*
	//else if classID is for the 3rd classes
	else if(classID >= 88 || classID <= 118)
	{
		double maxCP = CPByClassIDFor3rdClass[classID-88][level-1];
		maxCP = (maxCP * multiplier);
		return maxCP;
	}
*/
	//if there are bad arguments passed, return 0
	return 0;


} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts016,0);
   throw;       // Pass exception to some other handler
}


}

static const wchar_t *fnCombatPonts016a=L"Elhaym::DWORD GetMaxVP(BYTE level, BYTE classID, BYTE statCON)";
DWORD GetMaxVP(BYTE level, BYTE classID, BYTE statCON)
{
	try { _set_se_translator( trans_func );

	#ifdef __DEBUG_VERBOSE__
		fileEx << "[DEBUG][GetMaxCP] Level: " << (DWORD)level << " ClassID: " << (DWORD)classID << " CON: " << (DWORD)statCON << "\n";
		fileEx.flush();
	#endif

	//Grab our base CON multiplier for all classes
	double multiplier = ConMultiplier[statCON-1];

	//If the classID is for base classes, 1st classes, or 2nd classes
	if( classID <= 57 )
	{
		
		double maxCP = CPByClassID[classID][level-1];
		maxCP = (maxCP * multiplier);
		return maxCP;
	}


	//if there are bad arguments passed, return 0
	return 0;


} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts016a,0);
   throw;       // Pass exception to some other handler
}


}




//

void CP_patch()
{
	// Hook CCreature::ChangeClass()
	WriteHook(JMP_HOOK,0x00452851, HookCCreatureChangeClass, 0);
	// Hook CCreature::Die() / Buffs After Death Exploit Fix
	WriteHook(JMP_HOOK,0x0044F840, HookCCreatureDie, 0);
	// CCreature::LevelUp Hook
	WriteHook(JMP_HOOK,0x004517B9, HookCCreatureLevelUp, 0);
	// CCreature::LevelDown Hook
	WriteHook(JMP_HOOK,0x00451575, HookCCreatureLevelDown, 1);
	// CCreature::UseItem Hook
	WriteHook(JMP_HOOK,0x0044374E, HookCCreatureUseItem, 0);
	// CP Regeneration Hook
	WriteHook(JMP_HOOK,0x004E6E80, HookCombatPointsRegeneration, 0);
	// CP Damage Hook
	//43cf80	CCreature::AttackedBy(CCreature* pAttacker, double dDamage, DWORD weaponId, DWORD weaponType)
	WriteHook(JMP_HOOK,0x0043CF9C, HookCombatPointsDamage, 0);
	// Builder Command //healthy fix for CP
	WriteHook(JMP_HOOK,0x00421502, BuilderCommandHealthyFix, 1);

	//combat points
	WriteHook(JMP_HOOK,0x004DB9AD, CSkillEffect_i_p_attack_over_hit, 1);
	WriteHook(JMP_HOOK,0x004d749c, CSkillEffect_i_death_link, 1);
	WriteHook(JMP_HOOK,0x004DB795, CSkillEffect_i_p_attack, 1);
	WriteHook(JMP_HOOK,0x004dbdc1, CSkillEffect_i_fatal_blow, 1);
	WriteHook(JMP_HOOK,0x004dc12d, CSkillEffect_i_hp_drain, 1);
	WriteHook(JMP_HOOK,0x004dc54c, CSkillEffect_i_m_attack, 1);
	WriteHook(JMP_HOOK,0x004dd1cb, CSkillEffect_i_backstab, 1); //backstab bypass CP ???
	WriteHook(JMP_HOOK,0x004d6d16, CSkillEffect_i_energy_attack, 1);
	WriteHook(JMP_HOOK,0x004D7a36, CSkillEffect_i_cub_m_attack, 1);
	WriteHook(JMP_HOOK,0x004d7b60, CSkillEffect_i_cub_hp_drain, 1);

	//WriteHook(JMP_HOOK,0x004DA96e, CSkillEffect_t_hp__Tick, 0);
	//WriteHook(JMP_HOOK,0x004DAA4D, CSkillEffect_t_cub_hp__Tick, 0); //not tested

//		WriteHook(JMP_HOOK,0x004d99bf, CSkillEffect_p_damage_shield_Check, 2);
//		WriteHook(JMP_HOOK,0x004D9A34, CSkillEffect_p_damage_shield_Pump, 2);

WriteHook(JMP_HOOK,0x0043D070, CreatureAttackedBy_DamageShield, 3);

	

}

static const wchar_t *fnCombatPonts017=L"Elhaym::void PetAutofood(DWORD *pUser)";
void PetAutofood(DWORD *pUser)
{
	try { _set_se_translator( trans_func );

	if (pUser == NULL) return;
	if (User::CheckTrade(pUser)) return;
	PTCharBaseData CSharedDatPet= (PTCharBaseData)GetSharedData(pUser);
	if(CSharedDatPet == NULL) return;
	if(CSharedDatPet->m_bIsStanding > 1 || CSharedDatPet->m_bIsOnline ==0 || CSharedDatPet->nIsAlive ==0 || CSharedDatPet->fHP <= 0) return;

	DWORD *pPet= User::GetPet(pUser);
	if (pPet == NULL) return;
	CSharedDatPet= (PTCharBaseData)GetSharedData(pPet);
	if(CSharedDatPet == NULL) return;
	DWORD * pPetInventory = GetUserInventory(pUser);
	if(pPetInventory == NULL) return;
	if (0.55*CSharedDatPet->m_MaxMeal > CSharedDatPet->m_Meal) {
		DWORD meal = 2515; //food for wolves
		if (CSharedDatPet->m_nClassId > 1012077) meal = 4038; //HATCHLING FOOD
		if (CSharedDatPet->m_nClassId > 1012525) meal = 5168; //STRIDER FOOD
		if (CSharedDatPet->m_nClassId > 1012528) meal = 5169; //deluxe STRIDER FOOD
		DWORD * pItem = CInventory::FindFirstItemByClassID(pPetInventory, meal); 
		if (pItem == NULL) return; 
		//pet autofood
		CSharedDatPet->m_Meal = CSharedDatPet->m_Meal + 100;
		DelItemFromInventory(pUser, meal, 1);
	}

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts017,0);
   throw;       // Pass exception to some other handler
}


}

static const wchar_t *fnCombatPonts018=L"Elhaym::int FindBuffINSharedData(DWORD *pUser, PTCharBaseData CSharedDat, int buffID)";
int FindBuffINSharedData(DWORD *pUser, PTCharBaseData CSharedDat, int buffID)
{
try { _set_se_translator( trans_func );

	PTUserData PartyUser =(PTUserData)pUser; //?? GetSharedData(pUser)
	PTBuff Pt_Buff;
	int size;
	int pInt=0;

      size =  int(PartyUser->LastBuff - PartyUser->FirstBuff); // /  16;
	  if (size >21)
		  size = 21;

if (size >0)
{
      Pt_Buff =  PartyUser->FirstBuff;
	  if (Pt_Buff == NULL) {
						return 0;
	  }
	  //int strj = 4;
      for(int j =  0; j <=size -1 ; j ++)
       { 
			pInt=Pt_Buff->BuffData->Buff_id;
		//	if (pInt > 0)
		//		CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), "cdddd", aOPCODE(OP_SYS_MSG), 35, 1,1,pInt);
			if (pInt == buffID) return Pt_Buff->BuffData->Buff_level;
			if ((pInt > 10000) && (buffID == 10000)) return 1; //check for all NPC buffer BUFFs if requested id = 10000
			//pInt=Pt_Buff->BuffData->Buff_level;
			//pInt=Pt_Buff->BuffData->Buff_duration;


        Pt_Buff++;
       } 
}
return 0;

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts018,0);
   throw;       // Pass exception to some other handler
}

}

static const wchar_t *fnCombatPonts018a=L"Elhaym::int FindOverbuff(DWORD *pUser, PTCharBaseData CSharedDat)";
int FindOverbuff(DWORD *pUser, PTCharBaseData CSharedDat)
{
try { _set_se_translator( trans_func );

	PTUserData PartyUser =(PTUserData)pUser; //?? GetSharedData(pUser)
	PTBuff Pt_Buff;
	int size;
	int pInt=0;
	int buffID = 0;

      size =  int(PartyUser->LastBuff - PartyUser->FirstBuff); // /  16;
	  if (size >21)
		  size = 21;

if (size >0)
{
      Pt_Buff =  PartyUser->FirstBuff;
	  if (Pt_Buff == NULL) {
						return 0;
	  }
	  
      for(int j =  0; j <=size -1 ; j ++)
       { 
			pInt=Pt_Buff->BuffData->Buff_id;
			//LOG->Add(FILE_LOG,"[%S] check overbuff [%d], slot [%d] ", CSharedDat->wszName, pInt,j);
			if (j == 0) {
				buffID = pInt;
			} else {
				if (pInt == buffID)
					return buffID;
			}
			
        Pt_Buff++;
       } 
}
return 0;

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts018a,0);
   throw;       // Pass exception to some other handler
}

}



int FindBuffinSD_Real(DWORD *pUser, PTCharBaseData CSharedDat, int buffID)
{


	for (int i=0; i<20; i++) {
		TBUFF buff = CSharedDat->buffs[i];
		CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), "cdddddd", aOPCODE(OP_SYS_MSG), 0x5f, 2,1,buff.buff_id,1,buff.buff_level);		
		if (buff.buff_id == buffID)
			return buff.buff_level;
	}

	return 0;



}



static const wchar_t *fnCombatPonts019=L"Elhaym::double CombatPointsDistance(DWORD * pUser,double x1, double y1, double z1, double maxDist)";
double CombatPointsDistance(DWORD * pUser,double x1, double y1, double z1, double maxDist)
{
	try { _set_se_translator( trans_func );

					PTCharBaseData CSharedDat;
					if (pUser != NULL) 
						CSharedDat = (PTCharBaseData)GetSharedData(pUser);
					else 
						return 0;



	double x2 = CSharedDat->x;
					if ((x2 - x1) > maxDist) {
						return 0;
					}
	double y2 = CSharedDat->y;
					if ((y2 - y1) > maxDist) {
						return 0;
					}
	double z2 = CSharedDat->z;
					if ((z2 - z1) > maxDist) {
						return 0;
					}


	return sqrt(pow(abs(x2-x1),2)+pow(abs(y2-y1),2)+pow(abs(z2-z1),2));



} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnCombatPonts019,0);
   throw;       // Pass exception to some other handler
}



}


