#include <stdio.h>
#include <string.h>
//#include <sstream>
//#include <iomanip>
#include <stdlib.h>


#pragma once

char *EncPwdL2(char *Password)
{
	char	Key[16];
	
	memcpy(Key, Password, 16);

	int *v2 = (int *) &Key[0];
  	int *v3 = (int *) &Key[4];
  	int *v4 = (int *) &Key[8];
  	int *v5 = (int *) &Key[12];

	*v2 = 213119 * *v2 + 2529077;
	*v3 = 213247 * *v3 + 2529089;
	*v4 = 213203 * *v4 + 2529589;
	*v5 = 213821 * *v5 + 2529997;
	 
	Password[0] = Key[0] ^ Password[0];
	  
	for ( int Index = 1; Index < 16; ++Index )
		Password[Index] ^= Key[Index] ^ Password[Index - 1];
	  
	for ( int Index = 0; Index < 16; ++Index )
		if ( !Password[Index] ) { Password[Index] = 102; }

	return Password;
		

}

char GetHexVal(char Hex)
{
	switch(Hex) {
		case '0': return(0);
		case '1': return(1);
		case '2': return(2);
		case '3': return(3);
		case '4': return(4);
		case '5': return(5);
		case '6': return(6);
		case '7': return(7);
		case '8': return(8);
		case '9': return(9);
		case 'A': return(10);
		case 'B': return(11);
		case 'C': return(12);
		case 'D': return(13);
		case 'E': return(14);
		case 'F': return(15);
		case 'a': return(10);
		case 'b': return(11);
		case 'c': return(12);
		case 'd': return(13);
		case 'e': return(14);
		case 'f': return(15);
	}
	
	return(0);
}


void Hex2Bin(char *Src, char *Dst)
{
	int	Index = 0;

	while ( Src[Index] ) {
		Dst[Index / 2] = 16 * GetHexVal(Src[Index]) + GetHexVal(Src[Index + 1]);
		
		Index += 2;
	}
}


char hexval[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};


void Str2Hex(char *Src, char *Dest)
{
	Dest[0]=0x30;
	Dest[1]=0x78;
	for(int j = 0; j < 16; j++){
		Dest[(j*2) + 2] = hexval[((Src[j] >> 4) & 0xF)];
		Dest[(j*2) + 3] = hexval[(Src[j]) & 0x0F];
	}
}