/* 
 * Lineage II Extension Project - Affectionately known as the L2EP 'Elhaym' Project/DLL
 * Property of Michael Sadlon a.k.a. mcrabben7 [mcrabben7@gmail.com]
 * Team Effort along with RipperX, Annatar, Nevyn, and with some help from others.
 * 
 * The goals of this project are to expand the aging Lineage II Chronicle 1 server
 * to support the functionality in C3 and C4, and is made to work with the C4 client.
 * 
 * This project is open-source.  It is released from time to time by our discretion.
 * Anyone who has this code, or this DLL, and chooses to use it or learn from it frees
 * us from ALL liabilities.  USE AT YOUR OWN RISK.
 * 
 * I have chosen to release this (you can read the license in License.txt) with the caveat
 * that you may NOT sell our work, any derivative of our work, or make a profit in any way
 * related to our work or a derivative of our work WITHOUT OUR EXPRESS PERMISSION.
 * 
 * Please see License.txt for the full details.  Make sure you READ it!
 */

#include "AutoSS.h"
//#include "memoryFuncs.h"


//--------------------------------------------------------------------------------------------
//// Function Definitions
//--------------------------------------------------------------------------------------------

/*DWORD WINAPI AutoSSThreadHandler(LPVOID lpParameter)
{
	AutoState * autoState = (AutoState *)lpParameter;
	//file << "<<<< Entered AutoSSThreadHandler: pSocket: " << hex << autoState->pSocket 
	//	<< " itemID: " << autoState->itemID << ".\n";
	//file.flush();
	RefreshAutoSS(autoState->pSocket, autoState->itemID);
	return 1;
}*/





//static const wchar_t *fnAutoSS001=L"Elhaym::void RequestAutoSS(DWORD * pSocket, WORD itemID, BYTE setting)";
void RequestAutoSS(DWORD * pSocket, WORD itemID, BYTE setting, BYTE shotsevent)
{
//try { _set_se_translator( trans_func );


	if (pSocket != NULL)
	{
		DWORD * pUser = GetUser(pSocket);

		if(pUser != NULL)
		{
			ExUser * tempExUser = GetExUser(pUser);
			if (User::IsInPVPZone(pUser)){
				CSocketOLD::Send(pSocket, "cd", aOPCODE(OP_SYS_MSG), 113); //cannot be used
				tempExUser->AutoSpiritShot = 0;
				tempExUser->AutoSoulShot = 0;
				return; //no shots in pvp zone
			}

			//if( !bPrivateStore && !bActiveRequest && bIsAlive )
			//{
				DWORD * pUserInventory = GetUserInventory(pUser);
				

				//our check booleans
				bool bSendMsg = false;
				bool bUseItem = false;
				//our msgID for later
				WORD msgID = NULL;

				//if ItemID == SoulShot types NG through S grade, or Novice SoulShot
				if( (itemID >= 1463 && itemID <= 1467) || itemID == 1835 || itemID == 5789 || (itemID >= 6535 && itemID <= 6540) ) //blessed soulshots:helios:(itemID >= 6535 && itemID <= 6540)
				{
					//those new C6 soulshot must be osed with melee weapons only
					//if (itemID >= 6535 && itemID <= 6540) {
					//	PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pUser);
					//	if (CSharedDat->wWeaponRange>80) return;
					//}
					//if Auto SoulShots is NOT already enabled
					//OR if there is an enable/disable on the SAME item
					//THEN go ahead and make the proper changes
					if( (tempExUser->AutoSoulShot == 0) || (tempExUser->AutoSoulShot == itemID) )
					{
						if( setting )
						{
							tempExUser->AutoSoulShot = itemID;
							bUseItem = true;
						}
						else
						{
							tempExUser->AutoSoulShot = 0;
						}
						bSendMsg = true;
					}
				}
				//if ItemID == SpiritShot types NG through S grade, or Novice SpiritShot
				else if( (itemID >= 3947 && itemID <= 3952) || itemID == 5790 || ( itemID >= 2509 && itemID <= 2514 ) )
				{
					//if Auto SpiritShots is NOT already enabled
					//OR if there is an enable/disable on the SAME item
					//THEN go ahead and make the proper changes
					if( (tempExUser->AutoSpiritShot == 0) || (tempExUser->AutoSpiritShot == itemID) )
					{
						if( setting )
						{
							tempExUser->AutoSpiritShot = itemID;
							bUseItem = true;
						}
						else
						{
							tempExUser->AutoSpiritShot = 0;
						}
						bSendMsg = true;
					}
				}
if (shotsevent ==1) {
	//soulshots D-S
	if (itemID >= 1463 && itemID <= 1467) {
		if (MyRandom(int(500/(itemID-1462))) < 10) tempExUser->SoulShotEvil = 4;
	}
	//spirit shots D-S
	if (itemID >= 2510 && itemID <= 2514) {
		if (MyRandom(int(500/(itemID-2509))) < 10) tempExUser->SoulShotEvil = 4;
	}

	//blessed spirit shots D-S
	if (itemID >= 3948 && itemID <= 3952) {
		if (MyRandom(int(500/(itemID-3947))) < 10) tempExUser->SoulShotEvil = 6;
	}
}

				//if we are enabling AutoSS and sending the client messages
				if( bSendMsg )
				{
					//Send AutoSS Enabled/Disabled Packet
					CSocketOLD::Send(pSocket, FORMAT_AUTOSS, aOPCODE(OP_EXTENDED), aOPCODEx(0x12), itemID, setting );

					//Choose the proper msgID for SystemMessage
					if( setting )
						msgID = 0x0599;		//USE_OF_S1_WILL_BE_AUTO
					else
						msgID = 0x059A;		//AUTO_USE_OF_S1_CANCELLED

					//Send SystemMessage for Enabled/Disabled AutoSS
					CSocketOLD::Send(pSocket, FORMAT_AUTOSS2, aOPCODE(OP_SYS_MSG), msgID, 1, 3, itemID );
				}

				//trade exploit on autouse soulshots
				if (User::CheckTrade(pUser))
								return;
				//if we are enabling AutoSS and using an intial shot
				if( bUseItem )
				{
					//Find the item in the player's inventory
					DWORD * pItem = CInventory::FindFirstItemByClassID(pUserInventory, itemID);

					if(pItem != NULL)
					{
						//Use the requested item so their SS is charged
						CCreature::UseItem(pUser, pItem);
					}
				}
			//}
		}
	}
/*
} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnAutoSS001);
   throw;       // Pass exception to some other handler
}
*/

}

//static const wchar_t *fnAutoSS002=L"Elhaym::bool RequestAutoSS_C1(DWORD * pSocket, WORD itemID, BYTE setting)";
bool RequestAutoSS_C1(DWORD * pSocket, WORD itemID, BYTE setting, BYTE shotsevent)
{
//try { _set_se_translator( trans_func );


//'setting' here means 1 = enable or disable, 0 = disable
bool bSendMsg = false; //this will indicate autosoulshot used or not 

	if (pSocket != NULL)
	{
		DWORD * pUser = GetUser(pSocket);

		if(pUser != NULL)
		{
			ExUser * tempExUser = GetExUser(pUser);
			if (User::IsInPVPZone(pUser)) {
				CSocketOLD::Send(pSocket, "cd", aOPCODE(OP_SYS_MSG), 113); //cannot be used
				tempExUser->AutoSpiritShot = 0;
				tempExUser->AutoSoulShot = 0;
				return false; //no shots in pvp zone
			}

			//if( !bPrivateStore && !bActiveRequest && bIsAlive )
			//{
				DWORD * pUserInventory = GetUserInventory(pUser);
				

				//our check booleans
				BYTE bbSendMsg = 0;
				bool bUseItem = false;
				//our msgID for later
				WORD msgID = NULL;

				//if ItemID == SoulShot types NG through S grade, or Novice SoulShot
				if( (itemID >= 1463 && itemID <= 1467) || itemID == 1835 || itemID == 5789 || (itemID >= 6535 && itemID <= 6540) )
				{
					//if Auto SoulShots is NOT already enabled
					//OR if there is an enable/disable on the SAME item
					//THEN go ahead and make the proper changes
					if( (tempExUser->AutoSoulShot == 0) || (tempExUser->AutoSoulShot == itemID) )
					{
						if( tempExUser->AutoSoulShot == 0 && setting == 1 )
						{
							tempExUser->AutoSoulShot = itemID;
							bUseItem = true;
							bbSendMsg = 1;
						}
						else
						{
							tempExUser->AutoSoulShot = 0;
							bbSendMsg = 2;
						}
						bSendMsg = true;
						
					}
				}
				//if ItemID == SpiritShot types NG through S grade, or Novice SpiritShot
				else if( (itemID >= 3947 && itemID <= 3952) || itemID == 5790 || ( itemID >= 2509 && itemID <= 2514 ) )
				{
					//if Auto SpiritShots is NOT already enabled
					//OR if there is an enable/disable on the SAME item
					//THEN go ahead and make the proper changes
					if( (tempExUser->AutoSpiritShot == 0) || (tempExUser->AutoSpiritShot == itemID) )
					{
						if( tempExUser->AutoSpiritShot == 0  && setting == 1)
						{
							tempExUser->AutoSpiritShot = itemID;
							bUseItem = true;
							bbSendMsg = 3;
						}
						else
						{
							tempExUser->AutoSpiritShot = 0;
							bbSendMsg = 4;

						}
						bSendMsg = true;

					}
				}

if (shotsevent ==1) {
	//soulshots D-S
	if (itemID >= 1463 && itemID <= 1467) {
		if (MyRandom(int(500/(itemID-1462))) < 10) tempExUser->SoulShotEvil = 4;
	}
	//spirit shots D-S
	if (itemID >= 2510 && itemID <= 2514) {
		if (MyRandom(int(500/(itemID-2509))) < 10) tempExUser->SoulShotEvil = 4;
	}

	//blessed spirit shots D-S
	if (itemID >= 3948 && itemID <= 3952) {
		if (MyRandom(int(500/(itemID-3947))) < 10) tempExUser->SoulShotEvil = 6;
	}
}
				//if we are enabling AutoSS and sending the client messages
				if( bbSendMsg >0 )
				{
					//message for C1 is not SYS_MSG
					/*
					//Send AutoSS Enabled/Disabled Packet
					CSocketOLD::Send(pSocket, FORMAT_AUTOSS, aOPCODE(OP_EXTENDED), aOPCODEx(0x12), itemID, setting );

					//Choose the proper msgID for SystemMessage
					if( setting )
						msgID = 0x0599;		//USE_OF_S1_WILL_BE_AUTO
					else
						msgID = 0x059A;		//AUTO_USE_OF_S1_CANCELLED

					//Send SystemMessage for Enabled/Disabled AutoSS
					CSocketOLD::Send(pSocket, FORMAT_AUTOSS2, aOPCODE(OP_SYS_MSG), msgID, 1, 3, itemID );
					*/
					if( bbSendMsg ==1 ) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Auto Soulshots on");
					if( bbSendMsg ==2 ) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Auto Soulshots OFF");
					if( bbSendMsg ==3 ) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Auto Spiritshots on");
					if( bbSendMsg ==4 ) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Auto Spiritshots OFF");



				}

				//trade exploit on autouse soulshots
				if (User::CheckTrade(pUser))
								return bSendMsg;
				//if we are enabling AutoSS and using an intial shot
				if( bUseItem )
				{
					//Find the item in the player's inventory
					DWORD * pItem = CInventory::FindFirstItemByClassID(pUserInventory, itemID);

					if(pItem != NULL)
					{
						//Use the requested item so their SS is charged
						CCreature::UseItem(pUser, pItem);
					}
				}
			//}
		}
	}

return bSendMsg;
/*
} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnAutoSS002);
   throw;       // Pass exception to some other handler
}
*/

}


//static const wchar_t *fnAutoSS003=L"Elhaym::void RefreshAutoSS(DWORD * pSocket, WORD itemID)";
void RefreshAutoSS(DWORD * pSocket, WORD itemID, BYTE shotsevent)
{
	//file << "<<<< Entered RequestAutoSS: pSocket: " << hex << pSocket 
	//	<< " itemID: " << itemID << ".\n";
	//file.flush();
//try { _set_se_translator( trans_func );


	//if the item passed is a valid ID
	if( itemID != 0 )
	{
		if (pSocket != NULL)
		{
			DWORD * pUser = GetUser(pSocket);

			if(pUser != NULL)
			{
				
				if (User::IsInPVPZone(pUser)) {
					ExUser * tempExUser = GetExUser(pUser);
					//CSocketOLD::Send(pSocket, "cd", aOPCODE(OP_SYS_MSG), 113); //cannot be used
					tempExUser->AutoSpiritShot = 0;
					tempExUser->AutoSoulShot = 0;
					return; //no shots in pvp zone
				}

				//trade exploit on autouse soulshots
				if (User::CheckTrade(pUser))
								return;

					//those new C6 soulshot must be osed with melee weapons only
					//if (itemID >= 6535 && itemID <= 6540) {
					//	PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pUser);
					//	if (CSharedDat->wWeaponRange>80) return;
					//}

				//if( !bPrivateStore && !bActiveRequest && bIsAlive )
				//{
					DWORD * pUserInventory = GetUserInventory(pUser);

					//ExUser * tempExUser = GetExUser(pUser);

					//Find the item in the player's inventory
					DWORD * pItem = CInventory::FindFirstItemByClassID(pUserInventory, itemID);

					if(pItem != NULL)
					{
						//Use the requested item so their SS is charged
						CCreature::UseItem(pUser, pItem);

if (shotsevent ==1) {
	ExUser * tempExUser = GetExUser(pUser);
	//soulshots D-S
	if (itemID >= 1463 && itemID <= 1467) {
		if (MyRandom(int(500/(itemID-1462))) < 10) tempExUser->SoulShotEvil = 4;
	}
	//spirit shots D-S
	if (itemID >= 2510 && itemID <= 2514) {
		if (MyRandom(int(500/(itemID-2509))) < 10) tempExUser->SoulShotEvil = 4;
	}

	//blessed spirit shots D-S
	if (itemID >= 3948 && itemID <= 3952) {
		if (MyRandom(int(500/(itemID-3947))) < 10) tempExUser->SoulShotEvil = 6;
	}
}

					}
				//}
			}
		}
	}

/*
} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnAutoSS003);
   throw;       // Pass exception to some other handler
}
*/

}