#include "BasePacket.h"

BasePacket::BasePacket( char *Data, unsigned short DataLen )
: m_DataLen( DataLen ), m_Data( Data ) {
}

BasePacket::~BasePacket() {
	if ( m_Data != NULL ) {
		delete m_Data;
	}
}

unsigned short BasePacket::GetLen() const {
	return m_DataLen;
}

char *BasePacket::GetData() const {
	return m_Data;
}