#include "L2Server.h"
#include "CInventory.h"
#include "CItem.h"
#include "CParty.h"
#include "CShortcut.h"

class CCreature_;


inline bool SO_VALID_USER(CCreature_ *pUser)
{
	DWORD *p = (DWORD *)pUser;
	if (p==NULL) return false;
	DWORD a = (DWORD)p;
	if (a<0x1000000) return false;
	a = *p;
	if (a!=0x00602C04) return false;

//test clases loaded?
//DWORD *pUserInventory= GetUserInventory((DWORD *)pUser);
//if (pUserInventory == NULL) return false;
//PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData((DWORD *)pUser);
//if (CSharedDat == NULL) return false;

	return true;
}


typedef double (CCreature_::*CCREATURE_GOTDAMAGEBY)(CCreature_ *pAttacker, double dDamage, int nParam);


class CUserSocket
{
public:
	UCHAR unknown[0x1394];						// offset 0x0000
	CCreature_* pUser;							// offset 0x1394
	void SendSystemMessage(WCHAR *From, WCHAR *Text);
	void Send(const char* format, ...);
};

class CCubic
{
public:
        short *pCubicID;                                               // offset 0x0000
        UCHAR m_unk1[ 0x1C ];                                           // offset 0x0002
};

class CCreatureEnv
{
public:
        int nEnv0WalkSpeed;                                          // offset 0x0000
        int nEnv1WalkSpeed;                                          // offset 0x0004
        int nEnv2WalkSpeed;                                          // offset 0x0008
        int nEnv3WalkSpeed;                                          // offset 0x000C
        int nEnv0RunSpeed;                                           // offset 0x0010
        int nEnv1RunSpeed;                                           // offset 0x0014
        int nEnv2RunSpeed;                                           // offset 0x0018
        int nEnv3RunSpeed;                                           // offset 0x001C
																	//....0x80 CNPC Die related (+4, +8 +C) drop groups?
																	// 0x90 i_spoil
																	// A0 npcdie (+4, +8, +C) //drop in group? ids.DropProb [%f]/[%f]
																	// 0xBC classID
																	// 0xC8, 0xCC Clan help table
};




///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

class CCreature_
{
public:
	//variables
	//void* vtbl;    //offset 0000
    int ___unk_0004; //offset 0004
    int ___unk_0008; //offset 0008
    int ___unk_000C; //offset 000C
    int ___unk_0010; //offset 0010
    int nDBID; //offset 0014 CHAR_ID
    int nObjectID; //offset 0018
    int ___unk_001C; //offset 001C
    int ___unk_0020; //offset 0020
    int ___unk_0024; //offset 0024
    int ___unk_0028; //offset 0028
    int ___unk_002C; //offset 002C
    int ___unk_0030; //offset 0030
    int ___unk_0034; //offset 0034
    int ___unk_0038; //offset 0038
    int ___unk_003C; //offset 003C
    int ___unk_0040; //offset 0040
    int ___unk_0044; //offset 0044
    int ___unk_0048; //offset 0048
    int ___unk_004C; //offset 004C
    int ___unk_0050; //offset 0050
    int ___unk_0054; //offset 0054
    int ___unk_0058; //offset 0058
    int ___unk_005C; //offset 005C
    int ___unk_0060; //offset 0060
    int ___unk_0064; //offset 0064
    int ___unk_0068; //offset 0068
    int ___unk_006C; //offset 006C
    int ___unk_0070; //offset 0070
    int ___unk_0074; //offset 0074
    int ___unk_0078; //offset 0078
    int ___unk_007C; //offset 007C
    int ___unk_0080; //offset 0080
    int ___unk_0084; //offset 0084
    int ___unk_0088; //offset 0088
    int ___unk_008C; //offset 008C
    int ___unk_0090; //offset 0090
    int ___unk_0094; //offset 0094
    double grade_penalty_modifier; //offset 0098 //validate equiped 
    int ___unk_00A0; //offset 00A0
    int ___unk_00A4; //offset 00A4
    int ___unk_00A8; //offset 00A8
    int ___unk_00AC; //offset 00AC
    int ___unk_00B0; //offset 00B0
    int ___unk_00B4; //offset 00B4
    int ___unk_00B8; //offset 00B8
    int ___unk_00BC; //offset 00BC
    int ___unk_00C0; //offset 00C0
    int ___unk_00C4; //offset 00C4
    int ___unk_00C8; //offset 00C8
    int ___unk_00CC; //offset 00CC
    int ___unk_00D0; //offset 00D0
    int ___unk_00D4; //offset 00D4
    int ___unk_00D8; //offset 00D8
    int ___unk_00DC; //offset 00DC
    int ___unk_00E0; //offset 00E0
    int ___unk_00E4; //offset 00E4
    int ___unk_00E8; //offset 00E8
    int ___unk_00EC; //offset 00EC
    double p_physical_attack_by_material_diff; //offset 00F0
    double p_physical_attack_by_material_per; //offset 00F8
    double p_attack_attribute_diff; //offset 0100
    double p_attack_attribute_per; //offset 0108
    double p_magical_attack_diff; //offset 0110
    double p_magical_attack_per; //offset 0118
    double p_defence_attribute_diff; //offset 0120
    double p_defence_attribute_per; //offset 0128
    double p_speed_diff; //offset 0130
    double p_speed_per; //offset 0138
    double p_attack_speed_diff; //offset 0140
    double p_attack_speed_per; //offset 0148
    double ___unk_0150; //offset 0150
    double i_hp_per_max; //offset 0158
    double p_cub_attack_speed_diff_only; //offset 0160
    double p_magic_speed_diff; //offset 0168
    double p_magic_speed_per; //offset 0170
    double p_hit_diff; //offset 0178
    double p_avoid_diff_ONLY; //offset 0180
    double p_critical_rate_per_ONLY; //offset 0188
    __int8 p_block_move; //offset 0190
	__int8 p_block_act; //offset 0191
	__int8 p_block_controll; //offset 0192
	__int8 p_block_spel; //offset 0193
    __int8 p_block_getdamage; //offset 0194
	__int8 p_fear; //offset 0195
	__int8 disablePreemtiveStrikes; //offset 0196 (p_pasive.. s_veil) (also set in damage_reflect_pump)
	__int8 i_dispel_all; //offset 0197
    double p_damage_shield_diff_ONLY; //offset 0198
    double p_hit_per; //offset 01A0
    double p_max_hp_diff; //offset 01A8
    double p_max_hp_per; //offset 01B0
    double p_max_mp_diff; //offset 01B8
    double p_max_mp_per; //offset 01C0
    double p_attack_range_diff; //offset 01C8
    double p_attack_range_per; //offset 01D0
    double p_critical_damage_diff; //offset 01D8
    double p_critical_damage_per; //offset 01E0
    double p_reuse_delay; //offset 01E8
    double p_reduce_cancel_diff; //offset 01F0
    double p_reduce_cancel_per; //offset 01F8
    double p_attack_speed_by_weapon_diff; //offset 0200
    double p_attack_speed_by_weapon_per; //offset 0208
    double p_shield_defence_rate; //offset 0210
    int ___unk_0218; //offset 0218
    int ___unk_021C; //offset 021C
    int ___unk_0220; //offset 0220
    int ___unk_0224; //offset 0224
    int ___unk_0228; //offset 0228
    int ___unk_022C; //offset 022C
    int ___unk_0230; //offset 0230
    int ___unk_0234; //offset 0234
    int ___unk_0238; //offset 0238
    int ___unk_023C; //offset 023C
    int ___unk_0240; //offset 0240
    int ___unk_0244; //offset 0244
    int ___unk_0248; //offset 0248
    int ___unk_024C; //offset 024C
    int ___unk_0250; //offset 0250
    int ___unk_0254; //offset 0254
    int ___unk_0258; //offset 0258
    int ___unk_025C; //offset 025C
    int ___unk_0260; //offset 0260
    int ___unk_0264; //offset 0264
    int ___unk_0268; //offset 0268
    int ___unk_026C; //offset 026C
    int ___unk_0270; //offset 0270
    int ___unk_0274; //offset 0274
    int ___unk_0278; //offset 0278
    int ___unk_027C; //offset 027C
    int ___unk_0280; //offset 0280
    int ___unk_0284; //offset 0284
    int ___unk_0288; //offset 0288
    int ___unk_028C; //offset 028C
    int ___unk_0290; //offset 0290
    int ___unk_0294; //offset 0294
    int ___unk_0298; //offset 0298
    int ___unk_029C; //offset 029C
    int ___unk_02A0; //offset 02A0
    int ___unk_02A4; //offset 02A4
    int ___unk_02A8; //offset 02A8
    int ___unk_02AC; //offset 02AC
    int ___unk_02B0; //offset 02B0
    int ___unk_02B4; //offset 02B4
    int ___unk_02B8; //offset 02B8
    int ___unk_02BC; //offset 02BC
    int ___unk_02C0; //offset 02C0
    int ___unk_02C4; //offset 02C4
    int ___unk_02C8; //offset 02C8
    int ___unk_02CC; //offset 02CC
    int ___unk_02D0;; //offset 02D0
    int ___unk_02D4; //offset 02D4
    double p_safe_fall_height_diff; //offset 02D8
    double p_safe_fall_height_per; //offset 02E0
    double p_breath_diff; //offset 02E8
    double p_breath_per; //offset 02F0
    double p_weight_limit; //offset 02F8
    double p_weight_penalty; //offset 0300
    double p_trade1_non_grade; //offset 0308
    double p_trade2_d_grade; //offset 0310
    double p_trade3_c_grade; //offset 0318
    double p_trade4_b_grade; //offset 0320
    double p_trade5_a_grade; //offset 0328
    double p_trade6_S_grade; //offset 0330
    int p_mana_charge; //offset 0338
    int p_transfer_damage_summon; //offset 033C
    int nGradeExpertise; //offset 0340
    int ___unk_0344; //offset 0344
    int ___unk_0348; //offset 0348
    int ___unk_034C; //offset 034C
    int ___unk_0350; //offset 0350
    int ___unk_0354; //offset 0354
    int ___unk_0358; //offset 0358
    int ___unk_035C; //offset 035C

    __int8 p_luck; //offset 0360
	__int8 ___unk_0361; //offset 0364
	__int8 ___unk_0362; //offset 0364
	__int8 ___unk_0363; //offset 0364

    int ___unk_0364; //offset 0364
    int ___unk_0368; //offset 0368
    int ___unk_036C; //offset 036C
    int ___unk_0370; //offset 0370
    int ___unk_0374; //offset 0374
    int ___unk_0378; //offset 0378
    int ___unk_037C; //offset 037C
    int ___unk_0380; //offset 0380
    int ___unk_0384; //offset 0384
    int ___unk_0388; //offset 0388
    int ___unk_038C; //offset 038C
    int ___unk_0390; //offset 0390
    int ___unk_0394; //offset 0394
    int ___unk_0398; //offset 0398
    int ___unk_039C; //offset 039C
    int ___unk_03A0; //offset 03A0
    int ___unk_03A4; //offset 03A4
    int ___unk_03A8; //offset 03A8
    int energyFocused; //offset 03AC
    int ___unk_03B0; //offset 03B0
    int ___unk_03B4; //offset 03B4
    int ___unk_03B8; //offset 03B8
    int ___unk_03BC; //offset 03BC
    int ___unk_03C0; //offset 03C0
    int ___unk_03C4; //offset 03C4
    int p_cubic_mastery; //offset 03C8
    int ___unk_03CC; //offset 03CC
    int ___unk_03D0; //offset 03D0
    int ___unk_03D4; //offset 03D4
    int ___unk_03D8; //offset 03D8
    int ___unk_03DC; //offset 03DC
    int ___unk_03E0; //offset 03E0
    int ___unk_03E4; //offset 03E4
    double i_hp_per_max__; //offset 03E8
    int ___unk_03F0; //offset 03F0
    int ___unk_03F4; //offset 03F4
    int ___unk_03F8; //offset 03F8
    int ___unk_03FC; //offset 03FC
    int ___unk_0400; //offset 0400
    int ___unk_0404; //offset 0404
    int ___unk_0408; //offset 0408
    int ___unk_040C; //offset 040C
    int ___unk_0410; //offset 0410
    int ___unk_0414; //offset 0414
    int ___unk_0418; //offset 0418
    int ___unk_041C; //offset 041C
    int ___unk_0420; //offset 0420
    int ___unk_0424; //offset 0424
    int ___unk_0428; //offset 0428
    int ___unk_042C; //offset 042C
    int ___unk_0430; //offset 0430
    int ___unk_0434; //offset 0434
    int ___unk_0438; //offset 0438
    int ___unk_043C; //offset 043C
    int ___unk_0440; //offset 0440
    int ___unk_0444; //offset 0444
    int ___unk_0448; //offset 0448
    int ___unk_044C; //offset 044C
    int ___unk_0450; //offset 0450
    int ___unk_0454; //offset 0454
    int ___unk_0458; //offset 0458
    int ___unk_045C; //offset 045C
    int nArray300[300]; //offset 0460
    int ___unk_0910; //offset 0910
    int ___unk_0914; //offset 0914
    int ___unk_0918; //offset 0918
    int ___unk_091C; //offset 091C
    int ___unk_0920; //offset 0920
    int ___unk_0924; //offset 0924
    int ___unk_0928; //offset 0928
    int ___unk_092C; //offset 092C
    int ___unk_0930; //offset 0930
    int ___unk_0934; //offset 0934
    int ___unk_0938; //offset 0938
    int ___unk_093C; //offset 093C
    int ___unk_0940; //offset 0940
    int ___unk_0944; //offset 0944
    int ___unk_0948; //offset 0948
    int ___unk_094C; //offset 094C
    int ___unk_0950; //offset 0950
    int ___unk_0954; //offset 0954
    int ___unk_0958; //offset 0958
    int bIsBeingRessurected; //offset 095C //need test
    int ___unk_0960; //offset 0960
    __int8 bIsUnLocked; //offset 0964
	__int8 bIsCombatMode; //offset 0965
	__int8 ___unk_0966; //offset 0966
	__int8 ___unk_0967; //offset 0967
    int ___unk_0968; //offset 0968
    int ___unk_096C; //offset 096C
    int ___unk_0970; //offset 0970
    int ___unk_0974; //offset 0974
    int ___unk_0978; //offset 0978
    int ___unk_097C; //offset 097C
    int ___unk_0980; //offset 0980
    int ___unk_0984; //offset 0984
    int ___unk_0988; //offset 0988
    int ___unk_098C; //offset 098C
    int ___unk_0990; //offset 0990
    int ___unk_0994; //offset 0994
    int ___unk_0998; //offset 0998
    int ___unk_099C; //offset 099C
    int ___unk_09A0; //offset 09A0
    int ___unk_09A4; //offset 09A4
    int ___unk_09A8; //offset 09A8
    int ___unk_09AC; //offset 09AC
    int ___unk_09B0; //offset 09B0
    int ___unk_09B4; //offset 09B4
    int ___unk_09B8; //offset 09B8
    int ___unk_09BC; //offset 09BC
    int ___unk_09C0; //offset 09C0
    int ___unk_09C4; //offset 09C4
    int ___unk_09C8; //offset 09C8
    int ___unk_09CC; //offset 09CC
    int ___unk_09D0; //offset 09D0
    int ___unk_09D4; //offset 09D4
    int ___unk_09D8; //offset 09D8
    int ___unk_09DC; //offset 09DC
    int ___unk_09E0; //offset 09E0
    int ___unk_09E4; //offset 09E4
    int ___unk_09E8; //offset 09E8
    int ___unk_09EC; //offset 09EC
    int ___unk_09F0; //offset 09F0
    int ___unk_09F4; //offset 09F4
    int ___unk_09F8; //offset 09F8
    int ___unk_09FC; //offset 09FC
    int ___unk_0A00; //offset 0A00
    int ___unk_0A04; //offset 0A04
    int ___unk_0A08; //offset 0A08
    int ___unk_0A0C; //offset 0A0C
    int ___unk_0A10; //offset 0A10
    int ___unk_0A14; //offset 0A14
    int ___unk_0A18; //offset 0A18
    int ___unk_0A1C; //offset 0A1C
    int ___unk_0A20; //offset 0A20
    int ___unk_0A24; //offset 0A24
    int ___unk_0A28; //offset 0A28
    int ___unk_0A2C; //offset 0A2C
    int ___unk_0A30; //offset 0A30
    int ___unk_0A34; //offset 0A34
    int ___unk_0A38; //offset 0A38
    int ___unk_0A3C; //offset 0A3C
    int ___unk_0A40; //offset 0A40
    int ___unk_0A44; //offset 0A44
    int ___unk_0A48; //offset 0A48
    int ___unk_0A4C; //offset 0A4C
    CCubic *pCubicBegin; //offset 0A50
    CCubic *pCubicEnd; //offset 0A54
    int ___unk_0A58; //offset 0A58
    int ___unk_0A5C; //offset 0A5C
    int ___unk_0A60; //offset 0A60
    int ___unk_0A64; //offset 0A64
    int ___unk_0A68; //offset 0A68
    int ___unk_0A6C; //offset 0A6C
    int ___unk_0A70; //offset 0A70
    int ___unk_0A74; //offset 0A74
    int ___unk_0A78; //offset 0A78
    int ___unk_0A7C; //offset 0A7C
    int ___unk_0A80; //offset 0A80
    int ___unk_0A84; //offset 0A84
    int ___unk_0A88; //offset 0A88
    int ___unk_0A8C; //offset 0A8C
    int ___unk_0A90; //offset 0A90
    int ___unk_0A94; //offset 0A94
    int ___unk_0A98; //offset 0A98
    int ___unk_0A9C; //offset 0A9C
    int ___unk_0AA0; //offset 0AA0
    int ___unk_0AA4; //offset 0AA4
    int ___unk_0AA8; //offset 0AA8
    int ___unk_0AAC; //offset 0AAC
    int nAbnormalVisualEffect; //offset 0AB0
    int ___unk_0AB4; //offset 0AB4
    int ___unk_0AB8; //offset 0AB8
    int ___unk_0ABC; //offset 0ABC
    int ___unk_0AC0; //offset 0AC0
    int ___unk_0AC4; //offset 0AC4
    int ___unk_0AC8; //offset 0AC8
    int ___unk_0ACC; //offset 0ACC
    int ___unk_0AD0; //offset 0AD0
    int ___unk_0AD4; //offset 0AD4
    int ___unk_0AD8; //offset 0AD8
    int ___unk_0ADC; //offset 0ADC
    int ___unk_0AE0; //offset 0AE0
    int ___unk_0AE4; //offset 0AE4
    int ___unk_0AE8; //offset 0AE8
    int ___unk_0AEC; //offset 0AEC
    int ___unk_0AF0; //offset 0AF0
    int ___unk_0AF4; //offset 0AF4
    int ___unk_0AF8; //offset 0AF8
    int ___unk_0AFC; //offset 0AFC
    int ___unk_0B00; //offset 0B00
    int ___unk_0B04; //offset 0B04
    int ___unk_0B08; //offset 0B08
    int ___unk_0B0C; //offset 0B0C
    int ___unk_0B10; //offset 0B10
    int ___unk_0B14; //offset 0B14
    int ___unk_0B18; //offset 0B18
    int ___unk_0B1C; //offset 0B1C
    int ___unk_0B20; //offset 0B20
    int ___unk_0B24; //offset 0B24
    int ___unk_0B28; //offset 0B28
    int ___unk_0B2C; //offset 0B2C
    int ___unk_0B30; //offset 0B30
    int ___unk_0B34; //offset 0B34
    int ___unk_0B38; //offset 0B38
    int ___unk_0B3C; //offset 0B3C
    int ___unk_0B40; //offset 0B40
    int ___unk_0B44; //offset 0B44
    int ___unk_0B48; //offset 0B48
    int ___unk_0B4C; //offset 0B4C
    int ___unk_0B50; //offset 0B50
    int ___unk_0B54; //offset 0B54
    int ___unk_0B58; //offset 0B58
    int ___unk_0B5C; //offset 0B5C
    int ___unk_0B60; //offset 0B60
    int ___unk_0B64; //offset 0B64
    int ___unk_0B68; //offset 0B68
    int ___unk_0B6C; //offset 0B6C
    int ___unk_0B70; //offset 0B70
    int ___unk_0B74; //offset 0B74
    int ___unk_0B78; //offset 0B78
    int ___unk_0B7C; //offset 0B7C
    int ___unk_0B80; //offset 0B80
    int ___unk_0B84; //offset 0B84
    int ___unk_0B88; //offset 0B88
    int ___unk_0B8C; //offset 0B8C
    int ___unk_0B90; //offset 0B90
    int ___unk_0B94; //offset 0B94
    int ___unk_0B98; //offset 0B98
    int ___unk_0B9C; //offset 0B9C
    int ___unk_0BA0; //offset 0BA0
    int ___unk_0BA4; //offset 0BA4
    int ___unk_0BA8; //offset 0BA8
    int ___unk_0BAC; //offset 0BAC
    int ___unk_0BB0; //offset 0BB0
    int ___unk_0BB4; //offset 0BB4
    int ___unk_0BB8; //offset 0BB8
    int ___unk_0BBC; //offset 0BBC
    int ___unk_0BC0; //offset 0BC0
    int ___unk_0BC4; //offset 0BC4
    int ___unk_0BC8; //offset 0BC8
    int ___unk_0BCC; //offset 0BCC
    int ___unk_0BD0; //offset 0BD0
    int ___unk_0BD4; //offset 0BD4
    int ___unk_0BD8; //offset 0BD8
    int ___unk_0BDC; //offset 0BDC
    int ___unk_0BE0; //offset 0BE0
    int ___unk_0BE4; //offset 0BE4
    int ___unk_0BE8; //offset 0BE8
    int ___unk_0BEC; //offset 0BEC
    int ___unk_0BF0; //offset 0BF0
    int ___unk_0BF4; //offset 0BF4
    int ___unk_0BF8; //offset 0BF8
    int ___unk_0BFC; //offset 0BFC
    int ___unk_0C00; //offset 0C00
    int ___unk_0C04; //offset 0C04
    int ___unk_0C08; //offset 0C08
    int ___unk_0C0C; //offset 0C0C
    int ___unk_0C10; //offset 0C10
    int ___unk_0C14; //offset 0C14
    int ___unk_0C18; //offset 0C18
    int ___unk_0C1C; //offset 0C1C
    int ___unk_0C20; //offset 0C20
    int ___unk_0C24; //offset 0C24
    int ___unk_0C28; //offset 0C28
    int ___unk_0C2C; //offset 0C2C
    int ___unk_0C30; //offset 0C30
    int ___unk_0C34; //offset 0C34
    int ___unk_0C38; //offset 0C38
    int ___unk_0C3C; //offset 0C3C
    int ___unk_0C40; //offset 0C40
    int ___unk_0C44; //offset 0C44
    int ___unk_0C48; //offset 0C48
    int ___unk_0C4C; //offset 0C4C
    int ___unk_0C50; //offset 0C50
    int ___unk_0C54; //offset 0C54
    int ___unk_0C58; //offset 0C58
    int ___unk_0C5C; //offset 0C5C
    int ___unk_0C60; //offset 0C60
    int ___unk_0C64; //offset 0C64
    int ___unk_0C68; //offset 0C68
    int ___unk_0C6C; //offset 0C6C
    int ___unk_0C70; //offset 0C70
    int ___unk_0C74; //offset 0C74
    int ___unk_0C78; //offset 0C78
    int ___unk_0C7C; //offset 0C7C
    int ___unk_0C80; //offset 0C80
    int ___unk_0C84; //offset 0C84
    int ___unk_0C88; //offset 0C88
    int ___unk_0C8C; //offset 0C8C
    int ___unk_0C90; //offset 0C90
    int ___unk_0C94; //offset 0C94
    int ___unk_0C98; //offset 0C98
    int ___unk_0C9C; //offset 0C9C
    int ___unk_0CA0; //offset 0CA0
    int ___unk_0CA4; //offset 0CA4
    int ___unk_0CA8; //offset 0CA8
    int ___unk_0CAC; //offset 0CAC
    int ___unk_0CB0; //offset 0CB0
    int ___unk_0CB4; //offset 0CB4
    int ___unk_0CB8; //offset 0CB8
    int ___unk_0CBC; //offset 0CBC
    int ___unk_0CC0; //offset 0CC0
    int ___unk_0CC4; //offset 0CC4
    int ___unk_0CC8; //offset 0CC8
    int ___unk_0CCC; //offset 0CCC
    int ___unk_0CD0; //offset 0CD0
    int ___unk_0CD4; //offset 0CD4
    int ___unk_0CD8; //offset 0CD8
    int ___unk_0CDC; //offset 0CDC
    int ___unk_0CE0; //offset 0CE0
    int ___unk_0CE4; //offset 0CE4
    int ___unk_0CE8; //offset 0CE8
    int ___unk_0CEC; //offset 0CEC
    int ___unk_0CF0; //offset 0CF0
    int ___unk_0CF4; //offset 0CF4
    int ___unk_0CF8; //offset 0CF8
    int ___unk_0CFC; //offset 0CFC
    int ___unk_0D00; //offset 0D00
    int ___unk_0D04; //offset 0D04
    int ___unk_0D08; //offset 0D08
    int ___unk_0D0C; //offset 0D0C
    int ___unk_0D10; //offset 0D10
    int ___unk_0D14; //offset 0D14
    int ___unk_0D18; //offset 0D18
    int ___unk_0D1C; //offset 0D1C
    int ___unk_0D20; //offset 0D20
    int ___unk_0D24; //offset 0D24
    int ___unk_0D28; //offset 0D28
    int ___unk_0D2C; //offset 0D2C
    int ___unk_0D30; //offset 0D30
    int ___unk_0D34; //offset 0D34
    int ___unk_0D38; //offset 0D38
    int ___unk_0D3C; //offset 0D3C
    int ___unk_0D40; //offset 0D40
    int ___unk_0D44; //offset 0D44
    int ___unk_0D48; //offset 0D48
    int ___unk_0D4C; //offset 0D4C
    int ___unk_0D50; //offset 0D50
    int ___unk_0D54; //offset 0D54
    int ___unk_0D58; //offset 0D58
    int ___unk_0D5C; //offset 0D5C
    int ___unk_0D60; //offset 0D60
    int ___unk_0D64; //offset 0D64
    int ___unk_0D68; //offset 0D68
    int ___unk_0D6C; //offset 0D6C
    int ___unk_0D70; //offset 0D70
    int ___unk_0D74; //offset 0D74
    int ___unk_0D78; //offset 0D78
    int ___unk_0D7C; //offset 0D7C
    int ___unk_0D80; //offset 0D80
    int ___unk_0D84; //offset 0D84
    int ___unk_0D88; //offset 0D88
    int ___unk_0D8C; //offset 0D8C
    int ___unk_0D90; //offset 0D90
    int ___unk_0D94; //offset 0D94
    int ___unk_0D98; //offset 0D98
    int ___unk_0D9C; //offset 0D9C
    int ___unk_0DA0; //offset 0DA0
    int ___unk_0DA4; //offset 0DA4
    int ___unk_0DA8; //offset 0DA8
    int ___unk_0DAC; //offset 0DAC
    int ___unk_0DB0; //offset 0DB0
    int ___unk_0DB4; //offset 0DB4
    int ___unk_0DB8; //offset 0DB8
    int ___unk_0DBC; //offset 0DBC
    int ___unk_0DC0; //offset 0DC0
    int ___unk_0DC4; //offset 0DC4
    int ___unk_0DC8; //offset 0DC8
    int ___unk_0DCC; //offset 0DCC
    int ___unk_0DD0; //offset 0DD0
    int ___unk_0DD4; //offset 0DD4
    int ___unk_0DD8; //offset 0DD8
    int ___unk_0DDC; //offset 0DDC
    int ___unk_0DE0; //offset 0DE0
    int ___unk_0DE4; //offset 0DE4
    int ___unk_0DE8; //offset 0DE8
    int ___unk_0DEC; //offset 0DEC
    int ___unk_0DF0; //offset 0DF0
    int ___unk_0DF4; //offset 0DF4
    int ___unk_0DF8; //offset 0DF8
    int ___unk_0DFC; //offset 0DFC
    int ___unk_0E00; //offset 0E00
    int ___unk_0E04; //offset 0E04
    int ___unk_0E08; //offset 0E08
    int ___unk_0E0C; //offset 0E0C
    int ___unk_0E10; //offset 0E10
    int ___unk_0E14; //offset 0E14
    int ___unk_0E18; //offset 0E18
    int ___unk_0E1C; //offset 0E1C
    int ___unk_0E20; //offset 0E20
    int ___unk_0E24; //offset 0E24
    int ___unk_0E28; //offset 0E28
    int ___unk_0E2C; //offset 0E2C
    int ___unk_0E30; //offset 0E30
    int ___unk_0E34; //offset 0E34
    int ___unk_0E38; //offset 0E38
    int ___unk_0E3C; //offset 0E3C
    int ___unk_0E40; //offset 0E40
    int ___unk_0E44; //offset 0E44
    int ___unk_0E48; //offset 0E48
    int ___unk_0E4C; //offset 0E4C
    int ___unk_0E50; //offset 0E50
    int ___unk_0E54; //offset 0E54
    int ___unk_0E58; //offset 0E58
    int ___unk_0E5C; //offset 0E5C
    int ___unk_0E60; //offset 0E60      
    int ___unk_0E64; //offset 0E64
    int ___unk_0E68; //offset 0E68
    int ___unk_0E6C; //offset 0E6C
    int ___unk_0E70; //offset 0E70
    int ___unk_0E74; //offset 0E74
    int ___unk_0E78; //offset 0E78
    int ___unk_0E7C; //offset 0E7C
    int ___unk_0E80; //offset 0E80
    int ___unk_0E84; //offset 0E84
    int ___unk_0E88; //offset 0E88
    int ___unk_0E8C; //offset 0E8C
    int ___unk_0E90; //offset 0E90
    int ___unk_0E94; //offset 0E94
    int ___unk_0E98; //offset 0E98
    int ___unk_0E9C; //offset 0E9C
    int ___unk_0EA0; //offset 0EA0
    int ___unk_0EA4; //offset 0EA4
    int ___unk_0EA8; //offset 0EA8
    int ___unk_0EAC; //offset 0EAC
    int ___unk_0EB0; //offset 0EB0
    int ___unk_0EB4; //offset 0EB4
    int ___unk_0EB8; //offset 0EB8
    int ___unk_0EBC; //offset 0EBC
    int ___unk_0EC0; //offset 0EC0
    int ___unk_0EC4; //offset 0EC4
    int ___unk_0EC8; //offset 0EC8
    int ___unk_0ECC; //offset 0ECC
    int ___unk_0ED0; //offset 0ED0
    int ___unk_0ED4; //offset 0ED4
    int ___unk_0ED8; //offset 0ED8
    int ___unk_0EDC; //offset 0EDC
    int ___unk_0EE0; //offset 0EE0
    int ___unk_0EE4; //offset 0EE4
    int ___unk_0EE8; //offset 0EE8
    int ___unk_0EEC; //offset 0EEC
    int ___unk_0EF0; //offset 0EF0
    int ___unk_0EF4; //offset 0EF4
    int ___unk_0EF8; //offset 0EF8
    int ___unk_0EFC; //offset 0EFC
    int ___unk_0F00; //offset 0F00
    int ___unk_0F04; //offset 0F04
    int ___unk_0F08; //offset 0F08
    int ___unk_0F0C; //offset 0F0C
    int ___unk_0F10; //offset 0F10
    int ___unk_0F14; //offset 0F14
    int ___unk_0F18; //offset 0F18
    int ___unk_0F1C; //offset 0F1C
    int ___unk_0F20; //offset 0F20
    int ___unk_0F24; //offset 0F24
    int ___unk_0F28; //offset 0F28
    int ___unk_0F2C; //offset 0F2C
    int ___unk_0F30; //offset 0F30
    int ___unk_0F34; //offset 0F34
    int ___unk_0F38; //offset 0F38
    int ___unk_0F3C; //offset 0F3C
    int ___unk_0F40; //offset 0F40
    int ___unk_0F44; //offset 0F44
    int ___unk_0F48; //offset 0F48
    int ___unk_0F4C; //offset 0F4C
    int ___unk_0F50; //offset 0F50
    PTCharBaseData Data; //offset 0F54
    int ___unk_0F58; //offset 0F58
    int ___unk_0F5C; //offset 0F5C
    CCInventory Inventory; //offset 0F60 ==== INVENTORY ==== (sizeof = 0x0004) FOR NOW
    int ___unk_0F64; //offset 0F64
    int nCurrentWeight; //offset 0F68
    int ___unk_0F6C; //offset 0F6C
    int ___unk_0F70; //offset 0F70
    int ___unk_0F74; //offset 0F74
    int ___unk_0F78; //offset 0F78
    int ___unk_0F7C; //offset 0F7C
    int ___unk_0F80; //offset 0F80
    int ___unk_0F84; //offset 0F84
    int ___unk_0F88; //offset 0F88
    int ___unk_0F8C; //offset 0F8C
    int ___unk_0F90; //offset 0F90
    int ___unk_0F94; //offset 0F94
    int ___unk_0F98; //offset 0F98
    int i_sweeper_related; //offset 0F9C
    int ___unk_0FA0; //offset 0FA0
    int ___unk_0FA4; //offset 0FA4
    int ___unk_0FA8; //offset 0FA8
    int ___unk_0FAC; //offset 0FAC
    int ___unk_0FB0; //offset 0FB0
    int ___unk_0FB4; //offset 0FB4
    int ___unk_0FB8; //offset 0FB8
    int ___unk_0FBC; //offset 0FBC
    int ___unk_0FC0; //offset 0FC0
    int ___unk_0FC4; //offset 0FC4
    int ___unk_0FC8; //offset 0FC8
    int ___unk_0FCC; //offset 0FCC
    int ___unk_0FD0; //offset 0FD0
    int ___unk_0FD4; //offset 0FD4
    int ___unk_0FD8; //offset 0FD8
    int ___unk_0FDC; //offset 0FDC
    __int8 ___unk_0FE0; //offset 0FE0
	__int8 checkRessurect; //offset 0FE1 //need tests
	__int8 ___unk_0FE2; //offset 0FE2
	__int8 ___unk_0FE3; //offset 0FE3
    int ___unk_0FE4; //offset 0FE4
    int ___unk_0FE8; //offset 0FE8
    int ___unk_0FEC; //offset 0FEC
    int npc_created; //offset 0FF0 ???
    CCreatureEnv * pEnv; //offset 0FF4
    int TITLE; //offset 0FF8
    int ___unk_0FFC; //offset 0FFC
    int ___unk_1000; //offset 1000
    int ___unk_1004; //offset 1004
    int ___unk_1008; //offset 1008
    int ___unk_100C; //offset 100C
    int ___unk_1010; //offset 1010
    CCreature_* pNPC; //offset 1014
    int ___unk_1018; //offset 1018
    int ___unk_101C; //offset 101C
    int ___unk_1020; //offset 1020
    int ___unk_1024; //offset 1024
    bool bSoulShotOn; //offset 1028
	bool bSpiritShotOn;
	bool NAME;
	bool b102B;
    int ___unk_102C; //offset 102C
    int ___unk_1030; //offset 1030
    int ___ShortCuts; //offset 1034
    int ___unk_1038; //offset 1038
    int ___unk_103C; //offset 103C
    int ___unk_1040; //offset 1040
    int ___unk_1044; //offset 1044
    int ___unk_1048; //offset 1048
    int ___unk_104C; //offset 104C
    int ___unk_1050; //offset 1050
    int ___unk_1054; //offset 1054
    int ___unk_1058; //offset 1058
    int ___unk_105C; //offset 105C
    int ___unk_1060; //offset 1060
    int ___unk_1064; //offset 1064
    int ___unk_1068; //offset 1068
    int ___unk_106C; //offset 106C
    int ___unk_1070; //offset 1070
    int ___unk_1074; //offset 1074
    int ___unk_1078; //offset 1078
    int ___unk_107C; //offset 107C
    int ___unk_1080; //offset 1080
    int ___unk_1084; //offset 1084
    int ___unk_1088; //offset 1088
    int ___unk_108C; //offset 108C
    int ___unk_1090; //offset 1090
    int ___unk_1094; //offset 1094
    int ___unk_1098; //offset 1098
    int ___unk_109C; //offset 109C
    int ___unk_10A0; //offset 10A0
    int ___unk_10A4; //offset 10A4
    int ___unk_10A8; //offset 10A8
    int ___unk_10AC; //offset 10AC
    int ___unk_10B0; //offset 10B0
    int ___unk_10B4; //offset 10B4
    int ___unk_10B8; //offset 10B8
    int ___unk_10BC; //offset 10BC
    int ___unk_10C0; //offset 10C0
    int ___unk_10C4; //offset 10C4
    int ___unk_10C8; //offset 10C8
    int ___unk_10CC; //offset 10CC
    int ___unk_10D0; //offset 10D0
    int ___unk_10D4; //offset 10D4
    int ___unk_10D8; //offset 10D8
    int ___unk_10DC; //offset 10DC
    int ___unk_10E0; //offset 10E0
    int ___unk_10E4; //offset 10E4
    int ___unk_10E8; //offset 10E8
    int ___unk_10EC; //offset 10EC
    int ___unk_10F0; //offset 10F0
    int ___unk_10F4; //offset 10F4
    int ___unk_10F8; //offset 10F8
    int ___unk_10FC; //offset 10FC
    int ___unk_1100; //offset 1100
    int ___unk_1104; //offset 1104
    int ___unk_1108; //offset 1108
    int ___unk_110C; //offset 110C
    int ___unk_1110; //offset 1110
    int ___unk_1114; //offset 1114
    int ___unk_1118; //offset 1118
    int ___unk_111C; //offset 111C
    int ___unk_1120; //offset 1120
    int ___unk_1124; //offset 1124
    int ___unk_1128; //offset 1128
    int ___unk_112C; //offset 112C
    int ___unk_1130; //offset 1130
    int ___unk_1134; //offset 1134
    int ___unk_1138; //offset 1138
    int ___unk_113C; //offset 113C
    int ___unk_1140; //offset 1140
    int ___unk_1144; //offset 1144
    int ___unk_1148; //offset 1148
    int ___unk_114C; //offset 114C
    int ___unk_1150; //offset 1150
    int ___unk_1154; //offset 1154
    int ___unk_1158; //offset 1158
    int ___unk_115C; //offset 115C
    int ___unk_1160; //offset 1160
    int ___unk_1164; //offset 1164
    int ___unk_1168; //offset 1168
    int ___unk_116C; //offset 116C
    int ___unk_1170; //offset 1170
    int ___unk_1174; //offset 1174
    int ___unk_1178; //offset 1178
    int ___unk_117C; //offset 117C
    int ___unk_1180; //offset 1180
    int ___unk_1184; //offset 1184
    int ___unk_1188; //offset 1188
    int ___unk_118C; //offset 118C
    int ___unk_1190; //offset 1190
    int ___unk_1194; //offset 1194
    int ___unk_1198; //offset 1198
    int ___unk_119C; //offset 119C
    int ___unk_11A0; //offset 11A0
    int ___unk_11A4; //offset 11A4
    int ___unk_11A8; //offset 11A8
    int ___unk_11AC; //offset 11AC
    int ___unk_11B0; //offset 11B0
    int ___unk_11B4; //offset 11B4
    int ___unk_11B8; //offset 11B8
    int ___unk_11BC; //offset 11BC
    int ___unk_11C0; //offset 11C0
    int ___unk_11C4; //offset 11C4
    int ___unk_11C8; //offset 11C8
    int ___unk_11CC; //offset 11CC
    int ___unk_11D0; //offset 11D0
    int ___unk_11D4; //offset 11D4
    int ___unk_11D8; //offset 11D8
    int ___unk_11DC; //offset 11DC
    int ___unk_11E0; //offset 11E0
    int ___unk_11E4; //offset 11E4
    int ___unk_11E8; //offset 11E8
    int ___unk_11EC; //offset 11EC
    int ___unk_11F0; //offset 11F0
    int ___unk_11F4; //offset 11F4
    int ___unk_11F8; //offset 11F8
    int ___unk_11FC; //offset 11FC
    int ___unk_1200; //offset 1200
    int ___unk_1204; //offset 1204
    int ___unk_1208; //offset 1208
    int ___unk_120C; //offset 120C
    int ___unk_1210; //offset 1210
    int ___unk_1214; //offset 1214
    int ___unk_1218; //offset 1218
    int ___unk_121C; //offset 121C
    int ___unk_1220; //offset 1220
    int ___unk_1224; //offset 1224
    int ___unk_1228; //offset 1228
    int ___unk_122C; //offset 122C
    int ___unk_1230; //offset 1230
    int ___unk_1234; //offset 1234
    int ___unk_1238; //offset 1238
    int ___unk_123C; //offset 123C
    int ___unk_1240; //offset 1240
    int ___unk_1244; //offset 1244
    int ___unk_1248; //offset 1248
    int ___unk_124C; //offset 124C
    int ___unk_1250; //offset 1250
    int ___unk_1254; //offset 1254
    int ___unk_1258; //offset 1258
    int ___unk_125C; //offset 125C
    int ___unk_1260; //offset 1260
    int ___unk_1264; //offset 1264
    int ___unk_1268; //offset 1268
    int ___unk_126C; //offset 126C
    int ___unk_1270; //offset 1270
    int ___unk_1274; //offset 1274
    int ___unk_1278; //offset 1278
    int ___unk_127C; //offset 127C
    int ___unk_1280; //offset 1280
    int ___unk_1284; //offset 1284
    int ___unk_1288; //offset 1288
    int ___unk_128C; //offset 128C
    int ___unk_1290; //offset 1290
    int ___unk_1294; //offset 1294
    int ___unk_1298; //offset 1298
    int ___unk_129C; //offset 129C
    int ___unk_12A0; //offset 12A0
    int ___unk_12A4; //offset 12A4
    int ___unk_12A8; //offset 12A8
    int ___unk_12AC; //offset 12AC
    int ___unk_12B0; //offset 12B0
    int ___unk_12B4; //offset 12B4
    int ___unk_12B8; //offset 12B8
    int ___unk_12BC; //offset 12BC
    int ___unk_12C0; //offset 12C0
    int ___unk_12C4; //offset 12C4
    int ___unk_12C8; //offset 12C8
    int ___unk_12CC; //offset 12CC
    int ___unk_12D0; //offset 12D0
    int ___unk_12D4; //offset 12D4
    int ___unk_12D8; //offset 12D8
    int ___unk_12DC; //offset 12DC
    int ___unk_12E0; //offset 12E0
    int ___unk_12E4; //offset 12E4
    int ___unk_12E8; //offset 12E8
    int ___unk_12EC; //offset 12EC
    int ___unk_12F0; //offset 12F0
    int ___unk_12F4; //offset 12F4
    int ___unk_12F8; //offset 12F8
    int ___unk_12FC; //offset 12FC
    int ___unk_1300; //offset 1300
    int ___unk_1304; //offset 1304
    int ___unk_1308; //offset 1308
    int ___unk_130C; //offset 130C
    int ___unk_1310; //offset 1310
    int ___unk_1314; //offset 1314
    int ___unk_1318; //offset 1318
    int ___unk_131C; //offset 131C
    int ___unk_1320; //offset 1320
    int ___unk_1324; //offset 1324
    int ___unk_1328; //offset 1328
    int ___unk_132C; //offset 132C
    int ___unk_1330; //offset 1330
    int ___unk_1334; //offset 1334
    int ___unk_1338; //offset 1338
    int ___unk_133C; //offset 133C
    int ___unk_1340; //offset 1340
    int ___unk_1344; //offset 1344
    int ___unk_1348; //offset 1348
    int ___unk_134C; //offset 134C
    int ___unk_1350; //offset 1350
    int ___unk_1354; //offset 1354
    int ___unk_1358; //offset 1358
    int ___unk_135C; //offset 135C
    int ___unk_1360; //offset 1360
    int ___unk_1364; //offset 1364
    int ___unk_1368; //offset 1368
    int ___unk_136C; //offset 136C
    int ___unk_1370; //offset 1370
    int ___unk_1374; //offset 1374
    int ___unk_1378; //offset 1378
    int ___unk_137C; //offset 137C
    int ___unk_1380; //offset 1380
    int ___unk_1384; //offset 1384
    int ___unk_1388; //offset 1388
    int ___unk_138C; //offset 138C
    int ___unk_1390; //offset 1390
    int ___IsGM; //offset 1394 builder
    int ___unk_1398; //offset 1398
    int ___unk_139C; //offset 139C
    int ___unk_13A0; //offset 13A0
    int ___unk_13A4; //offset 13A4
    int ___unk_13A8; //offset 13A8
    int ___unk_13AC; //offset 13AC
    int ___unk_13B0; //offset 13B0
    int ___unk_13B4; //offset 13B4
    int ___unk_13B8; //offset 13B8
    int ___unk_13BC; //offset 13BC
    int ___unk_13C0; //offset 13C0
    int ___unk_13C4; //offset 13C4
    int ___unk_13C8; //offset 13C8
    int ___unk_13CC; //offset 13CC
    int ___unk_13D0; //offset 13D0
    int ___unk_13D4; //offset 13D4
    int ___unk_13D8; //offset 13D8
    int ___unk_13DC; //offset 13DC
    int ___unk_13E0; //offset 13E0
    int ___unk_13E4; //offset 13E4
    int ___unk_13E8; //offset 13E8
    int ___unk_13EC; //offset 13EC
    int ___unk_13F0; //offset 13F0
    int ___unk_13F4; //offset 13F4
    int ___unk_13F8; //offset 13F8
    int ___unk_13FC; //offset 13FC
    int ___unk_1400; //offset 1400
    int ___unk_1404; //offset 1404
    int ___unk_1408; //offset 1408
    int ___unk_140C; //offset 140C
    int ___unk_1410; //offset 1410
    int ___unk_1414; //offset 1414
    int ___unk_1418; //offset 1418
    int ___unk_141C; //offset 141C
    int ___unk_1420; //offset 1420
    int ___unk_1424; //offset 1424
    int ___unk_1428; //offset 1428
    int ___unk_142C; //offset 142C
    int ___unk_1430; //offset 1430
    int ___unk_1434; //offset 1434
    int ___unk_1438; //offset 1438
    int ___unk_143C; //offset 143C
    int ___unk_1440; //offset 1440
    int ___unk_1444; //offset 1444
    int ___unk_1448; //offset 1448
    int ___unk_144C; //offset 144C
    int ___unk_1450; //offset 1450
    int ___unk_1454; //offset 1454
    int ___unk_1458; //offset 1458
    int ___unk_145C; //offset 145C
    int ___unk_1460; //offset 1460
    int ___unk_1464; //offset 1464
    int ___unk_1468; //offset 1468
    int ___unk_146C; //offset 146C
    int ___unk_1470; //offset 1470
    int ___unk_1474; //offset 1474
    int ___unk_1478; //offset 1478
    int ___unk_147C; //offset 147C
    int ___unk_1480; //offset 1480
    int ___unk_1484; //offset 1484
    int ___unk_1488; //offset 1488
    int ___unk_148C; //offset 148C
    int ___unk_1490; //offset 1490
    int ___unk_1494; //offset 1494
    int ___unk_1498; //offset 1498
    int ___unk_149C; //offset 149C
    int ___unk_14A0; //offset 14A0
    int ___unk_14A4; //offset 14A4
    int ___unk_14A8; //offset 14A8
    int ___unk_14AC; //offset 14AC
    int ___unk_14B0; //offset 14B0
    int ___unk_14B4; //offset 14B4
    int ___unk_14B8; //offset 14B8
    int ___unk_14BC; //offset 14BC
    int ___unk_14C0; //offset 14C0
    int ___unk_14C4; //offset 14C4
    int ___unk_14C8; //offset 14C8
    int ___unk_14CC; //offset 14CC
    int ___unk_14D0; //offset 14D0
    int ___unk_14D4; //offset 14D4
    int ___unk_14D8; //offset 14D8
    int ___unk_14DC; //offset 14DC
    int ___unk_14E0; //offset 14E0
    int ___unk_14E4; //offset 14E4
    int ___unk_14E8; //offset 14E8
    int ___unk_14EC; //offset 14EC
    int ___unk_14F0; //offset 14F0
    int ___unk_14F4; //offset 14F4
    int ___unk_14F8; //offset 14F8
    int ___unk_14FC; //offset 14FC
    int ___unk_1500; //offset 1500
    int ___unk_1504; //offset 1504
    int ___unk_1508; //offset 1508
    int ___unk_150C; //offset 150C
    int ___unk_1510; //offset 1510
    int ___unk_1514; //offset 1514
    int ___unk_1518; //offset 1518
    int ___unk_151C; //offset 151C
    int ___unk_1520; //offset 1520
    int ___unk_1524; //offset 1524
    int ___unk_1528; //offset 1528
    int ___unk_152C; //offset 152C
    int ___unk_1530; //offset 1530
    int ___unk_1534; //offset 1534
    int ___unk_1538; //offset 1538
    int ___unk_153C; //offset 153C
    int ___unk_1540; //offset 1540
    int ___unk_1544; //offset 1544
    int ___unk_1548; //offset 1548
    int ___unk_154C; //offset 154C
    int ___unk_1550; //offset 1550
    int ___unk_1554; //offset 1554
    int ___unk_1558; //offset 1558
    int ___unk_155C; //offset 155C
    int ___unk_1560; //offset 1560
    int ___unk_1564; //offset 1564
    int ___unk_1568; //offset 1568
    int ___unk_156C; //offset 156C
    int ___unk_1570; //offset 1570
    int ___unk_1574; //offset 1574
    int ___unk_1578; //offset 1578
    int ___unk_157C; //offset 157C
    int ___unk_1580; //offset 1580
    int ___unk_1584; //offset 1584
    int ___unk_1588; //offset 1588
    int ___unk_158C; //offset 158C
    int ___unk_1590; //offset 1590
    int ___unk_1594; //offset 1594
    int ___unk_1598; //offset 1598
    int ___unk_159C; //offset 159C
    int ___unk_15A0; //offset 15A0
    int ___unk_15A4; //offset 15A4
    int ___unk_15A8; //offset 15A8
    int ___unk_15AC; //offset 15AC
    int ___unk_15B0; //offset 15B0
    int ___unk_15B4; //offset 15B4
    int ___unk_15B8; //offset 15B8
    int ___unk_15BC; //offset 15BC
    int ___unk_15C0; //offset 15C0
    int ___unk_15C4; //offset 15C4
    int ___unk_15C8; //offset 15C8
    int ___unk_15CC; //offset 15CC
    int ___unk_15D0; //offset 15D0
    int ___unk_15D4; //offset 15D4
    int ___unk_15D8; //offset 15D8
    int ___unk_15DC; //offset 15DC
    int ___unk_15E0; //offset 15E0
    int ___unk_15E4; //offset 15E4
    int ___unk_15E8; //offset 15E8
    int ___unk_15EC; //offset 15EC
    int ___unk_15F0; //offset 15F0
    int ___unk_15F4; //offset 15F4
    int ___unk_15F8; //offset 15F8
    int ___unk_15FC; //offset 15FC
    int ___unk_1600; //offset 1600
    int ___unk_1604; //offset 1604
    int ___unk_1608; //offset 1608
    int ___unk_160C; //offset 160C
    int ___unk_1610; //offset 1610
    int ___unk_1614; //offset 1614
    int ___unk_1618; //offset 1618
    int ___unk_161C; //offset 161C
    int ___unk_1620; //offset 1620
    int ___unk_1624; //offset 1624
    int ___unk_1628; //offset 1628
    int ___unk_162C; //offset 162C
    int ___unk_1630; //offset 1630
    int ___unk_1634; //offset 1634
    int ___unk_1638; //offset 1638
    int ___unk_163C; //offset 163C
    int ___unk_1640; //offset 1640
    int ___unk_1644; //offset 1644
    int ___unk_1648; //offset 1648
    int ___unk_164C; //offset 164C
    int ___unk_1650; //offset 1650
    int ___unk_1654; //offset 1654
    int ___unk_1658; //offset 1658
    int ___unk_165C; //offset 165C
    int ___unk_1660; //offset 1660
    int ___unk_1664; //offset 1664
    int ___unk_1668; //offset 1668
    int ___unk_166C; //offset 166C
    int ___unk_1670; //offset 1670
    int ___unk_1674; //offset 1674
    int ___unk_1678; //offset 1678
    int ___unk_167C; //offset 167C
    int ___unk_1680; //offset 1680
    int ___unk_1684; //offset 1684
    int ___unk_1688; //offset 1688
    int ___unk_168C; //offset 168C
    int ___unk_1690; //offset 1690
    int ___unk_1694; //offset 1694
    int ___unk_1698; //offset 1698
    int ___unk_169C; //offset 169C
    int ___unk_16A0; //offset 16A0
    int ___unk_16A4; //offset 16A4
    int ___unk_16A8; //offset 16A8
    int ___unk_16AC; //offset 16AC
    int ___unk_16B0; //offset 16B0
    int ___unk_16B4; //offset 16B4
    int ___unk_16B8; //offset 16B8
    int ___unk_16BC; //offset 16BC
    int ___unk_16C0; //offset 16C0
    int ___unk_16C4; //offset 16C4
    int ___unk_16C8; //offset 16C8
    int ___unk_16CC; //offset 16CC
    int ___unk_16D0; //offset 16D0
    int ___unk_16D4; //offset 16D4
    int ___unk_16D8; //offset 16D8
    int ___unk_16DC; //offset 16DC
    int ___unk_16E0; //offset 16E0
    int ___unk_16E4; //offset 16E4
    int ___unk_16E8; //offset 16E8
    int ___unk_16EC; //offset 16EC
    int ___unk_16F0; //offset 16F0
    int ___unk_16F4; //offset 16F4
    int ___unk_16F8; //offset 16F8
    int ___unk_16FC; //offset 16FC
    int ___unk_1700; //offset 1700
    int ___unk_1704; //offset 1704
    int ___unk_1708; //offset 1708
    int ___unk_170C; //offset 170C
    int ___unk_1710; //offset 1710
    int ___unk_1714; //offset 1714
    int ___unk_1718; //offset 1718
    int ___unk_171C; //offset 171C
    int ___unk_1720; //offset 1720
    int ___unk_1724; //offset 1724
    int ___unk_1728; //offset 1728
    int ___unk_172C; //offset 172C
    int ___unk_1730; //offset 1730
    int ___unk_1734; //offset 1734
    int ___unk_1738; //offset 1738
    int ___unk_173C; //offset 173C
    int ___unk_1740; //offset 1740
    int ___unk_1744; //offset 1744
    int ___unk_1748; //offset 1748
    int ___unk_174C; //offset 174C
    int ___unk_1750; //offset 1750
    int ___unk_1754; //offset 1754
    int ___unk_1758; //offset 1758
    int ___unk_175C; //offset 175C
    int ___unk_1760; //offset 1760
    int ___unk_1764; //offset 1764
    int ___unk_1768; //offset 1768
    int ___unk_176C; //offset 176C
    int ___unk_1770; //offset 1770
    int ___unk_1774; //offset 1774
    int ___unk_1778; //offset 1778
    int ___unk_177C; //offset 177C
    int ___unk_1780; //offset 1780
    int ___unk_1784; //offset 1784
    int ___unk_1788; //offset 1788
    int ___unk_178C; //offset 178C
    int ___unk_1790; //offset 1790
    int ___unk_1794; //offset 1794
    int ___unk_1798; //offset 1798
    int ___unk_179C; //offset 179C
    int ___unk_17A0; //offset 17A0
    int ___unk_17A4; //offset 17A4
    int ___unk_17A8; //offset 17A8
    int ___unk_17AC; //offset 17AC
    int ___unk_17B0; //offset 17B0
    int ___unk_17B4; //offset 17B4
    int ___unk_17B8; //offset 17B8
    int ___unk_17BC; //offset 17BC
    int ___unk_17C0; //offset 17C0
    int ___unk_17C4; //offset 17C4
    int ___unk_17C8; //offset 17C8
    int ___unk_17CC; //offset 17CC
    int ___unk_17D0; //offset 17D0
    int ___unk_17D4; //offset 17D4
    int ___unk_17D8; //offset 17D8
    int ___unk_17DC; //offset 17DC
    int ___unk_17E0; //offset 17E0
    int ___unk_17E4; //offset 17E4
    int ___unk_17E8; //offset 17E8
    int ___unk_17EC; //offset 17EC
    int ___unk_17F0; //offset 17F0
    int ___unk_17F4; //offset 17F4
    int ___unk_17F8; //offset 17F8
    int ___unk_17FC; //offset 17FC
    int ___unk_1800; //offset 1800
    int ___unk_1804; //offset 1804
    int ___unk_1808; //offset 1808
    int ___unk_180C; //offset 180C
    int ___unk_1810; //offset 1810
    int ___unk_1814; //offset 1814
    int ___unk_1818; //offset 1818
    int ___unk_181C; //offset 181C
    int ___unk_1820; //offset 1820
    int ___unk_1824; //offset 1824
    int ___unk_1828; //offset 1828
    int ___unk_182C; //offset 182C
    int ___unk_1830; //offset 1830
    int ___unk_1834; //offset 1834
    int ___unk_1838; //offset 1838
    int ___unk_183C; //offset 183C
    int ___unk_1840; //offset 1840
    int ___unk_1844; //offset 1844
    int ___unk_1848; //offset 1848
    int ___unk_184C; //offset 184C
    int ___unk_1850; //offset 1850
    int ___unk_1854; //offset 1854
    int ___unk_1858; //offset 1858
    int ___unk_185C; //offset 185C
    int ___unk_1860; //offset 1860
    int ___unk_1864; //offset 1864
    int ___unk_1868; //offset 1868
    int ___unk_186C; //offset 186C
    int ___unk_1870; //offset 1870
    int ___unk_1874; //offset 1874
    int ___unk_1878; //offset 1878
    int ___unk_187C; //offset 187C
    int ___unk_1880; //offset 1880
    int ___unk_1884; //offset 1884
    int ___unk_1888; //offset 1888
    int ___unk_188C; //offset 188C
    int ___unk_1890; //offset 1890
    int ___unk_1894; //offset 1894
    int ___unk_1898; //offset 1898
    int ___unk_189C; //offset 189C
    int ___unk_18A0; //offset 18A0
    int ___unk_18A4; //offset 18A4
    int ___unk_18A8; //offset 18A8
    int ___unk_18AC; //offset 18AC
    int ___unk_18B0; //offset 18B0
    int ___unk_18B4; //offset 18B4
    int ___unk_18B8; //offset 18B8
    int ___unk_18BC; //offset 18BC
    int ___unk_18C0; //offset 18C0
    int ___unk_18C4; //offset 18C4
    int ___unk_18C8; //offset 18C8
    int ___unk_18CC; //offset 18CC
    int ___unk_18D0; //offset 18D0
    int ___unk_18D4; //offset 18D4
    int ___unk_18D8; //offset 18D8
    int ___unk_18DC; //offset 18DC
    int ___unk_18E0; //offset 18E0
    int ___unk_18E4; //offset 18E4
    int ___unk_18E8; //offset 18E8
    int ___unk_18EC; //offset 18EC
    int ___unk_18F0; //offset 18F0
    int ___unk_18F4; //offset 18F4
    int ___unk_18F8; //offset 18F8
    int ___unk_18FC; //offset 18FC
    int ___unk_1900; //offset 1900
    int ___unk_1904; //offset 1904
    int ___unk_1908; //offset 1908
    int ___unk_190C; //offset 190C
    int ___unk_1910; //offset 1910
    int ___unk_1914; //offset 1914
    int ___unk_1918; //offset 1918
    int ___unk_191C; //offset 191C
    int ___unk_1920; //offset 1920
    int ___unk_1924; //offset 1924
    int ___unk_1928; //offset 1928
    int ___unk_192C; //offset 192C
    int ___unk_1930; //offset 1930
    int ___unk_1934; //offset 1934
    int ___unk_1938; //offset 1938
    int ___unk_193C; //offset 193C
    int ___unk_1940; //offset 1940
    int ___unk_1944; //offset 1944
    int ___unk_1948; //offset 1948
    int ___unk_194C; //offset 194C
    int ___unk_1950; //offset 1950
    int ___unk_1954; //offset 1954
    int ___unk_1958; //offset 1958
    int ___unk_195C; //offset 195C
    int ___unk_1960; //offset 1960
    int ___unk_1964; //offset 1964
    int ___unk_1968; //offset 1968
    int ___unk_196C; //offset 196C
    int ___unk_1970; //offset 1970
    int ___unk_1974; //offset 1974
    int ___unk_1978; //offset 1978
    int ___unk_197C; //offset 197C
    int ___unk_1980; //offset 1980
    int ___unk_1984; //offset 1984
    int ___unk_1988; //offset 1988
    int ___unk_198C; //offset 198C
    int ___unk_1990; //offset 1990
    int ___unk_1994; //offset 1994
    int ___unk_1998; //offset 1998
    int ___unk_199C; //offset 199C
    int ___unk_19A0; //offset 19A0
    int ___unk_19A4; //offset 19A4
    int ___unk_19A8; //offset 19A8
    int ___unk_19AC; //offset 19AC
    int ___unk_19B0; //offset 19B0
    int ___unk_19B4; //offset 19B4
    CUserSocket *pUserSocket; //offset 19B8
    CTrade *pTrade; //offset 19BC
    int ___unk_19C0; //offset 19C0
    int ___unk_19C4; //offset 19C4
    int ___unk_19C8; //offset 19C8
    int ___unk_19CC; //offset 19CC
    int ___unk_19D0; //offset 19D0
    int ___unk_19D4; //offset 19D4
    int ___unk_19D8; //offset 19D8
    int ___unk_19DC; //offset 19DC //*PrivateStoreMsg (2017)
    int ___unk_19E0; //offset 19E0
    int ___unk_19E4; //offset 19E4
    int ___unk_19E8; //offset 19E8
    int ___unk_19EC; //offset 19EC
    int ___unk_19F0; //offset 19F0
    int ___unk_19F4; //offset 19F4
    int ___unk_19F8; //offset 19F8
    int ___unk_19FC; //offset 19FC
    int ___unk_1A00; //offset 1A00
    int ___unk_1A04; //offset 1A04
    int ___unk_1A08; //offset 1A08
    int ___unk_1A0C; //offset 1A0C
    int ___unk_1A10; //offset 1A10
    int ___unk_1A14; //offset 1A14
    int ___unk_1A18; //offset 1A18
    int ___unk_1A1C; //offset 1A1C
    int ___unk_1A20; //offset 1A20
    int ___unk_1A24; //offset 1A24
    int ___unk_1A28; //offset 1A28
    int ___unk_1A2C; //offset 1A2C
    int ___unk_1A30; //offset 1A30
    int ___unk_1A34; //offset 1A34
    int ___unk_1A38; //offset 1A38
    int ___unk_1A3C; //offset 1A3C
    int ___unk_1A40; //offset 1A40
    int ___unk_1A44; //offset 1A44
    int ___unk_1A48; //offset 1A48
    int ___unk_1A4C; //offset 1A4C
    int ___unk_1A50; //offset 1A50
    int ___unk_1A54; //offset 1A54
    int BlockUserStructure; //offset 1A58
    int ___unk_1A5C; //offset 1A5C
    int BlockUserStructureLOCK; //offset 1A60
    int ___unk_1A64; //offset 1A64
    int ___unk_1A68; //offset 1A68
    int ___unk_1A6C; //offset 1A6C
    int ___unk_1A70; //offset 1A70
    int ___unk_1A74; //offset 1A74
    int ___unk_1A78; //offset 1A78
    int ___unk_1A7C; //offset 1A7C
    int ___unk_1A80; //offset 1A80
    int ___unk_1A84; //offset 1A84
    int ___unk_1A88; //offset 1A88
    int ___unk_1A8C; //offset 1A8C
    int ___unk_1A90; //offset 1A90
    int ___unk_1A94; //offset 1A94
    int ___unk_1A98; //offset 1A98
    int ___unk_1A9C; //offset 1A9C
    int ___unk_1AA0; //offset 1AA0
    int ___unk_1AA4; //offset 1AA4
    int ___unk_1AA8; //offset 1AA8
    int ___unk_1AAC; //offset 1AAC
    int ___unk_1AB0; //offset 1AB0
    int ___unk_1AB4; //offset 1AB4
    int ___unk_1AB8; //offset 1AB8
    int ___unk_1ABC; //offset 1ABC
    int ___unk_1AC0; //offset 1AC0
    int ___unk_1AC4; //offset 1AC4
    int ___unk_1AC8; //offset 1AC8
    int ___unk_1ACC; //offset 1ACC
    int ___unk_1AD0; //offset 1AD0
    int ___unk_1AD4; //offset 1AD4
    int ___unk_1AD8; //offset 1AD8
    int ___unk_1ADC; //offset 1ADC
    int pledgeOBJID; //offset 1AE0
    int ___unk_1AE4; //offset 1AE4
    int ___unk_1AE8; //offset 1AE8
    WCHAR szTitle[25]; //offset 1AEC
    bool ___unk_1B1E;
    bool ___unk_1B1F;
    int ___unk_1B20; //offset 1B20
    int ___unk_1B24; //offset 1B24
    int ___unk_1B28; //offset 1B28
    int ___unk_1B2C; //offset 1B2C
    int ___unk_1B30; //offset 1B30
    int ___unk_1B34; //offset 1B34
    int ___unk_1B38; //offset 1B38
    int ___unk_1B3C; //offset 1B3C
    int ___unk_1B40; //offset 1B40
    int ___unk_1B44; //offset 1B44
    int ___unk_1B48; //offset 1B48
    int ___unk_1B4C; //offset 1B4C
    int ___unk_1B50; //offset 1B50
    int ___unk_1B54; //offset 1B54
    int ___unk_1B58; //offset 1B58
    int nPartyLoot; //offset 1B5C
    bool  rejecting_friend_invitations; //offset 1B60
	bool unk_1B61;
	bool unk_1B62;
	bool unk_1B63;
    int ___unk_1B64; //offset 1B64
    int ___unk_1B68; //offset 1B68
    int ___unk_1B6C; //offset 1B6C
    int ___unk_1B70; //offset 1B70
    int ___unk_1B74; //offset 1B74
    int ___unk_1B78; //offset 1B78
    int ___unk_1B7C; //offset 1B7C
    int ___unk_1B80; //offset 1B80
    int ___unk_1B84; //offset 1B84
    int ___unk_1B88; //offset 1B88
    int inventory_count; //offset 1B8C
    int ___unk_1B90; //offset 1B90
    int ACTIVE_ITEM; //offset 1B94 *pItem
    int ___unk_1B98; //offset 1B98
    int ___unk_1B9C; //offset 1B9C
    int ___unk_1BA0; //offset 1BA0
    int ___unk_1BA4; //offset 1BA4
    int ___unk_1BA8; //offset 1BA8
    int ___unk_1BAC; //offset 1BAC
    int ___unk_1BB0; //offset 1BB0
    int ___unk_1BB4; //offset 1BB4
    bool bFindPartyMembers; //offset 1BB8
	bool ___unk_1BB9;
	bool ___unk_1BBA;
	bool ___unk_1BBB;
    int ___unk_1BBC; //offset 1BBC
    int ___unk_1BC0; //offset 1BC0
    int ___unk_1BC4; //offset 1BC4
    int ___unk_1BC8; //offset 1BC8
    int ___unk_1BCC; //offset 1BCC
    int ___unk_1BD0; //offset 1BD0
    int ___unk_1BD4; //offset 1BD4
    int ___unk_1BD8; //offset 1BD8
    int ___unk_1BDC; //offset 1BDC
    int ___unk_1BE0; //offset 1BE0
    int ___unk_1BE4; //offset 1BE4
    int ___unk_1BE8; //offset 1BE8
    int ___unk_1BEC; //offset 1BEC
    int ___unk_1BF0; //offset 1BF0
    int ___unk_1BF4; //offset 1BF4
    int ___unk_1BF8; //offset 1BF8
    int ___unk_1BFC; //offset 1BFC
    int ___unk_1C00; //offset 1C00
    int ___unk_1C04; //offset 1C04
    int ___unk_1C08; //offset 1C08
    int ___unk_1C0C; //offset 1C0C
    int ___unk_1C10; //offset 1C10
    int ___unk_1C14; //offset 1C14
    int ___unk_1C18; //offset 1C18
    int ___unk_1C1C; //offset 1C1C
    int ___unk_1C20; //offset 1C20
    int ___unk_1C24; //offset 1C24
    int ___unk_1C28; //offset 1C28
    int ___unk_1C2C; //offset 1C2C
    int ___unk_1C30; //offset 1C30
    int ___unk_1C34; //offset 1C34
    int ___unk_1C38; //offset 1C38
    int ___unk_1C3C; //offset 1C3C
    int ___unk_1C40; //offset 1C40
    int ___unk_1C44; //offset 1C44
    int ___unk_1C48; //offset 1C48
    int ___unk_1C4C; //offset 1C4C
    int ___unk_1C50; //offset 1C50
    int ___unk_1C54; //offset 1C54
    int ___unk_1C58; //offset 1C58
    int ___unk_1C5C; //offset 1C5C
    int ___unk_1C60; //offset 1C60
    int ___unk_1C64; //offset 1C64
    int ___unk_1C68; //offset 1C68
    int ___unk_1C6C; //offset 1C6C
    int ___unk_1C70; //offset 1C70
    int ___unk_1C74; //offset 1C74
    int ___unk_1C78; //offset 1C78
    int ___unk_1C7C; //offset 1C7C
    int ___unk_1C80; //offset 1C80
    int ___unk_1C84; //offset 1C84
    int ___unk_1C88; //offset 1C88
    int ___unk_1C8C; //offset 1C8C
    int ___unk_1C90; //offset 1C90
    int ___unk_1C94; //offset 1C94
    int ___unk_1C98; //offset 1C98
    int ___unk_1C9C; //offset 1C9C
    int ___unk_1CA0; //offset 1CA0
    int ___unk_1CA4; //offset 1CA4
    int ___unk_1CA8; //offset 1CA8
    int ___unk_1CAC; //offset 1CAC
    int ___unk_1CB0; //offset 1CB0
    int ___unk_1CB4; //offset 1CB4
    int ___unk_1CB8; //offset 1CB8
    int ___unk_1CBC; //offset 1CBC
    int ___unk_1CC0; //offset 1CC0
    int ___unk_1CC4; //offset 1CC4
    int ___unk_1CC8; //offset 1CC8
    int ___unk_1CCC; //offset 1CCC
    int ___unk_1CD0; //offset 1CD0
    int ___unk_1CD4; //offset 1CD4
    int ___unk_1CD8; //offset 1CD8
    int ___unk_1CDC; //offset 1CDC
    int ___unk_1CE0; //offset 1CE0
    int ___unk_1CE4; //offset 1CE4
    int ___unk_1CE8; //offset 1CE8
    int ___unk_1CEC; //offset 1CEC
    int ___unk_1CF0; //offset 1CF0
    int ___unk_1CF4; //offset 1CF4
    int ___unk_1CF8; //offset 1CF8
    int ___unk_1CFC; //offset 1CFC
    int ___unk_1D00; //offset 1D00
    int ___unk_1D04; //offset 1D04
    int ___unk_1D08; //offset 1D08
    int ___unk_1D0C; //offset 1D0C
    int ___unk_1D10; //offset 1D10
    int ___unk_1D14; //offset 1D14
    int ___unk_1D18; //offset 1D18
    int ___unk_1D1C; //offset 1D1C
    int ___unk_1D20; //offset 1D20
    int ___unk_1D24; //offset 1D24
    int ___unk_1D28; //offset 1D28
    int ___unk_1D2C; //offset 1D2C
    int ___unk_1D30; //offset 1D30
    int ___unk_1D34; //offset 1D34
    int ___unk_1D38; //offset 1D38
    int ___unk_1D3C; //offset 1D3C
    int ___unk_1D40; //offset 1D40
    int ___unk_1D44; //offset 1D44
    int ___unk_1D48; //offset 1D48
    int ___unk_1D4C; //offset 1D4C
    int ___unk_1D50; //offset 1D50
    int ___unk_1D54; //offset 1D54
    int ___unk_1D58; //offset 1D58
    int ___unk_1D5C; //offset 1D5C
    int ___unk_1D60; //offset 1D60
    int ___unk_1D64; //offset 1D64
    int ___unk_1D68; //offset 1D68
    int ___unk_1D6C; //offset 1D6C
    int ___unk_1D70; //offset 1D70
    int ___unk_1D74; //offset 1D74
    int ___unk_1D78; //offset 1D78
    int ___unk_1D7C; //offset 1D7C
    int ___unk_1D80; //offset 1D80
    int ___unk_1D84; //offset 1D84
    int ___unk_1D88; //offset 1D88
    int ___unk_1D8C; //offset 1D8C
    int ___unk_1D90; //offset 1D90
    int ___unk_1D94; //offset 1D94
    int ___unk_1D98; //offset 1D98
    int ___unk_1D9C; //offset 1D9C
    int ___unk_1DA0; //offset 1DA0
    int ___unk_1DA4; //offset 1DA4
    int ___unk_1DA8; //offset 1DA8
    int ___unk_1DAC; //offset 1DAC
    int ___unk_1DB0; //offset 1DB0
    int ___unk_1DB4; //offset 1DB4
    int ___unk_1DB8; //offset 1DB8
    int ___unk_1DBC; //offset 1DBC
    int ___unk_1DC0; //offset 1DC0
    int ___unk_1DC4; //offset 1DC4
    int nClanCrestID; //offset 1DC8
    int nAllyCrestID; //offset 1DCC
    int ___unk_1DD0; //offset 1DD0
    int ___unk_1DD4; //offset 1DD4
    int ___unk_1DD8; //offset 1DD8
    int ___unk_1DDC; //offset 1DDC
    int ___unk_1DE0; //offset 1DE0
    int ___unk_1DE4; //offset 1DE4
    int ___unk_1DE8; //offset 1DE8
    int ___unk_1DEC; //offset 1DEC
    int ___unk_1DF0; //offset 1DF0
    int ___unk_1DF4; //offset 1DF4
    int ___unk_1DF8; //offset 1DF8
    int ___unk_1DFC; //offset 1DFC
    int ___unk_1E00; //offset 1E00
    int ___unk_1E04; //offset 1E04
    int ___unk_1E08; //offset 1E08
    int ___unk_1E0C; //offset 1E0C
    int ___unk_1E10; //offset 1E10
    int ___unk_1E14; //offset 1E14
    int ___unk_1E18; //offset 1E18
    int ___unk_1E1C; //offset 1E1C
    int ___unk_1E20; //offset 1E20
    int ___unk_1E24; //offset 1E24
    int ___unk_1E28; //offset 1E28
    int ___unk_1E2C; //offset 1E2C
    int ___unk_1E30; //offset 1E30
    int ___unk_1E34; //offset 1E34
    int ___unk_1E38; //offset 1E38
    int ___unk_1E3C; //offset 1E3C
    int ___unk_1E40; //offset 1E40
    int ___unk_1E44; //offset 1E44
    int ___unk_1E48; //offset 1E48
    int ___unk_1E4C; //offset 1E4C
    int ___unk_1E50; //offset 1E50
    int ___unk_1E54; //offset 1E54
    int ___unk_1E58; //offset 1E58
    int ___unk_1E5C; //offset 1E5C
    int ___unk_1E60; //offset 1E60
    int ___unk_1E64; //offset 1E64
    int ___unk_1E68; //offset 1E68
    int ___unk_1E6C; //offset 1E6C
    int ___unk_1E70; //offset 1E70
    int ___unk_1E74; //offset 1E74
    int ___unk_1E78; //offset 1E78
    int ___unk_1E7C; //offset 1E7C
    int ___unk_1E80; //offset 1E80
    int ___unk_1E84; //offset 1E84
    int ___unk_1E88; //offset 1E88
    int ___unk_1E8C; //offset 1E8C
    int ___unk_1E90; //offset 1E90
    int ___unk_1E94; //offset 1E94
    int ___unk_1E98; //offset 1E98
    int ___unk_1E9C; //offset 1E9C
    int ___unk_1EA0; //offset 1EA0
    int ___unk_1EA4; //offset 1EA4
    int ___unk_1EA8; //offset 1EA8
    int ___unk_1EAC; //offset 1EAC
    int ___unk_1EB0; //offset 1EB0
    int ___unk_1EB4; //offset 1EB4
    int ___unk_1EB8; //offset 1EB8
    int ___unk_1EBC; //offset 1EBC
    int ___unk_1EC0; //offset 1EC0
    int ___unk_1EC4; //offset 1EC4
    int ___unk_1EC8; //offset 1EC8
    int ___unk_1ECC; //offset 1ECC
    int ___unk_1ED0; //offset 1ED0
    int ___unk_1ED4; //offset 1ED4
    int ___unk_1ED8; //offset 1ED8
    int ___unk_1EDC; //offset 1EDC
    int ___unk_1EE0; //offset 1EE0
    int ___unk_1EE4; //offset 1EE4
    int ___unk_1EE8; //offset 1EE8
    int ___unk_1EEC; //offset 1EEC
    int ___unk_1EF0; //offset 1EF0
    int ___unk_1EF4; //offset 1EF4
    int ___unk_1EF8; //offset 1EF8
    int ___unk_1EFC; //offset 1EFC
    int ___unk_1F00; //offset 1F00
    int ___unk_1F04; //offset 1F04
    int ___unk_1F08; //offset 1F08
    int ___unk_1F0C; //offset 1F0C
    int ___unk_1F10; //offset 1F10
    int ___unk_1F14; //offset 1F14
    int ___unk_1F18; //offset 1F18
    int ___unk_1F1C; //offset 1F1C
    int ___unk_1F20; //offset 1F20
    int ___unk_1F24; //offset 1F24
    int ___unk_1F28; //offset 1F28
    int ___unk_1F2C; //offset 1F2C
    int ___unk_1F30; //offset 1F30
    int ___unk_1F34; //offset 1F34
    int ___unk_1F38; //offset 1F38
    int ___unk_1F3C; //offset 1F3C
    int ___unk_1F40; //offset 1F40
    int ___unk_1F44; //offset 1F44
    int ___unk_1F48; //offset 1F48
    int ___unk_1F4C; //offset 1F4C
    int ___unk_1F50; //offset 1F50
    int ___unk_1F54; //offset 1F54
    int ___unk_1F58; //offset 1F58
    int ___unk_1F5C; //offset 1F5C
    int ___unk_1F60; //offset 1F60
    int ___unk_1F64; //offset 1F64
    int ___unk_1F68; //offset 1F68
    int ___unk_1F6C; //offset 1F6C
    int ___unk_1F70; //offset 1F70
    int ___unk_1F74; //offset 1F74
    int ___unk_1F78; //offset 1F78
    int ___unk_1F7C; //offset 1F7C
    int ___unk_1F80; //offset 1F80
    int ___unk_1F84; //offset 1F84
    int ___unk_1F88; //offset 1F88
    int ___unk_1F8C; //offset 1F8C
    int ___unk_1F90; //offset 1F90
    int ___unk_1F94; //offset 1F94
    int ___unk_1F98; //offset 1F98
    int ___unk_1F9C; //offset 1F9C
    int ___unk_1FA0; //offset 1FA0
    int ___unk_1FA4; //offset 1FA4
    int ___unk_1FA8; //offset 1FA8
    int ___unk_1FAC; //offset 1FAC
    int ___unk_1FB0; //offset 1FB0
    int ___unk_1FB4; //offset 1FB4
    int ___unk_1FB8; //offset 1FB8
    int ___unk_1FBC; //offset 1FBC
    int ___unk_1FC0; //offset 1FC0
    int ___unk_1FC4; //offset 1FC4
    int ___unk_1FC8; //offset 1FC8
    int ___unk_1FCC; //offset 1FCC
    int ___unk_1FD0; //offset 1FD0
    int ___unk_1FD4; //offset 1FD4
    int ___unk_1FD8; //offset 1FD8
    int ___unk_1FDC; //offset 1FDC
    int ___unk_1FE0; //offset 1FE0
    int ___unk_1FE4; //offset 1FE4
    int ___unk_1FE8; //offset 1FE8
    int ___unk_1FEC; //offset 1FEC
    int ___unk_1FF0; //offset 1FF0
    int ___unk_1FF4; //offset 1FF4
    int ___unk_1FF8; //offset 1FF8
    int ___unk_1FFC; //offset 1FFC
	//virtual functions
    virtual int System0(int Arg1, int Arg2); //offset 0000  
    virtual int System1(); //offset 0004
    virtual int System2(); //offset 0008
    virtual int System3(); //offset 000C
    virtual int System4(); //offset 0010
    virtual int System5(); //offset 0014
    virtual int System6(); //offset 0018
    virtual int System7(); //offset 001C
    virtual int TimerExpired(); //offset 0020
    virtual int ___func_0024(); //offset 0024
    virtual int OnIOTimerCallback(); //offset 0028
    virtual int ___func_002C(); //offset 002C
    virtual int OnIOCallback(); //offset 0030
    virtual int ___func_0034(); //offset 0034
    virtual void GetLocation(FVector* pLocation); //offset 0038
    virtual void GetGetHeading(int *RetVal); //offset 003C
    virtual int GetIndex(); //offset 0040
    virtual int ___func_0044(); //offset 0044
    virtual int Delete(); //offset 0048
    virtual int ___func_004C(); //offset 004C
    virtual int ___func_0050(); //offset 0050
    virtual int ___func_0054(); //offset 0054
    virtual int ___func_0058(); //offset 0058
    virtual int ___func_005C(); //offset 005C
    virtual int ___func_0060(); //offset 0060
    virtual int ___func_0064(); //offset 0064
    virtual int ___func_0068(); //offset 0068
    virtual int ___func_006C(); //offset 006C
    virtual int ___func_0070(); //offset 0070
    virtual int ___func_0074(); //offset 0074
    virtual int ___func_0078(); //offset 0078
    virtual int ___func_007C(); //offset 007C
    virtual int ___func_0080(); //offset 0080
    virtual int ___func_0084(); //offset 0084
    virtual int ___func_0088(); //offset 0088
    virtual int ___func_008C(); //offset 008C
    virtual int ___func_0090(); //offset 0090
    virtual int ___func_0094(); //offset 0094
    virtual int ___func_0098(); //offset 0098
    virtual int ___func_009C(); //offset 009C
    virtual int ___func_00A0(); //offset 00A0
    virtual int ___func_00A4(); //offset 00A4
    virtual int ___func_00A8(); //offset 00A8
    virtual int ___func_00AC(); //offset 00AC
    virtual int ___func_00B0(); //offset 00B0
    virtual int ___func_00B4(); //offset 00B4
    virtual int ___func_00B8(); //offset 00B8
    virtual int ___func_00BC(); //offset 00BC
	virtual int ___func_00C0(); //offset 00C0
    virtual int ___func_00C4(); //offset 00D4
    virtual int ___func_00C8(); //offset 00D8
    virtual int ___func_00CC(); //offset 00CC
	virtual int ___func_00E0(); //offset 00D0
    virtual int ___func_00E4(); //offset 00D4
    virtual int ___func_00D8(); //offset 00D8
    virtual int ___func_00DC(); //offset 00DC
    virtual bool IsInVehicle(); //offset 00E0
    virtual bool IsCanBeAttacked(CCreature_ * pObject); //offset 00E4
    virtual bool IsEnemyTo(CCreature_ * pObject); //offset 00E8 same
    virtual int User__IsMakeAttackerGuilty(); //offset 00EC
    virtual int User__IsMakeAttackerChao(); //offset 00F0
    virtual bool IsAlive(); //offset 00F4
    virtual int ___func_00F8(); //offset 00F8
    virtual int ___func_00FC(); //offset 00FC
    virtual int ___func_0100(); //offset 0100
    virtual int User__InSight(); //offset 0104
    virtual int User__OutOfSight(); //offset 0108
    virtual void GetMeleeAttackPosition(FVector *Position, CCreature_ * pCreature); //offset 010C
    virtual void LogSetPropertyFailed(int nObjectFieldType); //offset 0110
    virtual void LogSetPropertyFailed2(int nObjectFieldType); //offset 0114
    virtual void LogSetPropertyFailedValueDouble(int nObjectFieldType, double dValue); //offset 0118
    virtual void LogSetPropertyFailedValueInt(int nObjectFieldTypem, int nValue); //offset 011C
    virtual void LogSetPropertyFailedValueInt2(int nObjectFieldTypem, int nValue); //offset 0120
    virtual void LogInvocatedDeprecatedMethod(); //offset 0124
    virtual PWCHAR* GetObjectName(); //offset 0128
    virtual int GetCharID(); //offset 012C
    virtual void SetCharID(int nNewDBID); //offset 0130
    virtual int Say(); //offset 0134
    virtual int ___func_0138(); //offset 0138
    virtual int ValidateLocation(); //offset 013C
    virtual bool ChangeClass(int nNewClassID); //offset 0140
    virtual double GetEquippedWeaponInfo5CGetCritical(); //offset 0144
    virtual double GetEquippedWeaponPhysicalDamage(); //offset 0148
    virtual double GetEquippedWeaponWeaponMagicDamage(); //offset 014C
    virtual double GetEquippedWeaponAttackSpeed(); //offset 0150
    virtual double GetEquippedWeaponGradePenalty(); //offset 0154
    virtual int GetEquippedWeaponConsumSS(); //offset 0158
    virtual int GetEquippedWeaponConsumSpS(); //offset 015C
    virtual double GetEquippedGradePenalty(); //offset 0160
    virtual int ValidateEquipmentMPBonus(); //offset 0164
    virtual double GetTotalEquippedSome2(); //offset 0168
    virtual void SetExp(int nNewExp); //offset 016C
    virtual void ExpInc(int nNewExp); //offset 0170
    virtual void SetPvPFlag(bool bNewValue); //offset 0174
    virtual void SetKarma(int nNewKarma); //offset 0178
    virtual int Virtual_User_GetStatsByLevel(); //offset 017C
    virtual int User__RegenBonusByMotionEx(); //offset 0180
    virtual int Virtual_User_Validate_fHit(); //offset 0184
    virtual int Virtual_User_Validate_fAvoid(); //offset 0188
    virtual int Virtual_User__SetPAttack(); //offset 018C
    virtual int Validate_MagicalAttack(); //offset 0190
    virtual int User__SetMAttack(); //offset 0194
    virtual int User_Validate_Weapon(); //offset 0198
    virtual int User__SetMDef(); //offset 019C
    virtual int User__SetWeaponRange(); //offset 01A0
    virtual int User__Set_SD_458h(); //offset 01A4
    virtual int User__SetBaseAttackSpeed(); //offset 01A8
    virtual int User__SetBaseCastingSpeed(); //offset 01AC
    virtual int User_Validate_Armor(); //offset 01B0
    virtual int User__SetAttackSpeed(); //offset 01B4
    virtual int User__SetBaseCritical(); //offset 01B8
    virtual int UpdateBasePhyAttack(); //offset 01BC
    virtual int User__CheckMaxInventoryLoad(); //offset 01C0
    virtual int User__GetEarshot(); //offset 01C4
    virtual int User__Set_SD_444h(); //offset 01C8
    virtual int User_Validate_MaxHpMp(); //offset 01CC
    virtual int User__ValidateOrgHPRegen(); //offset 01D0
    virtual int User__ValidateOrgMPRegen(); //offset 01D4
    virtual int User__SetBasePhysicalDamage(); //offset 01D8
    virtual int User__SetBaseDefend(); //offset 01DC
    virtual int User__SetBaseMagicDamage(); //offset 01E0
    virtual int User__SetBaseMagicDefend(); //offset 01E4
    virtual int User__ValidateOrgSpeed(); //offset 01E8
    virtual int Validate_Level_Change(); //offset 01EC
    virtual int User_SetAttckSpeed(); //offset 01F0
    virtual int User_ValidateSpeed(); //offset 01F4
    virtual double GetAttackSpeedMult(); //offset 01F8
    virtual double GetMoveSpeedMult(); //offset 01FC
    virtual int User__GetPAttack(); //offset 0200
    virtual double GetPHit(); //offset 0204
    virtual double GetPAvoid(); //offset 0208
    virtual int User__GetMAttack(); //offset 020C
    virtual double GetSD_3A0(); //offset 0210
    virtual double GetSD_398(); //offset 0214
    virtual int CCreature__BroadcastWaitType(); //offset 0218
    virtual int CCreature__BroadcastCombatModeStart(); //offset 021C
    virtual int CCreature__BroadcastCombatModeFinish(); //offset 0220
    virtual int User__GetIsHidden(); //offset 0224
    virtual int User__EquipItem(); //offset 0228
    virtual int User__UnequipItem(); //offset 022C
    virtual int User__UseItem(); //offset 0230
    virtual int CCreature__UseETCItem(); //offset 0234
    virtual int User__DropItem(); //offset 0238
    virtual int User__GetItem(); //offset 023C
    virtual int CCreature__DeleteAllItemsInInventory(); //offset 0240
    virtual int User__GetInventoryCount(); //offset 0244
    virtual int User__EnterWorld(); //offset 0248
    virtual int User__LeaveWorld(); //offset 024C
    virtual int ___func_0250(); //offset 0250
    virtual int MoveToLocation(); //offset 0254
    virtual int MoveToLocationInVehicle(); //offset 0258
    virtual int TeleportToLocation(); //offset 025C
    virtual int User_IsInPVPZone(); //offset 0260
    virtual int User_IsInUnknownZone(); //offset 0264
    virtual int User_IsInPeaceZone(); //offset 0268
    virtual int User__Die(); //offset 026C
    virtual int CCreature__StopAction(); //offset 0270
    virtual int User__AttackOutOfRange(); //offset 0274
    virtual int User__AttackInCoolTime(); //offset 0278
    virtual int User__AttackDeadTarget(); //offset 027C
    virtual int CCreature__SocialAction(); //offset 0280
    virtual void CCreature__SendMoveType(int nMoveType); //offset 0284
    virtual int ___func_0288(); //offset 0288
    virtual int MATH_Load_0_0_to_FPU(); //offset 028C
    virtual int CCreature__GotDamage(); //offset 0290
    virtual double GotDamageBy(CCreature_ *pAttacker, double dDamage, int nParam); //offset 0294
    virtual int CCreature__AttackedBy(); //offset 0298
    virtual int User__ChangeTalkTarget(); //offset 029C
    virtual int CCreature__Action(); //offset 02A0
    virtual int CCreature__SkillAction(); //offset 02A4
    virtual int User__ActionFailed(); //offset 02A8
    virtual int User__ChangeTarget(); //offset 02AC
    virtual int CCreature__SendStatusUpdate(); //offset 02B0
    virtual int mov_eax_1e(); //offset 02B4
	virtual double GetBonusINT(); //offset 02B8
    virtual double GetBonusDEX(); //offset 02BC
    virtual double GetBonusMEN(); //offset 02C0
	virtual double GetBonusCON(); //offset 02C4
	virtual double GetBonusSTR(); //offset 02C8
	virtual double GetBonusWIT(); //offset 02CC
	virtual int ___GetLevel(); //offset 02D0
	virtual double GetRegenHP(); //offset 02D4
	virtual double GetMaxHP(); //offset 02D8
	virtual double GetRegenMP(); //offset 02DC
	virtual double GetMaxMP(); //offset 02E0
	virtual double GetPAttack(); //offset 02E4
	virtual double GetPDefend(); //offset 02E8
	virtual double GetSome2EC(); //offset 02EC
	virtual double GetSome2F0(); //offset 02F0
	virtual double GetMaxWeight(); //offset 02F4
	virtual int GetMovePoseType(); //offset 02F8
	virtual int GetSome2FC(); //offset 02FC
	virtual void ResetLoc(FVector *pLoc); //offset 0300
	virtual int GetMeleeAttackRange(); //offset 0304
	virtual int GetAttackType(); //offset 0308
	virtual int GetSome30C(); //offset 030C
	virtual int CreateInitialItems(); //offset 0310
	virtual int SendNPCInfo(); //offset 0314
	virtual int ___func_0318(); //offset 0318
	virtual int UserHear(); //offset 031C
	virtual int SendUserInfo(); //offset 0320
	virtual int SendCharInfo(); //offset 0324
	virtual void SendHPInfo(); //offset 0328
	virtual void SendMPInfo(); //offset 032C
	virtual void SendAbnormalStatusInfo(); //offset 0330
	virtual int ___func_0334(); //offset 0334
	virtual int ___func_0338(); //offset 033C

	bool UseItemAsCreature(CCItem *pItem);
	CCItem* FindFirstItemByClassID(int nItemID);
	CCItem* FindNextItemByClassID(CCItem* pPrevItem);
	CCItem* GetEquippedWeapon();
	CItemInfo* GetEquippedWeaponInfo();
	int GetAdenaAmount();
	void RechargeAutoSS();
	bool IsAwaitingForReply();
	bool IsInBlockList(WCHAR *szName);
	CParty_ *GetParty();

	int GetLevel()
	{
		return Data->nLevel;
	}
	int GetClass()
	{
		return Data->m_nClass;
	}
	double GetCurrentHP()
	{
		return Data->fHP;
	}
	double GetCurrentMP()
	{
		return Data->fMP;
	}

	double GetCollisionRadius()
	{
		return Data->collision_radius;
	}

	double GetCollisionHeight()
	{
		return Data->collision_height;
	}

	double GetCurrentCP();
	double GetMaxCP();

	void SetCurrentCP(double dNewCP)
	{
		//Data->fCurrentCP = (float) dNewCP;
	}

	void AddCurrentCP(double dAddCP)
	{
		//Data->fCurrentCP += (float)dAddCP;
		//if (Data->fCurrentCP > (float)GetMaxCP())
		//{
		//	SetCurrentCP(GetMaxCP());
		//}
	}

	int GetCurrentWeight()
	{
		return nCurrentWeight;
	}
	int GetMountType()
	{
		return Data->nMountType;
	}
	int GetHeading()
	{
		return Data->m_Direction;
	}
	int GetObjectID()
	{
		return nObjectID;
	}
	WCHAR* GetCharName()
	{
		return Data->wszName;
	}
	int GetRace()
	{
		return Data->m_Race;
	}
	int GetGender()
	{
		return Data->m_nSex;
	}
	int GetExp()
	{
		return Data->m_nEXP;
	}
	int GetSTR()
	{
		return Data->nSTR;
	}
	int GetDEX()
	{
		return Data->nDEX;
	}
	int GetCON()
	{
		return Data->nCON;
	}
	int GetINT()
	{
		return Data->nINT;
	}
	int GetWIT()
	{
		return Data->nWIT;
	}
	int GetMEN()
	{
		return Data->nMEN;
	}

	int GetSP()
	{
		return Data->m_nSP;
	}

	double GetPAtkSpeed()
	{
		return Data->fAtkSpeed;
	}

	bool IsDwarf()
	{
		return GetClass()==4;
	}

	int GetMyStatus();

	int GetPrivateStoreType()
	{
		return Data->m_nPrivateStoreType;
	}

	int GetClanPrivs()
	{
		return 0; //for now
	}

	int GetRecomLeft()
	{
		return 0;
	}

	int GetRecomHave()
	{
		return 0;
	}

	int GetInventoryLimit()
	{
		return 100;
	}

	int GetSpecialEffect()
	{
		return 1;
	}

	int GetTeamEffect()
	{
		return 1;
	}

	int GetLargeClanCrestID()
	{
		return 0;
	}

	int GetHeroControl()
	{
		return 0;
	}

	int GetHeroAura()
	{
		return 0;
	}

	int GetColor()
	{
		return 0x80FF80;
	}

	bool AddItemToInventory(int nItemClassID,int nCount,bool bIsPick);
	void DieAsCreature();
	double New_GotDamageBy(CCreature_ *pAttacker, double dDamage, int nParam);

	void CheckAbnormalVisualEffect();

	CShortCut * GetUserShortCut()
	{
		return (CShortCut*) &___ShortCuts;
	}

};


/*


c4:
	 0030       int _dw0000[342];
	 0588       //CreatureSharedData* sharedData;
	 0590       int _dw0590[2];
	 0598       //LPCRITICAL_SECTION csCritSection;
	 05A0       //CInventory inventory;
	 05A8 		int _dw05A8[24];
	 0608       int setClassID;
	 060C       int _dw060C[35];
	 0698       bool isKilledByBuilderCmd;
	 0699       __int8 _dw0699[7];
	 06A0 		double base_p_def_diff_bonus;
	 06A8 		double base_m_def_diff_bonus;
	 06B0 		double base_hp_diff_bonus;
	 06B8 		double base_mp_diff_bonus;
	 06C0 		double base_spd_diff_bonus;
	 06C8 		double physicalAttackPer;			// default 1.0
	 06D0 		double physicalAttackDiff;
	 06D8 		double physicalDefencePer;			// default 1.0
	 06E0 		double physicalDefenceDiff;
	 06E8 		double magicalAttackPer;			// default 1.0
	 06F0 		double magicalAttackDiff;
	 06F8 		double magicalDefencePer;			// default 1.0
	 0700 		double magicalDefenceDiff;
	 0708 		double hpRegenPer;					// default 1.0
	 0710 		double hpRegenDiff;
	 0718 		double mpRegenPer;					// default 1.0
	 0720 		double mpRegenDiff;
	 0728 		double speedDiff;					// default 1.0
	 0730 		double speedPer;
	 0738 		double attackSpeedDiff;				// default 1.0
	 0740 		double magicSpeedTmpPer;			// default 1.0 - p_magic_speed
	 0748 		double magicSpeedTmpDiff;			// p_magic_speed
	 0750 		double accuracyDiff;				// p_2h_sword_bonus, p_2h_blunt_bonus, p_physical_armor_hit
	 0758 		double dodgeDiff;					// p_avoid, p_avoid_rate_by_hp1, p_avoid_rate_by_hp2, p_set_collected
	 0760 		double critRateTmpPer;				// default 1.0 - p_critical_rate, p_critical_rate_by_hp1, p_critical_rate_by_hp2
	 0768 		double critRateTmpDiff;				// p_critical_rate, p_critical_rate_by_hp1, p_critical_rate_by_hp2
	 0770 		double mult_coef_for_magcrit;		// default 1.0 - res = WIT* 0.5*mult_coef_for_magcrit + add_coef_for_magcrit
	 0778 		double add_coef_for_magcrit;
	 0780 		bool can_move;						// default true, 0 - p_block_move
	 0781 		bool can_act;						// default true, 0 - p_cub_block_act
	 0782 		bool can_control;					// default true, 0 - p_block_controll, user can't control own char
	 0783 		bool can_get_spell;					// default true, 0 - p_block_spell
	 0784 		bool can_get_physical_skill_dmg;	// default true, 0 - p_block_skill_physical
	 0785 		bool can_get_special_skill_dmg;		// default true, 0 - p_block_skill_special
	 0786 		bool preserve_abnormal_on_die;		// default false, 1 - p_preserve_abnormal
	 0787 		bool can_get_mp_dmg;				// default true, 0 - is in petrified state, look at p_block_getdamage
	 0788 		bool can_get_hp_dmg;				// default true, 0 - is in petrified state, look at p_block_getdamage
	 0789 		bool reduce_drop_penalty;			// default false, 1 - p_reduce_drop_penalty, charm of luck
	 078A 		bool under_dear;					// default false, 1 - p_fear
	 078B 		bool damage_shield;					// default false, 1 - p_damage_shield
	 078C 		bool vampiric_attack;				// default false, 1 - p_vampiric_attack
	 078D 		bool pump_attack;					// default false, 1 -- p_critical_rate_by_hp1, p_critical_rate_by_hp2, p_physical_attack_by_hp1, p_physical_attack_by_hp2, p_physical_defence_by_hp1, p_physical_defence_by_hp2, p_avoid_rate_by_hp1, p_avoid_rate_by_hp2, p_attack_speed_by_hp1, p_attack_speed_by_hp2
	 078E 		bool b78E_zero;						// default false, not used for skill-mod
	 078F 		bool b78F_zero;						// default false, not used for skill-mod
	 0790 		double damageShieldDiff;			// default 1.0
	 0798 		double vampiricAttackPer;			// default 1.0
	 07A0 		double physical_armor_hit;			// default 1.0, used in s_agile_movement
	 07A8 		double maxHpDiff;
	 07B0 		double maxHpPer;					// default 1.0
	 07B8 		double maxMpDiff;
	 07C0 		double maxMpPer;					// default 1.0
	 07C8 		double maxCpDiff;
	 07D0 		double maxCpPer;					// default 1.0
	 07D8 		double attackRangeDiff;
	 07E0 		double attackRangePer;				// default 1.0
	 07E8 		double critDmgTmpDiff;
	 07F0 		double critDmgTmpPer;				// default 1.0
	 07F8 		double phys_skill_reuse_delay_coef;		// default 1.0, p_reuse_delay
	 0800 		double mag_skill_reuse_delay_coef;		// default 1.0
	 0808 		double type2_skill_reuse_delay_coef;	// default 1.0
	 0810 		double reduce_cancel_diff;		// p_reduce_cancel
	 0818 		double reduce_cancel_coef;		// default 1.0
	 0820 		double atk_spd_by_weapon_coef;	// default 1.0, p_attack_speed_by_weapon
	 0828 		double atk_spd_by_weapon_diff;
	 0830 		double shield_def_rate_coef;	// default 1.0, p_shield_defence_rate
	 0838 		int henna_int_bonus;
	 083C 		int henna_str_bonus;
	 0840 		int henna_con_bonus;
	 0844 		int henna_men_bonus;
	 0848 		int henna_dex_bonus;
	 084C 		int henna_wit_bonus;
	 0850 		double hp_regen_by_move_mode_coef[4];	// default 1.0, CSkillEffect_p_hp_regen_by_move_mode
	 0870 		double hp_regen_by_move_mode_diff[4];
	 0890 		double mp_regen_by_move_mode_coef[4];	// default 1.0, CSkillEffect_p_mp_regen_by_move_mode
	 08B0 		double mp_regen_by_move_mode_diff[4];
	 08D0 		double avoid_by_move_mode_coef[4];		// CSkillEffect_p_avoid_by_move_mode
	 08F0 		double avoid_by_move_mode_diff[4];		// 0 .. 3
	 0910 		double safe_fall_height_coef;	// default 1.0
	 0918 		double safe_fall_height_diff;
	 0920 		double breath_coef;				// default 1.0, CSkillEffect_p_breath
	 0928 		double breath_diff;
	 0930 		double weight_limit_coef;		// default 1.0, CSkillEffect_p_weight_limit
	 0938 		int    weight_penalty;			// weight limit, CSkillEffect_p_weight_penalty
	 093C 		int _dw93c;
	 0940 		double trade_coef[6];			// default 1.0, CSkillEffect_p_trade
	 0970 		int    mana_charge;				// CSkillEffect_p_mana_charge
	 0974 		int	_dw974;
	 0978 		double heal_effect_coef;		// default 1.0, CSkillEffect_p_heal_effect
	 0980 		int transfer_damage_summon;		// CSkillEffect_p_transfer_damage_summon
	 0984 		int _dw984;
	 0988 		double area_damage_coef;		// default 1.0, CSkillEffect_p_area_damage
	 0990 		double area_damage_diff;
	 0998 		double hit_at_night_coef;		// default 1.0, CSkillEffect_p_hit_at_night__Pump
	 09A0 		double hit_at_night_diff;
	 09A8 		int avoid_agro;					// CSkillEffect_p_avoid_agro::Pump
	 09AC 		int _dw9AC;
	 09B0 		double fatal_blow_rate_coef;	// default 1.0, CSkillEffect_p_fatal_blow_rate::Pump
	 09B8 		double fatal_blow_rate_diff;
	 09C0 		double critical_rate_position_bonus_front_coef;	// default 1.0, CSkillEffect_p_critical_rate_position_bonus::Pump
	 09C8 		double critical_rate_position_bonus_front_diff;
	 09D0 		double critical_rate_position_bonus_side_coef;	// default 1.0
	 09D8			double critical_rate_position_bonus_side_diff;
	 09E0 		double critical_rate_position_bonus_back_coef;	// default 1.0
	 09E8 		double critical_rate_position_bonus_back_diff;
	 09F0 		double critical_damage_position_front_coef;		// default 1.0, CSkillEffect_p_critical_damage_position__Pump
	 09F8 		double critical_damage_position_front_Diff;
	 0A00 		double critical_damage_position_side_coef;		// default 1.0
	 0A08 		double critical_damage_position_side_diff;
	 0A10 		double critical_damage_position_back_coef;		// default 1.0
	 0A18 		double critical_damage_position_back_diff;
	 0A20 		double physical_shield_defence_coef;			// default 1.0, installed in p_physical_shield_defence
	 0A28 		double physical_shield_defence_diff;			// installed in p_physical_shield_defence
	 0A30 		double phys_skill_mp_cost_coef;	// default 1.0, installed in p_magic_mp_cost
	 0A38 		double phys_skill_mp_cost_diff; // installed in p_magic_mp_cost
	 0A40 		double mag_skill_mp_cost_coef;	// default 1.0, installed in p_magic_mp_cost
	 0A48 		double mag_skill_mp_cost_diff;	// installed in p_magic_mp_cost
	 0A50 		double type2_skill_mp_cost_coef;	// default 1.0, installed in p_magic_mp_cost
	 0A58 		double type2_skill_mp_cost_diff;	// installed in p_magic_mp_cos
	 0A60 		double pvp_physical_attack_dmg_bonus;			// default 1.0, installed in p_pvp_physical_attack_dmg_bonus
	 0A68 		double pvp_physical_skill_dmg_bonus;			// default 1.0, installed in p_pvp_physical_skill_dmg_bonus skill-effect  
	 0A70 		double pvp_magical_skill_dmg_bonus;			// default 1.0, installed in p_pvp_magical_skill_dmg_bonus skill-effect
	 0A78 		bool b_0A78;					// default false, 1 - p_physical_shield_defence_angle_all
	 0A79 		bool b_0A79;					// default false, 1 - p_physical_polarm_target_single
	 0A7A 		bool b_0A7A;					// default false, 1 - p_abnormal_rate_limit
	 0A7B 		bool bBlockBuff;				// default false, used in CCreature::InfectedSkillBy?; CSkillEffect_p_block_buff::Pump
	 0A7C 		bool bBlockDebug;				// default false, used in CCreature::InfectedSkillBy?; CSkillEffect_p_block_debuff::Pump
	 0A7D 		__int8 _dwA7D[0x3];
	 0A80 		int skill_critical;				// default 26??, CSkillEffect_p_skill_critical
	 0A84 		int _dwA84;
	 0A88 		double skill_critical_probability_coef;			// default 1.0
	 0A90 		double skill_critical_probability_diff;
	 0A98 		int nIsMagic0_resist;			// used in CSkillInfo::ActivateSkill?
	 0A9C 		int nIsMagic1_resist;			// used in CSkillInfo::ActivateSkill?
	 0AA0 		int nIsMagic2_resist;			// used in CSkillInfo::ActivateSkill?
	 0AA4 		int _dwAA4;
	 0AA8 		double dResistDispelByCategory_SlotBuff;		// default 1.0
	 0AB0 		double dResistDispelByCategory_SlotDebuff;		// default 1.0
	 0AB8 		double dResistAbnormalByCategory_SlotBuff;		// default 1.0
	 0AC0 		double dResistAbnormalByCategory_SlotDeBuff;	// default 1.0
	 0AC8 		int allowed_grade;
	 0ACC 		int enlarge_storage[7];  // CSkillEffect_p_enlarge_storage::Pump
	// 0 - inventory_normal, 1 - storage_private, 2 - ??, 3 - trade_sell, 4 - trade_buy
	// 5 - recipe_dwarven, 6 - recipe_common
	 0AE8 		int hit_number;			// CSkillEffect_p_hit_number 
	 0AEC 		//INT8 _dw0AEC[0x54];
	 0B40       //BYTE _b0B40;
	 0B41       bool bOnBattlefield;
	 0B42       bool PvPzone;
	 0B43 		//BYTE _unk0B43[4];
	 0B47 		bool PeaceZone;
	 0B48       //INT8 _dw0B48[0x64];
	 0BAC 		//INT32 chargesCount;
	 0BB0 		//INT8 _DW0BB0[0x3B];
	 0BEB 		bool _dwBEB;
	 0BEC 		//INT8 _dw0BEC[0xB8];
	 0CA4      // BYTE _b0CA4;
	 0CA5       bool isInCombat;
	 0CA6      // BYTE _unk0CA6[34];
	 0CC8       __int64 Target;
	 0CD0       __int64 TargetObjectId;
	 0CD8      // CController* Controller;
	 0CE0       int _dw0CDC[64];
	 0DE0      // VOID *pLock1;
	 0DE8       int _dw0DE8[22];
	 0E40      // BuffVector vBuff;
	 0E70       int _dw0E60[228];
	 1200 		bool bAtkAttribute[34];
	 1222 		//WORD _w1222;
	 1224 		int _dw1224;
	 1228 		double dDefAttribute[34];
	 1338 		int _dw1338[110];


	 */