#include "L2Server.h"
#include "ExUser.h"

//extern ExUser ExUserArray[EX_USER_ARRAY_SIZE];
int ol_timer_val = 100000;

void ol_unregister_pledge(int pledgeID)
{
	olimpiada.ol_pledge[pledgeID]=0;
}

//used also on wictory claimed by PC
void ol_stadium_timer_expired(int stadium)
{
	//find players
	//1. if both found on stadium, search alive one - he is wictorious, second is loser
	//1.1.1. is both alive, bot are losers :)
	//2. if 1 player on stadium and alive = winner, death = loser
	//3. no players on stadium - both losers;
	//4. if timer not passed yet - ignore PC victory claim
	//teleport them to Adena coliseum

}


void ol_teleport2stadium(DWORD *pUser1, DWORD *pUser2, int stadium)
{
	//we reserved stadium in "reserve" function
	user_teleport( (DWORD *)GetParameter(pUser1,User::USER_SOCKET), 
		olimpiada.ol_stadium_x1[stadium], olimpiada.ol_stadium_y1[stadium], olimpiada.ol_stadium_z1[stadium]);
	user_teleport( (DWORD *)GetParameter(pUser2,User::USER_SOCKET), 
		olimpiada.ol_stadium_x2[stadium], olimpiada.ol_stadium_y2[stadium], olimpiada.ol_stadium_z2[stadium]);
		

}

int ol_find_free_stadium(DWORD *pSocket)
{
		for (int i=0; i< olimpiada.ol_max_available_stadiums;i++)
		{
			if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::Find free stadium");
			if ((olimpiada.ol_stadium_time[i]+10000) <GetTickCount())
			{
				if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::expired stadium found");
				//fight timer expired, no one claimed victory
				ol_stadium_timer_expired(i); //run function here which deals with those in stadium!
				olimpiada.ol_stadium_time[i]=0;
				return i;
			}
			if (olimpiada.ol_stadium_time[i]==0)
			{
				if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::stadium found");
				return i;
			}

		}
	return -1;
}

//need reserver before teleportation
//if not reserved = no teleportation
int ol_reserve_stadium(DWORD *pUser1, DWORD *pUser2, int stadium)
{
	int reserved=-1;
			if (reserved == -1)
			{
				if (olimpiada.ol_stadium_time[stadium] == 0 && olimpiada.ol_stadium_x1[stadium] !=0)
				{

					olimpiada.ol_stadium_time[stadium]=GetTickCount();
					olimpiada.ol_stadium_PC1[stadium]=GetParameter(pUser1, User::OBJECT_ID);
					olimpiada.ol_stadium_PC2[stadium]=GetParameter(pUser2, User::OBJECT_ID);
					reserved=stadium;

				}
			}
		

		return reserved;

}


int ol_check_validPC(DWORD *pUser, DWORD *pSocket)
{
	//check for trade, participating in olympiad, epic or something

	return 1; //all ok
}

int ol_prepare_PC(DWORD *pUser, DWORD *pSocket)
{

	//expel from party
	//remove buffs
	//etc
	return 1; //all ok
}


DWORD *ol_search_PC2(DWORD *pSocket, DWORD *pUser1, int fights, int classType, int pledgeStart) //1 knight, 2 - support, 3-damage dealer
{
	//search second PC - conditions, no trade, not riding , etc.
	//1. find registered pledge
	//2 find registered PC in pledge which have defined fights count and equals defined classType 
   //3. define timer	
	DWORD *pUser = NULL;
	DWORD *pPledge = NULL;
	ExPledge *exPledge=NULL;
	for (int i=pledgeStart; i<EX_PLEDGE_ARRAY_SIZE; i++)
	{
			exPledge=GetExPledge(i);
		if ((olimpiada.ol_pledge[i] != 0) && ((exPledge->ol_timer + ol_timer_val) < GetTickCount()))
		{
			if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::Oly Clan found");
			//check available pledge participants
			
			pPledge = L2Server::GetPledgeByOID(olimpiada.ol_pledge[i]);
			if (pPledge != NULL)
			{
				if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::server Clan found");
				if ((exPledge->ol_dmgdealer!=0) &&(exPledge->ol_dmgdealer_fights == fights) && (classType == 3))
				{
					pUser=PledgeGetMemberByCHARId(NULL,pPledge, exPledge->ol_dmgdealer);
					if (pUser != NULL) {
						if (ol_check_validPC(pUser, pSocket) == 1) return pUser;
					}
				}
				if ((exPledge->ol_knight!=0) &&(exPledge->ol_knight_fights == fights) && (classType == 1))
				{
					if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::knight2 search");
					pUser=PledgeGetMemberByCHARId(NULL,pPledge, exPledge->ol_knight);
					if (pUser != NULL) {
						if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::knight2 found");
						if (ol_check_validPC(pUser, pSocket) == 1) return pUser;
					}
				}
				if ((exPledge->ol_support!=0) &&(exPledge->ol_support_fights == fights) && (classType == 2))
				{
					pUser=PledgeGetMemberByCHARId(NULL,pPledge, exPledge->ol_support);
					if (pUser != NULL) {
						if (ol_check_validPC(pUser, pSocket) == 1) return pUser;
					}
				}
			} else {
				//unregister null pledge
				if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::null Clan found");
				//ol_unregister_pledge(i);
			}
	

		}
	}

	if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::knight2 search unsuccessful");
	return NULL;
}



int ol_search_combat(DWORD *pSocket,int fights)
{
	//search first PC - conditions, no trade, not riding , etc.
	//1 find registered pledge in olympiad
	//2 find registered PC in pledge which have defined fights count
	//3. if timer not passed by already, search another PC1
	// 4. define timer, 
	int freestadium = ol_find_free_stadium(pSocket);
	if (freestadium == -1) {
		
		if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::No free stadium");
		return 100; //no free stadium
	}


	DWORD *pUser = NULL;
	DWORD *pUser2 = NULL;
	DWORD *pPledge = NULL;
	ExPledge *exPledge=NULL;
	for (int i=0; i<EX_PLEDGE_ARRAY_SIZE; i++)
	{
		exPledge=GetExPledge(i);
		if (i==0) {
			if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL:: start search 0");
		}
		if ((olimpiada.ol_pledge[i] != 0) && ((exPledge->ol_timer + ol_timer_val) < GetTickCount()))
		{
			if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::Oly Clan found");

			//check available pledge participants
			pPledge = L2Server::GetPledgeByOID(olimpiada.ol_pledge[i]);
			if (pPledge != NULL)
			{
				if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::Server Clan found");

				//test  test test TODO exPledge->ol_timer = GetTickCount();
				if ((exPledge->ol_dmgdealer!=0) &&(exPledge->ol_dmgdealer_fights == fights))
				{
					pUser=PledgeGetMemberByCHARId(NULL,pPledge, exPledge->ol_dmgdealer);
					if (pUser != NULL) {
						//search user2
						if (ol_check_validPC(pUser, pSocket) == 1) {
						pUser2=ol_search_PC2(pSocket,pUser, fights, 3, (i+1));
						if (pUser2==NULL) pUser2=ol_search_PC2(pSocket,pUser, (fights+1), 3, (i+1));
						//if still null, no more fighters to fight
						if (pUser2==NULL) {
							//ol_unregister_pledge(i);
							//not found fighter for pUser, must unregister this pUser from olympiad //TODO
						} else {
							if (ol_prepare_PC(pUser, pSocket) == 1) { 
								if (ol_prepare_PC(pUser2, pSocket) == 1) {
									if (ol_reserve_stadium(pUser, pUser2, freestadium) == -1) return 101; //failed to reserve
									ol_teleport2stadium(pUser, pUser2, freestadium);
									return 1; //done
								}
							}
						}
						
						}
					}
				}
				if ((exPledge->ol_knight!=0) &&(exPledge->ol_knight_fights == fights))
				{
					if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::knight search start");

					pUser=PledgeGetMemberByCHARId(NULL,pPledge, exPledge->ol_knight);
					if (pUser != NULL) {
						if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::knight found");
						if (ol_check_validPC(pUser, pSocket) == 1) {
						//search user2
						pUser2=ol_search_PC2(pSocket,pUser, fights, 1, (i+1));
						if (pUser2==NULL) {
							if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::knight2 not found with defined fights");

							pUser2=ol_search_PC2(pSocket,pUser, (fights+1), 1, (i+1));
						}
						//if still null, no more fighters to fight
						if (pUser2==NULL) {
							//ol_unregister_pledge(i);
							//not found fighter for pUser, must unregister this pUser from olympiad //TODO
							if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::knight2 not found with defined fights+1");
						} else {
							if (ol_prepare_PC(pUser, pSocket) == 1) { 
								if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::knight1 prepared");
								if (ol_prepare_PC(pUser2, pSocket) == 1) {
									if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::knight2 prepared");
									if (ol_reserve_stadium(pUser, pUser2, freestadium) == -1) {
										if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::not reserved stadium");
										return 101; //failed to reserve
									}
									ol_teleport2stadium(pUser, pUser2, freestadium);
									if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::knights teleported");
									return 1; //done
								}
							}
						}
						}

					}
				}
				if ((exPledge->ol_support!=0) &&(exPledge->ol_support_fights == fights))
				{
					pUser=PledgeGetMemberByCHARId(NULL,pPledge, exPledge->ol_support);
					if (pUser != NULL) {
						if (ol_check_validPC(pUser, pSocket) == 1) {
						//search user2
						pUser2=ol_search_PC2(pSocket,pUser, fights, 2, (i+1));
						if (pUser2==NULL) pUser2=ol_search_PC2(pSocket,pUser, (fights+1), 2, (i+1));
						//if still null, no more fighters to fight
						if (pUser2==NULL) {
							//ol_unregister_pledge(i);
							//not found fighter for pUser, must unregister this pUser from olympiad //TODO
						} else {
							if (ol_prepare_PC(pUser, pSocket) == 1) { 
								if (ol_prepare_PC(pUser2, pSocket) == 1) {
									if (ol_reserve_stadium(pUser, pUser2, freestadium) == -1) return 101; //failed to reserve
									ol_teleport2stadium(pUser, pUser2, freestadium);
									return 1; //done
								}
							}
						}
						}

					}
				}
			} else {
				//unregister null pledge
				if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::clan is NULL");
				//ol_unregister_pledge(i);
			}
	
		}
		
	}
	if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL::search unsuccess");
	return 0; //unsuccess

}







//register stadium coordinates
int ol_register_stadium(int x1, int y1, int z1, int x2, int y2, int z2)
{
	int stadium=-1;
	for (int i=0; i< olimpiada.ol_max_available_stadiums;i++)
	{
		if (stadium == -1)
		{
			if (olimpiada.ol_stadium_x1[i] == x1)
			{
			//already registered
				stadium=i;
			} else if (olimpiada.ol_stadium_x1[i] == 0) {
				stadium=i;
				olimpiada.ol_stadium_x1[i]=x1;
				olimpiada.ol_stadium_y1[i]=y1;
				olimpiada.ol_stadium_z1[i]=z1;
				olimpiada.ol_stadium_x2[i]=x2;
				olimpiada.ol_stadium_y2[i]=y2;
				olimpiada.ol_stadium_z2[i]=z2;

			}

		}
	}

	return stadium;
}






					   

void ol_clear_all()
{
	olimpiada.ol_id=0;
	for (int i=0; i<EX_PLEDGE_ARRAY_SIZE; i++)
	{
		olimpiada.ol_pledge[i]=0;
		
	}
}

void ol_register_ol(int olID, int maxstadiums)
{
	olimpiada.ol_id=olID;
	olimpiada.ol_max_available_stadiums=maxstadiums;
}

void ol_register_pledge(int pledgeID, int pledgeOID)
{
	olimpiada.ol_pledge[pledgeID]=pledgeOID;
}

void ol_clear(int pledgeID)
{
	ExPledge *exPledge=GetExPledge(pledgeID);

	exPledge->ol_1=0;
	exPledge->ol_2=0;
	exPledge->ol_3=0;
	exPledge->ol_3x3_wins=0;
	exPledge->ol_3x3_fights=0;

	exPledge->ol_dmgdealer=0;
	exPledge->ol_dmgdealer_wins=0;
	exPledge->ol_dmgdealer_fights=0;

	exPledge->ol_knight=0;
	exPledge->ol_knight_wins=0;
	exPledge->ol_knight_fights=0;

	exPledge->ol_support=0;
	exPledge->ol_support_wins=0;
	exPledge->ol_support_fights=0;


}

//moved to ExUser.cpp
/*
int ol_exUserTransfer(DWORD *pUser, DWORD *pSocket)
{




		ExUser * tempExUser=GetExUser( pUser );
		ExUser * tempExUserOLD=NULL;

		DWORD db_charID=tempExUser->CHAR_ID;
		if (db_charID == 0) {
			if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL:: char_id = 0");
			return 0; //already all good
		}


		if (tempExUser->ol_charID == db_charID) {
			if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT2, OP_SYS_MSG,614, 2 , 0, L"TEST-OL:: already good. char_id =",1,db_charID);
			return 0; //already all good
		}


		DWORD NpcIndex = GetParameter(pUser, NPC_INDEX);

		
		for (int i=0; i<EX_USER_ARRAY_SIZE; i++)
		{
			tempExUserOLD=GetExUserById(i);

			if (tempExUserOLD != NULL) {
			if ((tempExUserOLD->ol_charID == db_charID) && (NpcIndex != i))
			{

				tempExUser->ol_charID=tempExUserOLD->ol_charID;
				tempExUser->ol_charOID=tempExUserOLD->ol_charOID;
				tempExUser->ol_id=tempExUserOLD->ol_id;
				tempExUser->ol_fights =tempExUserOLD->ol_fights;
				tempExUser->ol_wins =tempExUserOLD->ol_wins;
				tempExUser->ol_timer =tempExUserOLD->ol_timer;
				tempExUser->ol_3x3_id =tempExUserOLD->ol_3x3_id;
				tempExUser->ol_pledgeOID=tempExUserOLD->ol_pledgeOID;
				tempExUser->ol_competition_type=tempExUserOLD->ol_competition_type;		

				tempExUserOLD->ol_charID=0;
				tempExUserOLD->ol_charOID=0;
				tempExUserOLD->ol_id=0;
				tempExUserOLD->ol_fights =0;
				tempExUserOLD->ol_wins =0;
				tempExUserOLD->ol_timer =0;
				tempExUserOLD->ol_3x3_id =0;
				tempExUserOLD->ol_pledgeOID=0;
				tempExUserOLD->ol_competition_type=0;


				//if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"OL:: previous info transfer done");
				if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT2, OP_SYS_MSG,614, 2 , 0, L"OL:: previous info transfer done. oldID=",1,i);
				

				return 0;


			}
			}
		}
return 1;

}
*/

int ol_registerExUser(DWORD *pSocket,DWORD *pUser, DWORD pledgeOID, int ol_competition_type)
{
		ExUser * tempExUser=GetExUser( pUser );
		if ((tempExUser->ol_id == olimpiada.ol_id) && (tempExUser->ol_charID == GetParameter(pUser, User::CHAR_ID))) return 0; //already registered

		//check for relogin
		//if (ol_exUserTransfer(pUser, pSocket) == 0) return 0; //make this check in other place... for example exUser creation


/*
//OLYMPIAD SECTION
BYTE ol_competition_type; //1 knight, 2- support, 3 damage dealer
DWORD ol_charID; //this id will help to restore olypiad information after relogin
DWORD ol_charOID; //this is object id which is used in CCreature::GetCreature
DWORD ol_id; //olympiad id
DWORD ol_fights;
DWORD ol_wins;
DWORD ol_timer;
DWORD ol_3x3_id; //party ID?
DWORD ol_pledgeOID; //registered in pledge competition, 0 - individual registration
*/

	tempExUser->ol_charID=GetParameter(pUser, User::CHAR_ID);
	tempExUser->ol_charOID=GetParameter(pUser, User::OBJECT_ID);
	tempExUser->ol_id=olimpiada.ol_id;
	tempExUser->ol_fights =0;
	tempExUser->ol_wins =0;
	tempExUser->ol_timer =0;
	tempExUser->ol_3x3_id =0;
	tempExUser->ol_pledgeOID=pledgeOID;
	tempExUser->ol_competition_type=ol_competition_type;

	return 1;

}

void ol_UNregisterExUser(DWORD *pUser)
{
		ExUser * tempExUser=GetExUser( pUser );

	tempExUser->ol_charID=0;
	tempExUser->ol_charOID=0;
	tempExUser->ol_id=0;
	tempExUser->ol_fights =0;
	tempExUser->ol_wins =0;
	tempExUser->ol_timer =0;
	tempExUser->ol_3x3_id =0;
	tempExUser->ol_pledgeOID=0;
	tempExUser->ol_competition_type=0;
}

void ol_testExUser(DWORD *pUser, DWORD *pSocket)
{
		ExUser * tempExUser=GetExUser( pUser );

	if (tempExUser->ol_charID ==0)
		if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL:: ol char id = 0");

	if (tempExUser->ol_charID ==tempExUser->CHAR_ID)
		if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL:: ol char id = ex user char id");

	if (tempExUser->ol_charID ==GetParameter(pUser, User::CHAR_ID))
		if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL:: ol char id = current user char id");

//	DWORD *pUser2=CCreature::GetCreature(tempExUser->CHAR_OBJECTID);
//	if (pUser2 != NULL)
//		if (pSocket != NULL) CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"TEST-OL:: object id ok");


}



void ol_npcmessage_handler(DWORD *pSocket, DWORD *pUser,PTCharBaseData CSharedDat, int msgid, int olid)
{
	if (olid == 0 && msgid < 10005)
	{
		CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"OL::No competition now");
		return;
	}

	int pledgeID=CSharedDat->nPledgeId;
	DWORD pledgeOID=GetParameter(pUser,User::PLEDGE_OID); //0x1AE0

	ExPledge *exPledge = NULL;
	if (pledgeID !=0 ) 
	{
		exPledge=GetExPledge(pledgeID);
		if ((exPledge->ol_id != olid) && msgid < 10005 ) {
			ol_clear(pledgeID);
			ol_register_pledge(pledgeID,pledgeOID);
			exPledge->ol_id = olid;
		}

	}

	
	

	wchar_t *undefined=L"OL::Not registered";
	wchar_t *notonline=L"OL::Not online";
	wchar_t *registered=L"OL::Successfuly registered";
	wchar_t *someonereg=L"OL::Someone already registered";
	wchar_t *alreadyreg=L"OL::Already registered";
	DWORD *pMember=NULL;
	PTCharBaseData CSharedDatM=NULL;// (PTCharBaseData)GetSharedData(pUser);


	switch (msgid) 
	{
		//register as knight
		case 10001:
			if (exPledge->ol_knight != 0)
			{
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, someonereg);
			} else {
				if (ol_registerExUser(pSocket,pUser, pledgeOID, 1) ==1) {
					exPledge->ol_knight = GetParameter(pUser, User::CHAR_ID); 
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, registered);
				} else {
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, alreadyreg);
				}
			}
			break;
		//register as support
		case 10002:
			if (exPledge->ol_support != 0)
			{
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, someonereg);
			} else {
				if (ol_registerExUser(pSocket,pUser, pledgeOID, 2) ==1) {
					exPledge->ol_support = GetParameter(pUser, User::CHAR_ID); 
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, registered);
				} else { 
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, alreadyreg);
				}
			}
			break;
		//register as damage dealer
		case 10003:
			if (exPledge->ol_dmgdealer != 0)
			{
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, someonereg);
			} else {
				if (ol_registerExUser(pSocket,pUser, pledgeOID, 3) == 1) {
					exPledge->ol_dmgdealer = GetParameter(pUser, User::CHAR_ID); 
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, registered);
				} else {
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, alreadyreg);
				}
			}
			break;
		//register 3x3
		case 10004:
			if (exPledge->ol_1 == 0) {
				exPledge->ol_1 = GetParameter(pUser, User::CHAR_ID); 
			} else if (exPledge->ol_2 == 0) {
				exPledge->ol_2 = GetParameter(pUser, User::CHAR_ID); 
			} else if (exPledge->ol_3 == 0) {
				exPledge->ol_3 = GetParameter(pUser, User::CHAR_ID); 
			} else {
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, someonereg);
				return;
			}
			CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, registered);
			break;
		//unregister
		case 10005:
			ol_UNregisterExUser(pUser);

			if (pledgeOID != 0) 
			{
			if (exPledge->ol_knight == GetParameter(pUser, User::CHAR_ID))
			{
				exPledge->ol_knight = 0;
			}
			if (exPledge->ol_support == GetParameter(pUser, User::CHAR_ID))
			{
				exPledge->ol_support = 0;
			}
			if (exPledge->ol_dmgdealer == GetParameter(pUser, User::CHAR_ID))
			{
				exPledge->ol_dmgdealer = 0;
			}
			if (exPledge->ol_1 == GetParameter(pUser, User::CHAR_ID))
			{
				exPledge->ol_1 = 0;
			}
			if (exPledge->ol_2 == GetParameter(pUser, User::CHAR_ID))
			{
				exPledge->ol_2 = 0;
			}
			if (exPledge->ol_3 == GetParameter(pUser, User::CHAR_ID))
			{
				exPledge->ol_3 = 0;
			}
			}
			CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"OL::unregistered");
			break;
		//show registered members
		case 10006:
			CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"OL::List--------");
			if (exPledge->ol_knight == 0)
			{
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, undefined);
			} else {
				pMember=PledgeGetMemberByCHARId(pUser,NULL,exPledge->ol_knight);
				if (pMember != NULL)
				{
					CSharedDatM=(PTCharBaseData)GetSharedData(pMember);
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, CSharedDatM->wszName);
				} else {
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, notonline);
				}
			}

			if (exPledge->ol_support == 0)
			{
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, undefined);
			} else {
				pMember=PledgeGetMemberByCHARId(pUser,NULL,exPledge->ol_support);
				if (pMember != NULL)
				{
					CSharedDatM=(PTCharBaseData)GetSharedData(pMember);
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, CSharedDatM->wszName);
				} else {
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, notonline);
				}
			}

			if (exPledge->ol_dmgdealer == 0)
			{
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, undefined);
			} else {
				pMember=PledgeGetMemberByCHARId(pUser,NULL,exPledge->ol_dmgdealer);
				if (pMember != NULL)
				{
					CSharedDatM=(PTCharBaseData)GetSharedData(pMember);
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, CSharedDatM->wszName);
				} else {
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, notonline);
				}
			}

			if (exPledge->ol_1 == 0)
			{
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, undefined);
			} else {
				pMember=PledgeGetMemberByCHARId(pUser,NULL,exPledge->ol_1);
				if (pMember != NULL)
				{
					CSharedDatM=(PTCharBaseData)GetSharedData(pMember);
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, CSharedDatM->wszName);
				} else {
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, notonline);
				}
			}

			if (exPledge->ol_2 == 0)
			{
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, undefined);
			} else {
				pMember=PledgeGetMemberByCHARId(pUser,NULL,exPledge->ol_2);
				if (pMember != NULL)
				{
					CSharedDatM=(PTCharBaseData)GetSharedData(pMember);
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, CSharedDatM->wszName);
				} else {
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, notonline);
				}
			}

			if (exPledge->ol_3 == 0)
			{
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, undefined);
			} else {
				pMember=PledgeGetMemberByCHARId(pUser,NULL,exPledge->ol_3);
				if (pMember != NULL)
				{
					CSharedDatM=(PTCharBaseData)GetSharedData(pMember);
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, CSharedDatM->wszName);
				} else {
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, notonline);
				}
			}
			CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, L"OL::------------");

			break;

			//register individual to general fights
			case 10007:
				if(ol_registerExUser(pSocket,pUser, 0, 5) == 1) { //5-general individual type
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, registered);
				} else {
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, OP_SYS_MSG,614, 1 , 0, alreadyreg);
				}
			break;

	}





}

