#ifndef _PacketReader_h_
#define _PacketReader_h_

#include "WritterPack.h"



class PacketReader
{
public:

	

	PacketReader(u8 *packet);//, u32 size);
	~PacketReader();

	u8 ReadC()
	{
		u8 ret =0;
try { _set_se_translator( buf_trans_func );
		ret = *(u8*)(buffer + (pos));
		pos++;
		} catch (...) {
			//ignore this error
		}

		return ret;
	}

	u32 ReadD()
	{
		u32 ret=0;
try { _set_se_translator( buf_trans_func );
		ret = *(u32*)(buffer + (pos));
		pos += 4;
		} catch (...) {
			//ignore this error
		}

		return ret;
	}

	u16 ReadH()
	{
		u16 ret=0;
try { _set_se_translator( buf_trans_func );
		ret = *(u16*)(buffer + (pos));
		pos += 2;
		} catch (...) {
			//ignore this error
		}

		return ret;
	}

	WCHAR *ReadS()
	{
		WCHAR *ret = L"";

try { _set_se_translator( buf_trans_func );
		ret = (WCHAR*)(buffer + (pos));
		pos += (lstrlenW((LPCWSTR)ret) + 1) * 2;
		} catch (...) {
			//ignore this error
		}


		return ret;
	}

	d64 ReadF()
	{
		d64 ret=0;
try { _set_se_translator( buf_trans_func );
		ret = *(d64*)(buffer + (pos));
		pos += 8;
		} catch (...) {
			//ignore this error
		}

		return ret;
	}

	u64 ReadQ()
	{

		u64 ret=0;
try { _set_se_translator( buf_trans_func );
		ret = *(u64*)(buffer + (pos));
		pos += 8;
		} catch (...) {
			//ignore this error
		}


		return ret;
	}


	u8 PeekC(u32 position)
	{
		u8 ret=0;
try { _set_se_translator( buf_trans_func );
		ret = *(u8*)(buffer + (position));
		} catch (...) {
			//ignore this error
		}

		return ret;
	}

	u32 PeekD(u32 position)
	{
		u32 ret =0;
try { _set_se_translator( buf_trans_func );
		ret = *(u32*)(buffer + (position));
		} catch (...) {
			//ignore this error
		}


		return ret;
	}

	u16 PeekH(u32 position)
	{

		u16 ret=0;
try { _set_se_translator( buf_trans_func );
		u16 ret = *(u16*)(buffer + (position));
		} catch (...) {
			//ignore this error
		}

		return ret;
	}

	WCHAR *PeekS(u32 position)
	{
		WCHAR *ret=L"";

try { _set_se_translator( buf_trans_func );
		ret = (WCHAR*)(buffer + (position));
		} catch (...) {
			//ignore this error
		}


		return ret;
	}

	d64 PeekF(u32 position)
	{
		d64 ret=0;
try { _set_se_translator( buf_trans_func );
		ret = *(d64*)(buffer + (position));
		} catch (...) {
			//ignore this error
		}

		return ret;
	}

	u64 PeekQ(u32 position)
	{

		u64 ret=0;
try { _set_se_translator( buf_trans_func );
		ret = *(u64*)(buffer + (position));
		} catch (...) {
			//ignore this error
		}

		return ret;
	}

	u32 pos;
	u8 *buffer;
};

#endif