#ifndef __CACHED_SENDPACKET_H__
#define __CACHED_SENDPACKET_H__

#include "BasePacket.h"

//#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>

class SendPacketCached : public BasePacket {
public:
	SendPacketCached();
	virtual ~SendPacketCached();

	void Write8( const unsigned char Data );
	void Write32( const unsigned int Data );
	void WriteFloat( const float Data );
	void WriteStr( const char *Data );
	void WriteStrUnicode( const char *Data );
	void Finish();
private:
	void Resize( unsigned short NewLen );
};

#endif