#ifndef __TCPBASESOCKET_H__
#define __TCPBASESOCKET_H__

#include <winsock2.h>
//#define WIN32_LEAN_AND_MEAN
#include <windows.h>

class TCPBaseSocket
{
public:
	TCPBaseSocket();
	TCPBaseSocket(SOCKET &Socket, SOCKADDR_IN &AddrIn);
	virtual ~TCPBaseSocket();

	static bool Init(WORD wRequestedWinsockVersion);
	static void DeInit();
	static WSADATA GetWsaData();

	void Close();
	void SetSocket(SOCKET Socket);
	bool IsOk();
	SOCKET GetSocket();
	SOCKADDR_IN GetAddrIn();
protected:
	SOCKET m_Socket;
	SOCKADDR_IN m_AddrIn;
private:
	static WSADATA m_WsaData;
};

#endif