//----------------------------
//CT3 Awakening CLIENT Opcodes



static const BYTE clientToServAwake[210] = 
	{
	/*0*/	0x09,		//Logout
	/*1*/	0x0A,		//Attack
	/*2*/	0x02,		//Say 
	/*3*/	0x4d,		//RequestStartPledgeWar
	/*4*/	0x4e,		//RequestReplyStartPledgeWar
	/*5*/	0x4f,		//RequestStopPledgeWar
	/*6*/	0x50,		//RequestReplyStopPledgeWar
	/*7*/	0x51,		//RequestSurrenderPledgeWar
	/*8*/	0x52,		//RequestReplySurrenderPledgeWar
	/*9*/	0x53,		//RequestSetPledgeCrest
	/*a*/	0x54,		//TestPledgeCrest			(gues)
	/*b*/	0x55,		//RequestGiveNickName
	/*c*/	0x0b,		//CharacterCreate 
	/*d*/	0x0c,		//CharacterDelete 
	/*e*/	0x00,		//SendProtocolVersion
	/*f*/	0x01, 		//MoveBackwardToLocation
	/*10*/	0x02, 		//Say 
	/*11*/	0x03,		//EnterWorld
	/*12*/	0x0d,		//CharacterSelect
	/*13*/	0x0e,		//NewCharacter
	/*14*/	0x0f,		//ItemList
	/*15*/	0x10,		//Request EquipItem
	/*16*/	0x11,		//RequestUnEquipItem
	/*17*/	0x12,		//RequestDropItem 
	/*18*/	0x13, 		//RequestDropItemFromPet 
	/*19*/	0x14,		//UseItem
	/*1a*/	0x15,		//TradeRequest
	/*1b*/	0x16,		//AddTradeItem 
	/*1c*/	0x17,		//TradeDone
	/*1d*/	0xFF, //0x18,		//??
	/*1e*/	0xFF, //0x19,		//??
	/*1f*/	0x04,		//Action
	/*20*/	0xFF, //0x05,		//??
	/*21*/	0xFF, //0x06,		//??
	/*22*/	0x20,		//RequestLinkHtml
	/*23*/	0x21,		//RequestBypassToServer
	/*24*/	0x22,		//RequestBBSwrite
	/*25*/	0x23,		//RequestCreatePledge
	/*26*/	0x24,		//RequestJoinPledge
	/*27*/	0x25,		//RequestAnswerJoinPledge
	/*28*/	0x26,		//RequestWithDrawalPledge
	/*29*/	0x27,		//RequestOustPledgeMember
	/*2a*/	0x28,		//RequestDismissPledge 
	/*2b*/	0x08,		//RequestAuthLogin
	/*2c*/	0x8c,		//RequestGetItemFromPet
	/*2d*/	0xFF, //0x8d,		//RequestDropItemFromPet    
	/*2e*/	0x8e,		//RequestAllyInfo
	/*2f*/	0x72,		//RequestCrystallizeItem
	/*30*/	0x73,		//RequestPrivateStoreManageSell
	/*31*/	0x74,		//SetPrivateStoreListSell
	/*32*/	0x75,		//RequestPrivateStoreManageCancel
	/*33*/	0x1a,		//RequestTeleport
	/*34*/	0x1b,		//SocialAction
	/*35*/	0x1c,		//ChangeMoveType   not used any more RequestActionUse instead
	/*36*/	0x1d,		//ChangeStopType   not used any more RequestActionUse instead
	/*37*/	0x1e,		//RequestSellItem
	/*38*/	0x2e,		//RequestMagicSkillList
	/*39*/	0x2f,		//RequestMagicSkillUse
	/*3a*/	0x30,		//Appearing
	/*3b*/	0x31,		//SendWareHouseDepositList
	/*3c*/	0x32,		//SendWareHouseWithDrawList
	/*3d*/	0x33,		//RequestShortCutReg
	/*3e*/	0x34,		//RequestShortCutUse
	/*3f*/	0x35,		//RequestShortCutDel
	/*40*/	0x1f,		//RequestBuyItem
	/*41*/	0x28,		//RequestDismissPledge
	/*42*/	0x29,		//RequestJoinParty
	/*43*/	0x2a,		//RequestAnswerJoinParty
	/*44*/	0x2b,		//RequestWithDrawalParty
	/*45*/	0x2c,		//RequestOustPartyMember
	/*46*/	0x2d,		//RequestDismissParty
	/*47*/	0xFF, //0x36,		//CannotMoveAnymore			(gone)
	/*48*/	0x37,		//RequestTargetCancel
	/*49*/	0x38,		//Say2
	/*4a*/	0xFF, //0x39,		//???
	/*4b*/	0xFF, //0x3a,		//SetPartyMemberListOpen (gone)
	/*4c*/	0xFF, //0x3b,		//SetPartyMemberListClose (gone)
	/*4d*/	0x3c,		//RequestPledgeMemberList
	/*4e*/	0xFF, ////0x3d,		//ShowPledgeMemberListClose	(gone)
	/*4f*/	0x3e,		//RequestMagicList			(gone)
	/*50*/	0x3f,		//RequestSkillList
	/*51*/	0xFF, //0x40, ???		
	/*52*/	0x41,		//MoveWithDelta
	/*53*/	0x42,		//GetOnVehicle
	/*54*/	0x43,		//GetOffVehicle
	/*55*/	0x44,		//AnswerTradeRequest
	/*56*/	0x45,		//RequestActionUse
	/*57*/	0x46,		//RequestRestart
	/*58*/	0x47,		//RequestSiegeInfo
	/*59*/	0x48,		//ValidatePosition
	/*5a*/	0x49,		//RequestSEKCustom
	/*5b*/	0x4a,		//StartRotating
	/*5c*/	0x4b,		//FinishRotating
	/*5d*/	0xFF, //0x56,	???
	/*5e*/	0x57,		//RequestShowboard
	/*5f*/	0x58,		//RequestEnchantItem
	/*60*/	0x59,		//RequestDestroyItem
	/*61*/	0xFF, //0x5A ???
	/*62*/	0x63,		//RequestQuestList
	/*63*/	0x64, 		//RequestQuestDestroy
	/*64*/	0xFF, //0x65,		//RequestQuestDestroy Old
	/*65*/	0x66,		//RequestPledgeInfo
	/*66*/	0x67,		//RequestPledgeExtendedInfo		
	/*67*/	0x68,		//RequestPledgeCrest	
	/*68*/	0x69,		//RequestSurrenderPersonally			
	/*69*/	0x6A,		//Ride	
	/*6a ?????*/	0x6A, 
	/*6b*/	0xcc,		//RequestSendL2FriendSay
	/*6c*/	0xcd,		//RequestOpenMINIMAP
	/*6d*/	0xce,		//RequestSendMSNChatLog.
	/*6e*/	0xcf,		//RequestReload 
	/*6f*/	0xbc,		//RequestHennaEquip
	/*70*/	0xbd,		//HennaUnequipList			
	/*71*/	0xbe,		//HennaUnequipInfo			
	/*72*/	0xbf,		//HennaUnequip
	/*73*/	0x6b,		//RequestAquireSkillInfo
	/*74*/	0x5b,		//SendBypassBuildCmd
	/*75 FF*/	0x5c,		//MoveToLocationInVehicle
	/*76 FF*/	0x5d,		//CannotMoveAnymoreInVehicle
	/*77*/	0x5e,		//RequestFriendInvite
	/*78*/	0x5f,		//RequestFriendAddReply
	/*79*/	0x60,		//RequestFriendList
	/*7a*/	0x61,		//RequestFriendDel
	/*7b*/	0x62,		//CharacterRestore
	/*7c*/	0x6c,		//RequestAquireSkill
	/*7d*/	0x6d,		//RequestRestartPoint
	/*7e*/	0x6e,		//RequestGMCommand
	/*7f*/	0x6f,		//RequestPartyMatchConfig
	/*80*/	0x70,		//RequestPartyMatchList
	/*81*/	0x71,		//RequestPartyMatchDetail
	/*82*/	0x78,		//RequestPrivateStoreList 
	/*83*/	0x79,		//SendPrivateStoreBuyBuyList
	/*84*/	0x7a,		//ReviveReply
	/*85*/	0x7b,		//RequestTutorialLinkHtml
	/*86*/	0x7c,		//RequestTutorialPassCmdToServer
	/*87*/	0x7d,		//RequestTutorialQuestionMark
	/*88*/	0x7e,		//RequestTutorialClientEvent
	/*89*/	0x7f,		//RequestPetition
	/*8a*/	0x80,		//RequestPetitionCancel
	/*8b*/	0x81,		//RequestGMList
	/*8c*/	0x82,		//RequestJoinAlly
	/*8d*/	0x83,		//RequestAnswerJoinAlly
	/*8e*/	0x84,		//RequestWithdrawAlly
	/*8f*/	0x85,		//RequestOustAlly
	/*90*/	0x86,		//RequestDismissAlly
	/*91*/	0x87,		//RequestSetAllyCrest
	/*92*/	0x88,		//RequestAllyCrest
	/*93*/	0x89,		//RequestChangePetName
	/*94*/	0x8a,		//RequestPetUseItem
	/*95*/	0x8b,		//RequestGiveItemToPet
	/*96*/	0x76,		//RequestPrivateStoreQuitSell
	/*97*/	0x77,		//SetPrivateStoreMsg (sell i gues)
	/*98*/	0x8f,		//RequestPetGetItem
	/*99*/	0x90,		//RequestPrivateStoreList[Manage]  (gues)
	/*9a*/	0x91,		//SetPrivateStoreListBuy
	/*9b*/	0x92,		//RequestPrivateStoreBuyManageCancel
	/*9c*/	0x93,		//RequestPrivateStoreBuyQuit
	/*9d*/	0x94,		//SetPrivateStoreBuyMsg
	/*9e*/	0x95,		//RequestPrivateStoreBuyList (gues)
	/*9f*/	0x96,		//RequestPrivateStoreSell
	/*a0*/	0x97,		//SendTimeCheckPacket
	/*a1*/	0x98,		//StartAllianceWar
	/*a2*/	0x99,		//ReplyStartAllianceWar
	/*a3*/	0x9a,		//StopAllianceWar
	/*a4*/	0x9b,		//ReplyStopAllianceWar
	/*a5*/	0x9c,		//SurrenderAllianceWar
	/*a6*/	0x9d,		//RequestSkillCoolTime
	/*a7*/	0x9e,		//RequestPackageSendableItemList
	/*a8*/	0x9f,		//RequestPackageSend
	/*a9*/	0xa0,		//RequestBlock
	/*aa*/	0xa1,		//RequestCastleSiegeInfo
	/*ab*/	0xa2,		//RequestCastleSiegeAttackerList
	/*ac*/	0xa3,		//RequestSiegeDefenderList
	/*ad*/	0xa4,		//RequestJoinCastleSiege
	/*ae*/	0xa5,		//RequestConfirmCastleSiegeWaitingList
	/*af*/	0xa6,		//RequestSetCastleSiegeTime
	/*b0*/	0xa7,		//RequestMultiSellChoose
	/*b1*/	0xa8,		//NetPing
	/*b2*/	0xa9,		//RemainTime
	/*b3*/	0xaa,		//RequestUserCommand
	/*b4*/	0xab,		//SnoopQuit
	/*b5*/	0xac,		//RequestRecipeBookOpen
	/*b6*/	0xad,		//equestRecipeBookDestroy
	/*b7*/	0xae,		//RequestRecipeItemMakeInfo
	/*b8*/	0xaf,		//RequestRecipeItemMakeSelf
	/*b9*/	0xb0,		//RequestRecipeShopManageList
	/*ba*/	0xb1,		//RequestRecipeShopMessageSet
	/*bb*/	0xb2,		//RequestRecipeShopListSet
	/*bc*/	0xb3,		//RequestRecipeShopManageQuit
	/*bd*/	0xb4,		//RequestRecipeShopCancel
	/*be*/	0xb5,		//RequestRecipeShopMakeInfo
	/*bf*/	0xb6,		//RequestRecipeShopMakeItem
	/*c0*/	0xb7,		//RequestRecipeShopManagePrev
	/*c1*/	0xb8,		//ObserverReturn
	/*c2*/	0xb9,		//RequestEvaluate
	/*c3*/	0xba,		//RequestHennaList
	/*c4*/	0xbb,		//RequestHennaItemInfo
	/*c5*/	0xc4,		//BuySeed
	/*c6*/	0xc5,		//ConfirmDialog
	/*c7*/	0xc6,		//RequestWearItem
	/*c8*/	0xc7,		//RequestSSQStatus
	/*c9*/	0xc8,		//PetitionVote
	/*ca FF*/	0xc9,		 //PledgeWarInfo	(gone)(gues)
	/*cb*/	0xca,		//ReplyGameGuardQuery
	/*cc*/	0xc0,		//RequestPledgePower (Clan Privileges)
	/*cd*/	0xc1,		//RequestMakeMacro
	/*ce*/	0xc2,		//RequestDeleteMacro
	/*cf*/	0xc3,		//RequestProcureCrop		
	/*d0*/	0xd0,		//UserEx
	};



//----------------------------
//CT3 Awakening SERVER Opcodes

//NOT CHANGED	
	static BYTE servToClientAwake[0x101] = 
	{
	/*0*/	0x00,//0x2E, // VersionCheck
	/*1*/	0x01,//0x2F, // MoveToLocation
	/*2*/	0x30, // NPC Say
	/*3*/	0x31, // CharInfo
	/*4*/	0x32, // User Info
	/*5*/	0x33, // Attack
	/*6*/	0x00, // Die
	/*7*/	0xEE, //use Hena packets for our needs  //0x01, // Revive
	/*8*/	0x02, // AttackOutOfRange
	/*9*/	0x03, // AttackInCoolTime
	/*a*/	0x04, // AttackDeadTarget
	/*b*/	0x05, // Spawn Item
	/*c*/	0x16, // Drop Item
	/*d*/	0x17, // Get Item
	/*e*/	0x18, // Status Update
	/*f*/	0x19, // NPC HTML Message
	/*10*/	0x06, // SellList
	/*11*/	0x07, // BuyList
	/*12*/	0x08, // DeleteObject
#ifdef	__KAMAEL_PACKETS_SEND__
	/*13*/	0xE5, //0x09, // CharacterSelectionInfo
#else
	/*13*/	0x09, // CharacterSelectionInfo
#endif
	/*14*/	0x0A, // LoginFail
	/*15*/	0x0b, // CharacterSelected
	/*16*/	0x0c, // NpcInfo  
	/*17*/	0x0d, // NewCharacterSucess 
	/*18*/	0x0e, // NewCharacterFail 
	/*19*/	0x0f, // CharacterCreatesuccess 
	/*1a*/	0x10, // CharacterCreateFail 
	/*1b*/	0x11, // ItemList
	/*1c*/	0x12, // SunRise
	/*1d*/	0x13, // SunSet 2d
	/*1e*/	0x14, // TradeStart
	/*1f*/	0x15, // TradeStartOk
	/*20*/	0x1a, // TradeOwnAdd
	/*21*/	0x1b, // TradeOtherAdd
	/*22*/	0x1c, // TradeDone
	/*23*/	0x1d, // CharacterDeletesuccess
	/*24*/	0x1e, // CharacterDeleteFail
	/*25*/	0x1f, // ActionFail
	/*26*/	0x20, // SeverClose
	/*27*/	0x21, // InventoryUpdate
	/*28*/	0x22, // TeleportToLocaton
	/*29*/	0x23, // TargetSelected
	/*2a*/	0x24, // TargetUnselecte
	/*2b*/	0x25, // AutoAttackStart
	/*2c*/	0x26, // AutoAttackStop
	/*2d*/	0x27, // SocialAction
	/*2e*/	0x28, // ChangeMoveType
	/*2f*/	0x29, // ChangeWaitType
	/*30*/	0x2a, // ManagePledgePower
	/*31*/	0x2b, // CreatePledge
	/*32*/	0x2c, // AskJoinPledge
	/*33*/	0x2d, // JoinPledge
	/*34*/	0x34, // WithdrawalPledge
	/*35*/	0x35, // OustPledgeMembe
	/*36*/	0x36, // SetOustPledgeMeber
	/*37*/	0x37, // DismissPledge
	/*38*/	0x38, // SetDismissPledge
	/*39*/	0x39, // AskJoinParty
	/*3a*/	0x3a, // JoinParty
	/*3b*/	0x3b, // WithdrawalParty
	/*3c*/	0x3c, // OustPartyMember
	/*3d*/	0x3d, // SetOustPartyMemer
	/*3e*/	0x3e, // DismissParty
	/*3f*/	0x3f, // SetDismissParty
	/*40*/	0x40, // MagicAndSkillList
	/*41*/	0x41, // WareHouseDeposiList
	/*42*/	0x42, // WareHouseWithdrwList
	/*43*/	0x43, // WareHouseDone
	/*44*/	0x44, // ShortCutRegister
	/*45*/	0x45, // ShortCutInit
	/*46*/	0x46, // ShortCutDelete
	/*47*/	0x47, // StopMove
	/*48*/	0x48, // MagicSkillUse
	/*49*/	0x49, // MagicSkillCanceed
	/*4a*/	0x4a, // Say2
	/*4b*/	0x4b, // EquipUpdate
	/*4c*/	0x4c, // DoorInfo
	/*4d*/	0x4d, // DoorStatusUpdate
	/*4e*/	0x4e, // PartySmallWindowAll
	/*4f*/	0x4f, // PartySmallWindowAdd
	/*50*/	0x50, // PartySmallWindowDeleteAll
	/*51*/	0x51, // PartySmallWindowDelete
	/*52*/	0x52, // PartySmallWindowUpdate
	/*53*/	0x5a, // PledgeShowMembeListAll
	/*54*/	0x5b, // PledgeShowMembeListUpdate
	/*55*/	0x5c, // PledgeShowMembeListAdd
	/*56*/	0x5d, // PledgeShowMembeListDelete
	/*57*/	0x5e, // MagicList
	/*58*/	0x5f, // SkillList
	/*59*/	0x60, // VehicleInfo
	/*5a*/	0x6c, // VehicleDeparture
	/*5b*/	0x6d, // VehicleCheckLoction
	/*5c*/	0x6e, // GetOnVehicle
	/*5d*/	0x6f, // GetOffVehicle
	/*5e*/	0x70, // TradeRequest
	/*5f*/	0x71, // RestartResponse
	/*60*/	0x72, // MoveToPawn
	/*61*/	0x79, // ValidateLocation
	/*62*/	0x7a, // StartRotating
	/*63*/	0x61, // FinishRotating
	/*64*/	0x62, // SystemMessage
	/*65*/	0x63, // StartPledgeWar
	/*66*/	0x64, // ReplyStartPledgWar
	/*67*/	0x65, // StopPledgeWar
	/*68*/	0x66, // ReplyStopPledgeWar
	/*69*/	0x67, // SurrenderPledgeWar
	/*6a*/	0x68, // ReplySurrenderPedgeWar
	/*6b*/	0x69, // SetPledgeCrest
	/*6c*/	0x6a, // PledgeCrest
	/*6d*/	0x6b, // SetupGauge
	/*6e*/	0x7b, // ShowBoard
	/*6f*/	0x7c, // ChooseInventoryItem
	/*70*/	0x7d, // Dummy
	/*71*/	0x7e, // MoveToLocationIVehicle
	/*72*/	0x7f, // StopMoveInVehice
	/*73*/	0x80, // ValidateLocatioInVehicle
	/*74*/	0x81, // TradeUpdate
	/*75*/	0x53, // TradePressOwnOk
	/*76*/	0x54, // MagicSkillLaunced
	/*77*/	0x55, // FriendAddRequesResult
	/*78*/	0x56, // FriendAdd
	/*79*/	0x57, // FriendRemove
	/*7a*/	0x58, // FriendList
	/*7b*/	0x59, // FriendStatus
	/*7c*/	0x82, // TradePressOtherOk
	/*7d*/	0x83, // FriendAddRequest
	/*7e*/	0x84, // LogOutOk
	/*7f*/	0x85, // AbnormalStatusUdate
	/*80*/	0x86, // QuestList
	/*81*/	0x87, // EnchantResult
	/*82*/	0x88, // PledgeShowMembeListDeleteAll
	/*83*/	0x89, // PledgeInfo
	/*84*/	0x8a, // PledgeExtendedInfo
	/*85*/	0x8b, // SurrenderPersonlly
	/*86*/	0x8c, // Ride
	/*87*/	0x8d, // unk
	/*88*/	0x8e, // PledgeShowInfoUdate
	/*89*/	0x8f, // ClientAction
	/*8a*/	0x90, // AcquireSkillList
	/*8b*/	0x91, // AcquireSkillInfo
	/*8c*/	0x92, // ServerObjectInfo
	/*8d*/	0x93, // GMHide
	/*8e*/	0x94, // AcquireSkillDone
	/*8f*/	0x95, // GMViewCharacterInfo
	/*90*/	0x96, // GMViewPledgeInfo
	/*91*/	0x97, // GMViewSkillInfo
	/*92*/	0x98, // GMViewMagicInfo
	/*93*/	0x99, // GMViewQuestInfo
	/*94*/	0x9a, // GMViewItemList
	/*95*/	0x9b, // GMViewWarehouseithdrawList
	/*96*/	0x9c, // ListPartyWating
	/*97*/	0x9d, // PartyRoomInfo
	/*98*/	0x9e, // PlaySound
	/*99*/	0x9f, // StaticObject
	/*9a*/	0xa0, // PrivateStoreMangeListSell
	/*9b*/	0xa1, // PrivateStoreList
	/*9c*/	0xa2, // PrivateStoreMsg
	/*9d*/	0xa3, // ShowMinimap
	/*9e*/	0xa4, // ReviveRequest
	/*9f*/	0xa5, // AbnormalVisualEfect
	/*a0*/	0xa6, // TutorialShowHtml
	/*a1*/	0xa7, // TutorialShowQuetionMark
	/*a2*/	0xa8, // TutorialEnableCientEvent
	/*a3*/	0xa9, // TutorialCloseHtml
	/*a4*/	0xaa, // ShowRadar
	/*a5*/	0xb8, // DeleteRadar
	/*a6*/	0xb9, // MyTargetSelected
	/*a7*/	0xba, // PartyMemberPosition
	/*a8*/	0xbb, // AskJoinAlliance
	/*a9*/	0xbc, // JoinAlliance
	/*aa*/	0xab, // WithdrawAlliance
	/*ab*/	0xac, // OustAllianceMemerPledge
	/*ac*/	0xad, // DismissAlliance
	/*ad*/	0xae, // SetAllianceCrest
	/*ae*/	0xaf, // AllianceCrest
	/*af*/	0xb0, // ServerCloseSocket
	/*b0*/	0xb1, // PetStatusShow
	/*b1*/	0xb2, // PetInfo
	/*b2*/	0xb3, // PetItemList
	/*b3*/	0xb4, // PetInventoryUpdate
	/*b4*/	0xb5, // AllianceInfo
	/*b5*/	0xb6, // PetStatusUpdate
	/*b6*/	0xb7, // PetDelete
	/*b7*/	0xbd, // PrivateStoreBuyManageList
	/*b8*/	0xbe, // PrivateStoreBuyList
	/*b9*/	0xbf, // PrivateStoreBuyMsg
	/*ba*/	0xc0, // VehicleStart
	/*bb*/	0xc1, // RequestTimeCheck
	/*bc*/	0xc2, // StartAllianceWar
	/*bd*/	0xc3, // ReplyStartAlliaceWar
	/*be*/	0xc4, // StopAllianceWar
	/*bf*/	0xc5, // ReplyStopAllianeWar
	/*c0*/	0xc6, // SurrenderAllianeWar
	/*c1*/	0xc7, // SkillCoolTime
	/*c2*/	0xc8, // PackageToList
	/*c3*/	0xd2, // PackageSendableList
	/*c4*/	0xd3, // EarthQuake
	/*c5*/	0xd4, // FlyToLoaction
	/*c6*/	0xd5, // BlockList
	/*c7*/	0xd6, // SpecialCamera
	/*c8*/	0xd7, // NormalCamera
	/*c9*/	0xc9, // CastleSiegeInfo
	/*ca*/	0xca, // CastleSiegeAttakerList
	/*cb*/	0xcb, // CastleSiegeDefederList
	/*cc*/	0xcc, // NickNameChanged
	/*cd*/	0xcd, // PledgeStatusChaged
	/*ce*/	0xce, // RelationChanged
	/*cf*/	0xcf, // EventTrigger
	/*d0*/	0xd0, // MultiSellList
	/*d1*/	0xd1, // SetSummonRemainTime
	/*d2*/	0xd8, // SkillRemainSec
	/*d3*/	0xd9, // NetPing
	/*d4*/	0xda, // Dice
	/*d5*/	0xdb, // Snoop
	/*d6*/	0xdc, // RecipeBookItemList
	/*d7*/	0xdd, // RecipeItemMakeInfo
	/*d8*/	0xde, // RecipeShopManagList
	/*d9*/	0xdf, // RecipeShopSellList
	/*da*/	0xe0, // RecipeShopItemInfo
	/*db*/	0xe1, // RecipeShopMsg
	/*dc*/	0xe2, // ShowCalc
	/*dd*/	0xe3, // MonRaceInfo
	/*de*/	0xea, // ShowTownMap
	/*df*/	0xeb, // ObserverStart
	/*e0*/	0xec, // ObserverEnd
	/*e1*/	0xed, // ChairSit
	/*e2*/	0xee, // HennaEquipList
	/*e3*/	0xe4, // HennaItemInfo
	/*e4*/	0xe5, // HennaInfo
	/*e5*/	0xe6, // HennaUnequipList
	/*e6*/	0xe7, // HennaUnequipInfo
	/*e7*/	0xe8, // MacroList
	/*e8*/	0xe9, // BuyListSeed
	/*e9*/	0xef, // SellListProcure
	/*ea*/	0xf0, // GMHennaInfo
	/*eb*/	0xf1, // RadarControl
	/*ec*/	0xf2, // ClientSetTime
	/*ed*/	0xf3, // ConfirmDlg
	/*ee*/	0xf4, // PartySpelled
	/*ef*/	0xf5, // ShopPreviewList
	/*f0*/	0xf6, // ShopPreviewInfo
	/*f1*/	0xf7, // CameraMode
	/*f2*/	0xf8, // ShowXMasSeal
	/*f3*/	0xf9, // EtcStatusUpdate
	/*f4*/	0xfa, // ShortBuffStatusUpdate
	/*f5*/	0xfb, // SSQStatus
	/*f6*/	0xfc, // PetitionVote
	/*f7*/	0xfd, // AgitDecoInfo
	/*f8*/	0x73, // SSQInfo
	/*f9*/	0x74, // GameGuardQuery
	/*fa*/	0x75, // L2FriendList
	/*fb*/	0x76, // L2Friend
	/*fc*/	0x77, // L2FriendStatus
	/*fd*/	0x78, // L2FriendSay
	/*fe*/	0xFE,  // UserEx
	/*ff*/	0xFF,  // ???
	0
	};


static BYTE CT3OpcodePatch[0xEF]=
{
0x00,0x01,0x30,0x31,0x32,0xF6,0x33,0x33,0xFF,0xFF,0xFF,0x00,0xEE,0x02,0x03,
0x04,0xFF,0xFF,0xFF,0xF6,0xF6,0x05,0x16,0x17,0xFF,0xFF,0x18,0x19,0x06,0x07,0x08,
/*0x09*/0xE5,0x0A,0x0B,0x0c,0x0d,0x0E,0x0F,0x10,0x11,0x12,0x13,0xF6,0xF6,0xF6,0xF6,0x14,
0xF6,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,0x20,0x21,0x28,0x23,0x24,0x25,0x26,0x27,0x28,
0x29,0xF6,0xF6,0xF6,0x2B,0x2C,0x2D,0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,
0x3D,0x3E,0x3F,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0xF6,0x4A,0x4B,
0xFF,0x4C,0x4D,0xF6,0x4E,0x4F,0x50,0x51,0x52,0x5A,0x5B,0x5C,0x5D,0xF6,0x5F,0x60,
0x6C,0x6D,0x6E,0x6F,0x70,0x71,0x72,0x79,0x7A,0x61,0xFF,0x62,0xF6,0xF6,0x63,0x64,
0x65,0x66,0x67,0x68,0xF6,0x6A,0x6B,0x7B,0x7C,0xF6,0x7E,0x7F,0x80,0x81,0xF6,0x54,
0x55,0xF6,0xF6,0xF6,0xF6,0xF6,0x83,0x84,0x85,0x86,0x87,0xF6,0x88,0x89,0x8A,0x8B,
0x8C,0xF6,0x8E,0x8F,0x90,0x91,0x92,0x93,0x94,/*0x95*/0xE4,0x96,0x97,0x98,0x99,0x9A,0x9B,
0x9C,0x9D,0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xB8,
0xB9,0xBA,0xBB,0xBC,0xAB,0xAC,0xAD,0xF6,0xAF,0xF6,0xB1,0xB2,0xB3,0xB4,0xF6,0xB6,
0xB7,0xBD,0xBE,0xBF,0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xD2,0xD3,0xD4,
0xD5,0xD6,0xD7,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0xD0,0xD1,0xD8,0xD9,0x00
};

